PROGRAM vmria;

USES Forms,    Graphics, Dialogs,  Controls, SysUtils,
     vzlocom,  vmria0,   varfun,   vspectr,  vpmodel, vgfit,   vmriasp,
     vmriafl,  vmriasgm, vmriahkl, vmriauto, vtest,   vpeaksr, vmriarit,
     vmriarix,
  vmria1   in 'vmria1.pas'   {Form1},
  vmria3   in 'vmria3.pas'   {Form2},
  vmriahlp in 'vmriahlp.pas' {Form3},
  vmria4   in 'vmria4.pas'   {Form4};
{$R *.RES}
PROCEDURE InitializeForms;
BEGIN WITH Form1 DO
 BEGIN GetDir(0,vmdir); s:=vmdir+'\vmria.fn'; inifn:=vmdir; evfn:=vmdir;
 Left:=0; Top:=0; Width:=630; Height:=470;
 Caption:='  VISUAL MRIA +++ 2003,    by Zlokazov V.B.     DIR= '+vmdir;
 WITH Image1 DO
  BEGIN Left:=0; Top:=0; Width:=wgraph; Height:=y1graph-1;
  END;
 WITH Image2 DO
  BEGIN Left:=0; Top:=y1graph{100}; Width:=wgraph-104; Height:=323;
  END;
 WITH Image3 DO
  BEGIN Left:=516; Top:=y1graph{100}; Width:=104; Height:=323;
  END;
 END;
WITH Form2 DO
 BEGIN WITH Image1 DO
  BEGIN Left:=0; Top:=1; Width:=310; Height:=290;
  END;
 WITH Image2 DO
  BEGIN Left:=0; Top:=80; Width:=516; Height:=300;
  END;
 END;
WITH Form4 DO
 BEGIN Left:=420; Top:=55; Width:=200; Height:=90;
 END;
END;
PROCEDURE Inipr;
VAR   i,j,k:INTEGER; ss:STRING;
BEGIN mriamode:=0; ModalRes:=1; dsfn:=vmdir;
i:=Length(vmdir); ss:=vmdir; IF(ss[i]<>'\')THEN ss:=ss+'\';
s:=FormatDateTime('dd',Date)+FormatDateTime('hhnn',Time);
outfn:=ss+'m'+s+'.res';
Form2.OpenDialog1.Title:='   Select the file';
L0rec:='Enter file name';
MakeFormV(0,20,630,430,0); SaveHelp(blankH_n,blankH);
OuttoLabel(Form2.Label1,15,40,clMaroon,clWhite,'Output file:  '+outfn);
s:='Remark: the analysis results are saved in an output file';
OuttoLabel(Form2.Label4,15,70,clBlue,clWhite,s);
s:='               Standard output file name = m+date+time+.res';
OuttoLabel(Form2.Label3,15,86,clBlue,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=3;
 ar[1]:='Change the file name';
 ar[2]:='Abort';
 ar[3]:='Go on';
 END;
MakeRadioGroup(1,0,200,135,260,120);
WITH CB1rec DO
 BEGIN nitems:=3;
 ar[1]:=' Put comments to the output file ';
 ar[2]:=' Set the screen to 1024 x 800 ';
 ar[3]:=' Use the small font ';
 END;
MakeCheckListBox(190,280,280,57);
FOR i:=1 TO 3 DO Form2.CheckListBox2.Checked[i-1]:=false;
WITH Form2 DO
 BEGIN ShowModal; i:=RadioGroup1.ItemIndex;
 IF((ModalRes=0)OR(i=1))THEN Application.Terminate;
 IF(i=0)THEN
  BEGIN GetFilename(outfn,1); IF(ModalRes=0)THEN Application.Terminate;
  END;
 END;
AssignFile(fout,outfn); {$I-} ReWrite(fout); {$I+};
ok:=(IOresult=0); IF NOT ok THEN
 BEGIN s:='Output file failure: possibly shared or read only';
 ShowMess(s); Exit;
 END;
IF(Form2.CheckListBox2.Checked[0])THEN
 BEGIN L0rec:=' Enter the comments '; MakeFormV(0,20,620,430,0);
 SaveHelp(blankH_n,blankH); MakeMemo(5,590);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes<>0)THEN WITH Memo1.Lines DO
   FOR i:=1 TO Count DO Writeln(fout,Strings[i-1]);
  END;
 END;
s:=ss+'vmria.fn'; IF(FileExists(s))THEN
  BEGIN AssignFile(ft,s); {$I-} Reset(ft); {$I+};
  EnterStr(ft); inifn:=sedz; CloseFile(ft);
  END;
FOR i:=0 TO 4 DO spec[i]:=TSpectrum.Create(vmdir);
FOR i:=0 TO 4 DO pmod[i]:=TPeakModel.Create;
gfit:=TParameter.Create(npmax,nmmax,upintx);  WITH gfit DO
 BEGIN mpoint:=0; FormCB; cb.eps:=0.1; cb.step:=0.99; cb.damp:=0.01;
 npar:=npmax; FormParameters; npar:=0; nfr:=0; cw:=cb; {cb}
 END;
FOR i:=1 TO 4 DO WITH lat[i] DO  {lattice}
 BEGIN WITH lpd DO
  BEGIN a:=5.154; b:=5.22; c:=5.32; alpha:=90; beta:=99.2; gamma:=90;
  END;
 InverseLatPar(lpd,lpi,voli,0); nat:=1; lpd0:=lpd;
 syng:=1; nlatt:=0; nsg:=1; sett:=1; csym:=0;
 lerrc:=5; aerrc:=10; coW:=1; Wl0:=5; Wl1:=0; SetSpaceGroupInfo(i);
 FOR j:=1 TO 48 DO
  BEGIN FOR k:=1 TO 9 DO mut[k,j]:=0;
  FOR k:=1 TO 3 DO mut[(k-1)*3+k,j]:=1;
  END;
 FOR j:=1 TO 100 DO WITH atoms[j,i] DO  {atoms}
  BEGIN name:=' ';  occ:=1; x:=0; y:=0; z:=0;
  t11:=0; t12:=0; t13:=0; t22:=0; t23:=0; t33:=0;
  Ab:=0; al:=0; Bb:=0; bl:=0; Cb:=0; cl:=0; Db:=0;
  END;
 END;
FOR i:=1 TO 4 DO FOR j:=1 TO 1001 DO WITH hkla[j,i] DO {hkl}
 BEGIN Fkc:=0; Fks:=0; dk:=0; h:=0; k:=0; l:=0; mul:=0; txtc:=1;
 END;
imod1:=0; imod2:=0;
FSFthresh:=0.5; nophasi:=true; FOR i:=1 TO 4 DO
 BEGIN noatoms[i]:=true; nohkls[i]:=true;
 END;
SetNoPrep(15,true); SetNoFit(15,true); resfOK:=false;
{nresf:=33; FOR i:=1 TO nresf DO respf[i]:=pmod[1].morr[i*6-5];}
auclass:=false; FOR i:=1 TO 4 DO
 BEGIN hmax[i]:=4; hmin[i]:=-4; kmax[i]:=4; kmin[i]:=-4; lmax[i]:=4;
 vmax[i]:=5000; vmin[i]:=0;
 END;
parfn:=vmdir; savfn:=vmdir;
FormDN2effSp; SaveHelp(NyetI_n,NyetI); Form1.N1.Enabled:=false;
ic1:=spec[1].a11; ic2:=spec[1].a22; cadl:=ic2-ic1+1;
numsp:=1; indi:=' x    ';
Form1.Items1.CopyToClipBoard;
END;
{********}
BEGIN Application.Initialize;
Application.CreateForm(TForm1, Form1);
Application.CreateForm(TForm2, Form2);
Application.CreateForm(TForm3, Form3);
Application.CreateForm(TForm4, Form4);
InitializeForms;
Inipr; IF(ModalRes=0)THEN Exit;
{WM_GETMINMAXINFO
 lpmmi (LPMINMAXINFO) lParam;}
{VAR Info: TWMGetMinMaxInfo;
Form1.WMGetMinMaxInfo(VAR Info: TWMGetMinMaxInfo);}
HideComponents;
Application.Run;
END.

      (ionn:''; ffaca:(,,,,,,
      ,);),
      (ionn:''; ffaca:(,,,,,,
      ,);),
      (ionn:''; ffaca:(,,,,,,
      ,);),
      (ionn:''; ffaca:(,,,,,,
      ,);)
