unit vsaveform;

interface
uses
  Controls;

procedure SaveForm(Obj: TWinControl; Filename: string);

implementation
uses
  Windows, Classes, Graphics;

procedure SaveForm(Obj: TWinControl; Filename: string);
var
  tempCanvas: TCanvas;
  sourceRect, destRect: TRect;
  tempBitmap: TBitmap;
begin
  tempCanvas:=TCanvas.Create;
  tempBitmap:=TBitmap.create;
  try
    tempCanvas.Handle := GetWindowDC(Obj.handle);
    with tempBitmap do begin
      Height:=Obj.Height;
      Width:=Obj.Width;
      destRect:=Rect(0,0,Width,Height);
      sourceRect:=destRect;
      Canvas.CopyRect(destRect,tempCanvas,sourceRect);
    end;
    tempBitmap.SaveToFile(Filename);
  finally
    tempBitmap.Free;
    tempCanvas.Free;
  end;
end;

end.
