UNIT vedz3;
{  main     top_1  top_2 top_3 top_4

     stack1 stack2 stack3 stack4 stack5 stack6 stack7
       *      *      *      *      *      *      *      face-down suit
       u      u      u      u      u      u      u      face-up suit
}
INTERFACE
USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, Menus,    vzlocom, varfun,   ExtCtrls, vedz0,
      vstdcons;

TYPE
  TForm3 = CLASS(TForm)
    {Main -> Stack} Button1: TButton;
    {Automatic}     Button2: TButton;
    {Return}        Button3: TButton;
    {Main off}      Button4: TButton;
    {Scroll Main}   Button5: TButton;
    {Stack -> Main} Button6: TButton;
    {ReOrder}       Button7: TButton;
    {Stack to Top}  Button8: TButton;
    {Menue}         Button9: TButton;
    {Screen back}   Button10: TButton;
    {Screen ahead}  Button11: TButton;
    Image1: TImage;
    Image2: TImage;
    PROCEDURE Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
    PROCEDURE Button3Click(Sender: TObject);
    PROCEDURE Button4Click(Sender: TObject);
    PROCEDURE Button5Click(Sender: TObject);
    PROCEDURE Button6Click(Sender: TObject);
    PROCEDURE Button7Click(Sender: TObject);
    PROCEDURE Button8Click(Sender: TObject);
    PROCEDURE Button9Click(Sender: TObject);
    PROCEDURE Button10Click(Sender: TObject);
    PROCEDURE Button11Click(Sender: TObject);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;

CONST nc0:INTEGER = 6;
TYPE CARD  = RECORD m,c:INTEGER;
             END;
     STACK = RECORD ca:ARRAY[1..22] OF CARD; n1,n2,ip:BYTE;
             END; {n1= number of face-down cards in the suit}
                  {n2= number of face-up cards in the suit}
     STR2  = STRING[2];
TYPE TScrStates =
      RECORD st:STACK;
             smain:ARRAY[1..57] OF CARD;
             snm:INTEGER;
             sncar:INTEGER;
             spil:ARRAY[1..7] OF STACK;
             snpil:ARRAY[1..7] OF INTEGER;
             stops:ARRAY[1..4] OF STACK;
             shiar,sclar:ARRAY[1..14] OF INTEGER;
             shimax,sclmax:INTEGER;
             snhimax,snclmax:INTEGER;
             sparr:ARRAY[1..7] OF INTEGER;
             sNofRet:INTEGER;
             sNoDispl:BOOLEAN;
             sNoReOrd:INTEGER;
      END;

FUNCTION pn(i:INTEGER):INTEGER; {Number of last card in the row stack}
FUNCTION pcm(i:INTEGER):INTEGER; {Value of the card in the row stack}
FUNCTION pcc(i:INTEGER):INTEGER; {Color of the card in the row stack}
FUNCTION tn(i:INTEGER):INTEGER;
FUNCTION tcm(i:INTEGER):INTEGER;
FUNCTION tcc(i:INTEGER):INTEGER;
FUNCTION difcol(i,j:INTEGER):BOOLEAN;
FUNCTION NofEqualCards:INTEGER;  { MaxNumber of equal hidden cards}
PROCEDURE CountMisorders;
PROCEDURE TurnLastStack;
PROCEDURE CheckCoinc(i1:INTEGER);
PROCEDURE SwapCard(i,loc:INTEGER);
PROCEDURE ProvideOne11213(nn,loc:INTEGER);
PROCEDURE GetHidden;
PROCEDURE GetClosed;
PROCEDURE DeleteUpCard(j:INTEGER);
PROCEDURE TryDeleteUpCard;
PROCEDURE Initial(start:BOOLEAN; nc:INTEGER);
PROCEDURE CheckDone(VAR k:INTEGER);
FUNCTION itos(i:INTEGER):STR2;
PROCEDURE SetCol(c:INTEGER; VAR cl:LONGINT);
PROCEDURE SwapCards(i1,i2:INTEGER);
FUNCTION TurnXtoI(x:INTEGER):INTEGER;
FUNCTION TurnTXtoI(x:INTEGER):INTEGER;
FUNCTION TurnMXtoI(x:INTEGER):INTEGER;
PROCEDURE HideCompo(vis:BOOLEAN);
PROCEDURE BlockCommands(bl:BOOLEAN);
PROCEDURE PrintClick(s:STRING; sc:STRING);
PROCEDURE Printer;
PROCEDURE NextMainItem;
PROCEDURE MainToStack(i1,mo:INTEGER);
PROCEDURE TopToStack(i1:INTEGER);
PROCEDURE ExchangeItems(i:INTEGER);
PROCEDURE LoadScr(ncad:INTEGER);
PROCEDURE SaveScr(ncad:INTEGER);
PROCEDURE Patience(i:INTEGER; VAR acmenu:BOOLEAN);
VAR
  Form3: TForm3;
VAR
  deck:ARRAY[1..57] OF CARD;   {total deck}
  ncar:INTEGER;                {number of cards in the deck}
  main:ARRAY[1..57] OF CARD;   {deck without stacks}
  pil:ARRAY[1..7] OF STACK;    {row stacks}
  npil:ARRAY[1..7] OF INTEGER; {number of cards in each of them}
  nst:INTEGER;                 {number of cards in the row stacks}
  tops:ARRAY[1..4] OF STACK;   {main top stacks}
  gmaxold:INTEGER;             {old number of coinciding card}
  hiar,clar:ARRAY[1..14] OF INTEGER; {number of hidden (in row stack)
                                      and closed (by antecedents) cards}
  himax,clmax:INTEGER;         {maximum numbers of hidden and closed}
  nhimax,nclmax:INTEGER;       {number of hid-max and clos-max}
  c,modep,scor,n,l1,l2,k1,k2,i1,i2,i,j,k,mx:INTEGER;
  kk0,kk1,kk2,kk3:CARD;        {work cards}
  parr:ARRAY[1..7] OF INTEGER; {pointers to highest card in piles}
  ch,ch1:CHAR;
  x0:INTEGER;                  {initial graph x-shift}
  sdr:INTEGER;                 {distance between stacks}
  s:STRING[72];
  nmiso:INTEGER;            {number of misorders}
  nm0,nm:INTEGER;           {total number of cards in mains}
  i413:BOOLEAN;             {all the 4 13s are at the pile tops?}
  NofRet:INTEGER;           {Now many times a card returned to deck?}
  NoDispl:BOOLEAN;          {Are stack cards face-up?}
  NoReOrd:INTEGER;          {Number of allowed stack rearrangements?}
  ok:BOOLEAN;
  inl:ARRAY[1..14] OF INTEGER;
  sk:STRING[2];
  grs:INTEGER;              {Reaction on mouse mode 0=main to stack
                                                    1=dialog}
  started:BOOLEAN;
  ncl:INTEGER;              {Number of right mouse button clicking}
  im1,im2:INTEGER;          {item numbers while moving}
  icoor,jcoor,xcoor,ycoor:INTEGER;
  memar:ARRAY[1..200] OF TScrStates;
  ncad,ncadx:INTEGER;             {number of current screen, max}

IMPLEMENTATION
{$R *.DFM}
PROCEDURE TForm3.Button10Click(Sender: TObject); {back}
BEGIN ncad:=MAX0(ncad-2,1); LoadScr(ncad); Printer;
END;
PROCEDURE TForm3.Button11Click(Sender: TObject); {ahead}
BEGIN IF(ncad>ncadx)THEN Exit; LoadScr(ncad); Printer;
END;
PROCEDURE LoadScr(ncad:INTEGER);
VAR i,j,k:INTEGER;
BEGIN WITH memar[ncad] DO
 BEGIN FOR i:=1 TO 7 DO pil[i]:=spil[i];
 FOR i:=1 TO 7 DO npil[i]:=snpil[i];
 FOR i:=1 TO 7 DO parr[i]:=sparr[i];
 FOR i:=1 TO 57 DO main[i]:=smain[i];
 FOR i:=1 TO 4 DO tops[i]:=stops[i];
 ncar:=sncar;
 nm:=snm;
 FOR i:=1 TO 14 DO hiar[i]:=shiar[i];
 FOR i:=1 TO 14 DO clar[i]:=sclar[i];
 himax:=shimax;
 clmax:=sclmax;
 nhimax:=snhimax;
 nclmax:=snclmax;
 NofRet:=sNofRet;
 NoDispl:=sNoDispl;
 NoReOrd:=sNoReOrd;
 END;
END;
PROCEDURE SaveScr(ncad:INTEGER);
VAR i,j,k:INTEGER;
BEGIN j:=ncad; IF(ncad>200)THEN
 BEGIN j:=200; FOR i:=2 TO j DO memar[i-1]:=memar[i];
 END;
WITH memar[j] DO
 BEGIN FOR i:=1 TO 7 DO spil[i]:=pil[i];
 FOR i:=1 TO 7 DO snpil[i]:=npil[i];
 FOR i:=1 TO 7 DO sparr[i]:=parr[i];
 FOR i:=1 TO 57 DO smain[i]:=main[i];
 snm:=nm;
 FOR i:=1 TO 4 DO stops[i]:=tops[i];
 sncar:=ncar;
 FOR i:=1 TO 14 DO shiar[i]:=hiar[i];
 FOR i:=1 TO 14 DO sclar[i]:=clar[i];
 shimax:=himax;
 sclmax:=clmax;
 snhimax:=nhimax;
 snclmax:=nclmax;
 sNofRet:=NofRet;
 sNoDispl:=NoDispl;
 sNoReOrd:=NoReOrd;
 END;
END;
PROCEDURE Printer;
VAR ii,c,x,y,i,j,k,n,ymax:INTEGER; cl:LONGINT;
BEGIN ymax:=0; GetHidden; GetClosed; Form3.Button1.Enabled:=false;
WITH Form3.Image1 DO
 BEGIN Left:=0; Top:=0; Width:=exs(610); Height:=exs(430);
 Visible:=true;
 END;
WITH Form3.Image1.Canvas DO
 BEGIN Brush.Color:=clBlack; Font.Color:=clTeal; Font.Size:=14;
 FillRect(Rect(0,0,exs(610),exs(430)));
 END;
WITH Form3.Button3 DO
 IF(NofRet=0)THEN Enabled:=false ELSE Enabled:=true;
WITH Form3.Button7 DO
 IF(NoReOrd=0)THEN Enabled:=false ELSE Enabled:=true;
{Display stacks}
FOR i:=1 TO 7 DO WITH pil[i] DO
  BEGIN x:=((i-1)*sdr+6+x0)*8; y:=3*18+5;
  Form3.Image1.Canvas.TextOut(x,y,'  *');
  END;
FOR i:=1 TO 7 DO WITH pil[i] DO
 BEGIN n:=n1+n2; ymax:=Max0(ymax,n); FOR j:=1 TO n DO
  BEGIN x:=((i-1)*sdr+6+x0)*8; y:=(j+3)*18;
  c:=ca[j].c; k:=ca[j].m; SetCol(c,cl);
  IF(j<=n1)THEN
   BEGIN IF(NoDispl)THEN WITH Form3.Image1.Canvas DO
    BEGIN Brush.Color:=clBlack; Font.Color:=clGray;
    TextOut(x,y,'**');
    END             ELSE WITH Form3.Image1.Canvas DO
    BEGIN Brush.Color:=clGray; Font.Color:=cl;
    TextOut(x,y,itos(k));
    END;
   END     ELSE WITH Form3.Image1.Canvas DO
   BEGIN Brush.Color:=clBlack; Font.Color:=cl; TextOut(x,y,itos(k));
   END;
  END;
 END;
{Display tops }
ii:=(24+x0); y:=2*18; WITH Form3.Image1.Canvas DO
 BEGIN Brush.Color:=clYellow; Font.Color:=clRed;
 TextOut((13+x0)*8,y,'  Tops:  ');
 Brush.Color:=clBlack; FOR i:=1 TO 4 DO WITH tops[i] DO
 IF(n1<>0)THEN
  BEGIN x:=((i-1)*8+ii)*8; c:=ca[n1].c;
  k:=ca[n1].m; SetCol(c,cl); Font.Color:=cl; TextOut(x,y,itos(k));
  END;
{Display mains}
 x:=8; y:=2*18;
 Brush.Color:=clBlack; y:=14; FOR i:=1 TO nm DO
  BEGIN j:=main[i].c; SetCol(j,cl); Font.Color:=cl;
  x:=(3*i-1)*8; TextOut(x,y,itos(main[i].m));
  END;
{Display Done }
 CheckDone(k); IF(k=0)THEN
  BEGIN x:=65*8; y:=10; Brush.Color:=clBlue; Font.Color:=clYellow;
  TextOut(x,y,'   DONE !  ');
  END;
 {Display indications}
 IF(NofRet>0)THEN
  BEGIN Brush.Color:=clRed; Font.Color:=clWhite; x:=(67+8)*8; y:=2*18;
  TextOut(x-40,y,'  N of Returns =  '+IntToStr(NofRet)+' ');
  END;
 IF(NoReOrd<>0)THEN
  BEGIN Brush.Color:=clRed; Font.Color:=clWhite; x:=(67+8)*8; y:=3*18+3;
  TextOut(x-40,y,'  Permutations =  '+IntToStr(NoReOrd)+' ');
  END;
 IF(clmax=4)THEN
  BEGIN Brush.Color:=clRed; Font.Color:=clWhite; x:=(10+8)*8; y:=23*18;
  TextOut(x,y,'  Warning; 4 blocked items  ');
  END;

 Brush.Color:=clGray; Font.Color:=clLime;
 x:=(67+8)*8; y:=5*18; TextOut(x-40,y,' Item  Closed Blocked');
 j:=0; FOR i:=1 TO 13 DO j:=j+hiar[i];
 IF(j<>0)THEN FOR i:=1 TO 13 DO
  BEGIN x:=(68+8)*8; y:=(i+6)*18-6; k:=hiar[i];
  Font.Color:=clWhite; IF(k=0)THEN Font.Color:=clBlack;
  Brush.Color:=clBlack; IF(k=himax)THEN Brush.Color:=clBlue;
  IF(k=4)THEN Brush.Color:=clRed;
  TextOut(x-40,y,itos(i)+'   =   '+itos(k));
  Brush.Color:=clBlack;
  IF((clar[i]>=(himax-1))AND(clmax<>0))THEN Brush.Color:=clFuchsia;
  TextOut(x+(9+8)*8-40,y,itos(clar[i]));
  END;
 {Check for right number of items}
 j:=0; FOR i:=1 TO 7 DO WITH pil[i] DO
  BEGIN j:=j+n1+n2;
  END;
 j:=j+nm-4; FOR i:=1 TO 4 DO WITH tops[i] DO j:=j+n1;
 Brush.Color:=clBlue; Font.Color:=clWhite;
 IF(j<>52)THEN
  BEGIN x:=8; y:=23*18; TextOut(x,y,'Error, nm <> 52');
  END;
 x:=600; y:=365; TextOut(x,y,' Scr= '+IntToStr(ncad)+' ');
 Form3.Show;
 END;
SaveScr(ncad); ncadx:=MAX0(ncadx,ncad); Inc(ncad);
END;
PROCEDURE Patience(i:INTEGER; VAR acmenu:BOOLEAN);
BEGIN acmenu:=false; nc:=i+3; WITH Form3 DO
 BEGIN scrsize:=1.25; Caption:='Session '+IntToStr(nc);
 Left:=0; Top:=0; Width:=exs(610); Height:=exs(430);
 Color:=clBtnFace; Font.Size:=fntsize;
 END;
x0:=0; kk0.m:=14; kk0.c:=0; ncad:=1; Randomize; sdr:=10;
FOR i:=1 TO Random(5000) DO j:=iRandom(10);
ncar:=3; modep:=0;  started:=false; ncl:=1;
grs:=0;
Initial(true,nc); i413:=false; NoDispl:=false; CountMisorders;
Form3.Canvas.Font.Size:=12; Form3.Canvas.Font.Style:=[fsBold];
Form3.Canvas.Font.Style:=[fsBold]; started:=true; HideCompo(true);
WITH Form3 DO
 BEGIN Left:=0; Top:=0; WITH Image2 DO
  BEGIN Left:=552; Top:=392; Width:=202; Height:=99; Color:=clTeal;
  WITH Canvas DO
   BEGIN Brush.Color:=clTeal; FillRect(Rect(0,0,202,99));
   END;
  END;
 WITH Button7 DO
  BEGIN Left:=725-40; Width:=70; Top:=5; Caption:='ReOrder';
  END;
 WITH Button3 DO
  BEGIN Left:=655-40; Width:=70; Top:=5; Caption:='Return';
  END;
 {***}
 WITH Button8 DO
  BEGIN Left:=687; Width:=61; Top:=400; Caption:='St->Top';
  END;
 WITH Button4 DO
  BEGIN Left:=622; Width:=61; Top:=400; Caption:='Main off';
  END;
 WITH Button5 DO
  BEGIN Left:=557; Width:=61; Top:=400; Caption:='Scroll M';
  END;

 WITH Button6 DO
  BEGIN Left:=687; Width:=61; Top:=430; Caption:='St->M';
  END;
 WITH Button1 DO
  BEGIN Left:=622; Width:=61; Top:=430; Caption:='Make St';
  END;
 WITH Button11 DO
  BEGIN Left:=557; Width:=61; Top:=430; Caption:='ScrForw';
  END;

 WITH Button2 DO
  BEGIN Left:=687; Width:=61; Top:=460; Caption:='Auto';
  END;
 WITH Button9 DO
  BEGIN Left:=622; Width:=61; Top:=460; Caption:='Menu';
  END;
 WITH Button10 DO
  BEGIN Left:=557; Width:=61; Top:=460; Caption:='Scr-back';
  END;

 END;
Printer;
END;
FUNCTION NofEqualCards:INTEGER;  { MaxNumber of equal hidden cards}
VAR n1,n2,n,ll,j0,i,j,k,ii,jj,lmax,gmax:INTEGER;
BEGIN gmax:=0; FOR i:=1 TO 7 DO WITH pil[i] DO
 BEGIN FOR j:=1 TO 13 DO inl[j]:=0; FOR j:=1 TO n1 DO
  BEGIN k:=ca[j].m; Inc(inl[k]);
  END;
 lmax:=0; FOR j:=1 TO 13 DO lmax:=MAX0(lmax,inl[j]);
 gmax:=MAX0(gmax,lmax);
 END;
NofEqualCards:=gmax;
END;
PROCEDURE CountMisorders;
VAR i,j,k:INTEGER;
BEGIN nmiso:=0; FOR i:=1 TO 7 DO WITH pil[i] DO
 IF(n1>0)THEN FOR k:=1 TO n1 DO IF(ca[k].m>ca[k+1].m)THEN Inc(nmiso);
END;
PROCEDURE TurnLastStack;
VAR i,j,k:INTEGER;
BEGIN FOR i:=1 TO 7 DO WITH pil[i] DO IF((n2=0)AND(n1<>0))THEN
  BEGIN Dec(n1); Inc(n2); CountMisorders;
  END;
END;
PROCEDURE CheckCoinc(i1:INTEGER);
{To check whether too many cards coincide}
BEGIN
END;
PROCEDURE SwapCard(i,loc:INTEGER);
BEGIN kk1:=deck[i]; deck[i]:=deck[loc]; deck[loc]:=kk1;
END;
PROCEDURE ProvideOne11213(nn,loc:INTEGER);
VAR   i,j,k:INTEGER;
LABEL Lend;
BEGIN FOR i:=53-nc TO 52 DO IF(deck[i].m=nn)THEN
 BEGIN IF(i<>loc)THEN SwapCard(i,loc); GOTO Lend;
 END;
FOR i:=1 TO 49 DO IF(deck[i].m=nn)THEN
 BEGIN SwapCard(i,loc); GOTO Lend;
 END;
Lend:;
END;

FUNCTION pn(i:INTEGER):INTEGER; {Number of last card in the row stack}
BEGIN pn:=pil[i].n1+pil[i].n2;
END;
FUNCTION pcm(i:INTEGER):INTEGER; {Value of the card in the row stack}
BEGIN pcm:=pil[i].ca[pn(i)].m;
END;
FUNCTION pcc(i:INTEGER):INTEGER; {Color of the card in the row stack}
BEGIN pcc:=pil[i].ca[pn(i)].c;
END;
FUNCTION tn(i:INTEGER):INTEGER;
BEGIN tn:=tops[i].n1;
END;
FUNCTION tcm(i:INTEGER):INTEGER;
BEGIN tcm:=tops[i].ca[tn(i)].m;
END;
FUNCTION tcc(i:INTEGER):INTEGER;
BEGIN tcc:=tops[i].ca[tn(i)].c;
END;
FUNCTION difcol(i,j:INTEGER):BOOLEAN;
BEGIN difcol:=false;
CASE modep OF
0: IF(i<>j)THEN difcol:=true;
1: IF(((i IN [1,2])AND(j IN [3,4]))OR
      ((j IN [1,2])AND(i IN [3,4])))THEN difcol:=true;
ELSE END;
END;
PROCEDURE GetHidden;
VAR   i,j,n,k:INTEGER;
BEGIN himax:=0; nhimax:=0; FOR i:=1 TO 13 DO hiar[i]:=0;
FOR i:=1 TO 7 DO WITH pil[i] DO FOR j:=1 TO n1 DO
  BEGIN k:=ca[j].m; IF(j<=n1)THEN Inc(hiar[k]);
  END;
FOR i:=1 TO 13 DO himax:=Max0(himax,hiar[i]);
FOR i:=1 TO 13 DO IF(hiar[i]=himax)THEN Inc(nhimax);
IF(himax=0)THEN nhimax:=0;
END;
PROCEDURE GetClosed;
VAR   ii,i,j,k:INTEGER; ok:BOOLEAN;
BEGIN clmax:=0; nclmax:=0; FOR i:=1 TO 13 DO clar[i]:=0;
FOR i:=1 TO 7 DO WITH pil[i] DO FOR k:=1 TO n1 DO
 BEGIN j:=ca[k].m; ok:=true; FOR ii:=k+1 TO n1+1 DO
 IF((ca[ii].m=(j-1))AND(ok))THEN
  BEGIN Inc(clar[j]); ok:=false;
  END;
 END;
FOR i:=1 TO 13 DO clmax:=Max0(clmax,clar[i]);
FOR i:=1 TO 13 DO IF(clar[i]=clmax)THEN Inc(nclmax);
IF(clmax=0)THEN nclmax:=0;
END;
PROCEDURE DeleteUpCard(j:INTEGER);
BEGIN k:=pn(j); IF(k<>0)THEN
 BEGIN kk1:=pil[j].ca[k]; Inc(nm); main[nm]:=kk1; Dec(pil[j].n2);
 TurnLastStack;
 END;
END;
PROCEDURE TryDeleteUpCard;
VAR j:INTEGER;
BEGIN j:=iRandom(7)+1; DeleteUpCard(j);
END;
PROCEDURE Initial(start:BOOLEAN; nc:INTEGER);
VAR   i,j,k:INTEGER;
BEGIN NofRet:=1;
{Get deck}
IF(start)THEN FOR i:=1 TO 4 DO FOR j:=1 TO 13 DO
WITH deck[(i-1)*13+j] DO
 BEGIN m:=j; c:=i;
 END;
FOR k:=1 TO 1499 DO
 BEGIN i1:=iRandom(52)+1; i2:=iRandom(52)+1;
 kk1:=deck[i1]; deck[i1]:=deck[i2]; deck[i2]:=kk1;
 END;
IF((nc>8)AND(nc<>20))THEN NofRet:=0;
{Provide for at least one 1,2,12,13}
IF(nc>3)THEN ProvideOne11213(2,49);
IF(nc>5)THEN ProvideOne11213(11,48);
ProvideOne11213(1,50);
ProvideOne11213(12,51); ProvideOne11213(13,52);
nst:=52-nc; NoReOrd:=1;
      {Get row stacks}
CASE nc OF
 3: BEGIN FOR i:=1 TO 7 DO npil[i]:=7;
    END;
 4: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=7;
    npil[4]:=6; npil[5]:=7; npil[6]:=7; npil[7]:=7;
    END;
 5: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=7;
    npil[4]:=5; npil[5]:=7; npil[6]:=7; npil[7]:=7;
    END;
 6: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=7;
    npil[4]:=4; npil[5]:=7; npil[6]:=7; npil[7]:=7;
    END;
 7: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=7;
    npil[4]:=3; npil[5]:=7; npil[6]:=7; npil[7]:=7;
    END;
 8: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=7;
    npil[4]:=2; npil[5]:=7; npil[6]:=7; npil[7]:=7;
    END;
 9: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=7;
    npil[4]:=1; npil[5]:=7; npil[6]:=7; npil[7]:=7;
    END;
10: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=6;
    npil[4]:=2; npil[5]:=6; npil[6]:=7; npil[7]:=7;
    END;
11: BEGIN npil[1]:=7; npil[2]:=7; npil[3]:=6;
    npil[4]:=1; npil[5]:=6; npil[6]:=7; npil[7]:=7;
    END;
12: BEGIN npil[1]:=7; npil[2]:=6; npil[3]:=5;
    npil[4]:=4; npil[5]:=5; npil[6]:=6; npil[7]:=7;
    END;
13: BEGIN npil[1]:=6; npil[2]:=5; npil[3]:=7;
    npil[4]:=3; npil[5]:=7; npil[6]:=5; npil[7]:=6;
    END;
14: BEGIN npil[1]:=6; npil[2]:=5; npil[3]:=7;
    npil[4]:=2; npil[5]:=7; npil[6]:=5; npil[7]:=6;
    END;
15: BEGIN npil[1]:=6; npil[2]:=5; npil[3]:=7;
    npil[4]:=1; npil[5]:=7; npil[6]:=5; npil[7]:=6;
    END;
16: BEGIN FOR i:=1 TO 7 DO npil[i]:=i+1; npil[1]:=3;
    END;
17: BEGIN FOR i:=1 TO 7 DO npil[i]:=i+1; NoReOrd:=0;
    END;
18: BEGIN FOR i:=1 TO 7 DO npil[i]:=8; npil[4]:=2; npil[1]:=0;
    npil[7]:=0;
    END;
19: BEGIN FOR i:=1 TO 7 DO npil[i]:=8; npil[4]:=1; npil[1]:=0;
    npil[7]:=0;
    END;
20: BEGIN FOR i:=1 TO 7 DO npil[i]:=0;
    FOR i:=1 TO 3 DO npil[i]:=10; npil[2]:=12;
    END;
ELSE
 BEGIN nst:=36; k:=7; FOR i:=1 TO 7 DO npil[i]:=1;
 FOR i:=1 TO 29 DO
  BEGIN j:=iRandom(7)+1; WHILE(npil[j]=7)DO
   BEGIN Inc(j); IF(j>7)THEN j:=1;
   END; npil[j]:=npil[j]+1;
  END;
 END;
      END;
k:=1; FOR i:=1 TO 7 DO WITH pil[i] DO {Form stacks}
 BEGIN FOR j:=1 TO npil[i] DO
  BEGIN ca[j]:=deck[k]; Inc(k);
  END; n1:=Max0(npil[i]-1,0); IF(npil[i]>0)THEN n2:=1 ELSE n2:=0;
 END;
{Form mains}
nm:=52-nst; nm0:=nm; FOR i:=1 TO nm DO
 BEGIN main[i]:=deck[k]; Inc(k);
 END;
{Form tops}
FOR i:=1 TO 4 DO WITH tops[i] DO
 BEGIN ca[1].m:=0; ca[1].c:=i; n1:=1;
 END;
scor:=0;
{Check and correct for fairness}
GetHidden; GetClosed; IF(clmax=4)THEN Inc(NoReOrd);
END;
PROCEDURE CheckDone(VAR k:INTEGER);
VAR i:INTEGER;
BEGIN k:=0; FOR i:=1 TO 7 DO k:=k+pil[i].n1;
END;
FUNCTION itos(i:INTEGER):STR2;
VAR j:INTEGER;
BEGIN j:=i+20; sk:=IntToStr(j);
IF(i>9)THEN sk[1]:='1' ELSE sk[1]:='_'; itos:=sk;
END;
PROCEDURE SetCol(c:INTEGER; VAR cl:LONGINT);
BEGIN
CASE c OF
1: cl:=clLime;
2: cl:=clRed;
3: cl:=clFuchsia;
4: cl:=clAqua;
ELSE END;
END;
PROCEDURE SwapCards(i1,i2:INTEGER);
VAR   i,l,n:INTEGER; ok:BOOLEAN;
LABEL Lend;
BEGIN l:=pn(i1); IF(l=0)THEN GOTO Lend; ok:=false;
l2:=pn(i2); n:=pil[i1].n2; l1:=pil[i1].n1+1;
kk1:=pil[i1].ca[l1]; IF((l2=0)AND(kk1.m=13))THEN ok:=true;
IF(l2<>0)THEN
 BEGIN kk2:=pil[i2].ca[l2];
 IF(((kk2.m-kk1.m)=1)AND(difcol(kk2.c,kk1.c)))THEN ok:=true ELSE
  BEGIN kk1:=pil[i1].ca[l];
  IF(((kk2.m-kk1.m)=1)AND(difcol(kk2.c,kk1.c)))THEN
   BEGIN ok:=true; n:=1; l1:=pn(i1);
   END;
  END;
 END;
IF(ok)THEN FOR i:=1 TO n DO
 BEGIN Inc(pil[i2].n2);
 pil[i2].ca[l2+i]:=pil[i1].ca[l1+i-1]; Dec(pil[i1].n2);
 END;
TurnLastStack;
Lend:;
END;
FUNCTION TurnXtoI(x:INTEGER):INTEGER;
VAR   i,j,x1,i1:INTEGER;
LABEL L1;
BEGIN j:=(sdr*8)DIV 2; FOR i:=1 TO 7 DO
 BEGIN x1:=((i-1)*sdr+6+x0)*8; IF((x>=x1-j)AND(x<x1+j))THEN
  BEGIN i1:=i; GOTO L1;
  END;
 END;
i1:=0;
L1: TurnXtoI:=i1;
END;
FUNCTION TurnTXtoI(x:INTEGER):INTEGER;
VAR   i,x1,i1:INTEGER;
LABEL L1;
BEGIN FOR i:=1 TO 4 DO
 BEGIN x1:=((i-1)*8+24+x0)*8; IF((x>=x1-32)AND(x<x1+32))THEN
  BEGIN i1:=i; GOTO L1;
  END;
 END;
i1:=0;
L1: TurnTXtoI:=i1;
END;
FUNCTION TurnMXtoI(x:INTEGER):INTEGER;
VAR   i,x1,i1:INTEGER;
LABEL L1;
BEGIN FOR i:=1 TO nm DO
 BEGIN x1:=(3*i-1)*8; IF((x>=x1)AND(x<x1+24))THEN
  BEGIN i1:=i; GOTO L1;
  END;
 END;
i1:=0;
L1: TurnMXtoI:=i1;
END;


PROCEDURE HideCompo(vis:BOOLEAN);
BEGIN WITH Form3 DO
 BEGIN Button1.Visible:=vis; Button2.Visible:=vis; Button3.Visible:=vis;
 Button4.Visible:=vis; Button5.Visible:=vis; Button6.Visible:=vis;
 Button7.Visible:=vis; Button8.Visible:=vis; Button9.Visible:=vis;
 Button10.Visible:=vis; Button11.Visible:=vis; Image2.Visible:=vis;
 END;
END;
PROCEDURE BlockCommands(bl:BOOLEAN);
BEGIN WITH Form3 DO
 BEGIN Button1.Enabled:=bl; Button2.Enabled:=bl; {Button3.Enabled:=bl;}
 Button4.Enabled:=bl; Button5.Enabled:=bl; Button6.Enabled:=bl;
 {Button7.Enabled:=bl;} Button8.Enabled:=bl; Button9.Enabled:=bl;
 END;
END;
PROCEDURE PrintClick(s:STRING; sc:STRING);
BEGIN BlockCommands(false); WITH Form3.Canvas DO
 BEGIN Font.Color:=clYellow; Brush.Color:=clBlue; TextOut(5,2*18,s);
 END;
END;
PROCEDURE TForm3.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR   i:INTEGER;
LABEL Lend,L1;
BEGIN IF(grs=1)THEN GOTO L1;
IF((infun(x,1,(23+x0)*8))AND(infun(y,36,54)))THEN
 BEGIN NextMainItem; Printer; GOTO Lend;
 END                                               ELSE
IF((infun(x,(24+x0)*8,(56+x0)*8))AND(infun(y,36,54)))THEN
 BEGIN TopToStack(TurnTXtoI(x)); GOTO Lend;
 END                                                 ELSE
IF((infun(x,16,(3*nm+2)*8))AND(infun(y,18,36)))THEN
 BEGIN MainToStack(TurnMXtoI(x),0); GOTO Lend;
 END ELSE;
L1: CASE grs OF
0: BEGIN IF(Button=mbRight)THEN ExchangeItems(TurnXtoI(x))
                           ELSE
   CASE ncl OF
   1: BEGIN im1:=TurnXtoI(x); ncl:=2; WITH Image1.Canvas DO
       BEGIN Brush.Color:=clBlue; Font.Color:=clYellow;
       TextOut(5,2*18,' Move ');
       END;
      END;
   2: BEGIN im2:=TurnXtoI(x); ncl:=1;
      IF((im1 IN [1..7])AND(im2 IN [1..7]))THEN SwapCards(im1,im2);
      Printer;
      END;
   ELSE END;
   END;
1: BEGIN icoor:=TurnXtoI(x); jcoor:=Round(Y DIV 18)-3;
   xcoor:=x; ycoor:=Y DIV 18;
   END;
ELSE END;
Lend: click1:=true;
END;
PROCEDURE NextMainItem; {Next Main item, occasionally to Top}
VAR i,j,k:INTEGER;
BEGIN kk1:=main[nm]; i:=kk1.c; j:=tn(i);
IF(j=0)THEN k:=0 ELSE k:=tops[i].ca[j].m; IF((kk1.m-k)<>1)THEN
 BEGIN kk1:=main[nm]; FOR i:=nm DOWNTO 2 DO main[i]:=main[i-1];
 main[1]:=kk1; Exit;
 END;
Inc(tops[i].n1); j:=tn(i); tops[i].ca[j]:=kk1; Dec(nm);
END;
PROCEDURE MainToStack(i1,mo:INTEGER);
VAR   i,j:INTEGER;
LABEL Lout;
BEGIN IF(mo=0)THEN
 BEGIN grs:=1; PrintClick('    TO    ','Main to stack');
 Wait(click1); i:=icoor; grs:=0; BlockCommands(true); j:=jcoor;
 END          ELSE
  BEGIN i:=i1; i1:=nm;
  END;
IF((i1 IN [1..nm])AND(jcoor<3)AND(xcoor>((24+x0)*8)))THEN
 BEGIN kk1:=main[i1]; i:=kk1.c; j:=tn(i);
 IF(j=0)THEN k:=0 ELSE k:=tops[i].ca[j].m; IF((kk1.m-k)=1)THEN
  BEGIN Inc(tops[i].n1); j:=tn(i); tops[i].ca[j]:=kk1;
  FOR j:=i1+1 TO nm DO main[j-1]:=main[j]; Dec(nm); GOTO Lout;
  END;
 END;
i:=icoor; IF((i1 IN [1..nm])AND(i IN[1..7]))THEN
 BEGIN IF(nm=0)THEN GOTO Lout; kk1:=main[i1];
 l2:=pn(i); IF((l2=0)AND(kk1.m<>13))THEN GOTO Lout;
 IF(l2=0)THEN kk2:=kk0 ELSE kk2:=pil[i].ca[l2];
 IF(((kk2.m-kk1.m)=1)AND(difcol(kk2.c,kk1.c)))THEN
  BEGIN Inc(pil[i].n2); pil[i].ca[l2+1]:=kk1;
  FOR j:=i1+1 TO nm DO main[j-1]:=main[j];
  Dec(nm);
  END                                         ELSE GOTO Lout;
 END;
Lout: ;
Printer;
END;
PROCEDURE TopToStack(i1:INTEGER);
LABEL Lend;
BEGIN grs:=1; PrintClick('    TO    ','Tops to stack');
Wait(click1); i2:=icoor; grs:=0; BlockCommands(true);
IF((i1 IN [1..7])AND(i2 IN [1..7]))THEN
 BEGIN l1:=tops[i1].n1; IF(l1<=1)THEN GOTO Lend;
 kk1:=tops[i1].ca[l1]; l2:=pn(i2); kk2:=pil[i2].ca[l2];
 IF((((kk2.m-kk1.m)=1)AND(difcol(kk2.c,kk1.c)))OR(l2=0))THEN
  BEGIN Inc(pil[i2].n2); pil[i2].ca[l2+1]:=kk1; Dec(tops[i1].n1);
  END;
 TurnLastStack;
 END;
Lend: Printer;
END;
PROCEDURE ExchangeItems(i:INTEGER);
VAR j,ll2:INTEGER; km1:CARD;
LABEL Ladd,Lout;
BEGIN IF(nm=0)THEN Exit; IF(NOT(i IN [1..7]))THEN i:=1; kk1:=main[nm];
l2:=pn(i); IF(l2=0)THEN GOTO Ladd; kk2:=pil[i].ca[l2]; j:=pil[i].n2;
IF(j>1)THEN km1:=pil[i].ca[l2-1]; IF(kk2.m<>kk1.m)THEN GOTO Ladd;
IF(nc IN [9..17])THEN Exit;
IF((j=1)OR((j>1)AND(difcol(kk1.c,km1.c))))THEN
 BEGIN pil[i].ca[l2]:=kk1; main[nm]:=kk2;  {Exchange}
 END                                      ELSE Exit;
TurnLastStack; Printer; Exit;
{*}
Ladd: IF((l2=0)AND(kk1.m<>13))THEN GOTO Lout;  {Add}
IF(l2=0)THEN kk2:=kk0 ELSE kk2:=pil[i].ca[l2];
IF(((kk2.m-kk1.m)=1)AND(difcol(kk2.c,kk1.c)))THEN
 BEGIN Inc(pil[i].n2); pil[i].ca[l2+1]:=kk1; Dec(nm);
 END;
Lout: TurnLastStack; Printer;
END;
PROCEDURE TForm3.Button1Click(Sender: TObject);
{ from deck to stack, make the top}
BEGIN IF(nm=0)THEN Exit;
grs:=1; PrintClick(' WHERE ','Deck to stack'); Wait(click1);
i:=icoor; grs:=0; BlockCommands(true);
IF(NOT(i IN [1..7]))THEN i:=1; kk1:=main[nm];
l2:=pn(i); IF(l2=0)THEN kk2:=kk0 ELSE kk2:=pil[i].ca[l2];
IF(((kk2.m-kk1.m)=1)AND(difcol(kk2.c,kk1.c))AND(pil[i].n2<>1))THEN
 Inc(pil[i].n2)                                               ELSE
  BEGIN pil[i].n1:=pil[i].n1+pil[i].n2; pil[i].n2:=1;
  END;
pil[i].ca[l2+1]:=kk1; Dec(nm); TurnLastStack; Printer;
END;
PROCEDURE TForm3.Button2Click(Sender: TObject);{Automatic steps}
VAR i,j,k:INTEGER;
BEGIN FOR k:=2 TO 13 DO
 BEGIN FOR j:=1 TO 7 DO parr[j]:=0;
 FOR i:=1 TO 7 DO IF(pcm(i)=(15-k))THEN parr[i]:=k;
 FOR i:=1 TO 7 DO IF(parr[i]<>0)THEN FOR j:=1 TO 7 DO SwapCards(i,j);
 END;
Printer;
END;
PROCEDURE TForm3.Button3Click(Sender: TObject);{from stack to main deck}
BEGIN IF(NofRet=0)THEN Exit;
grs:=1; PrintClick(' FROM ','Return'); Wait(click1); i1:=icoor;
grs:=0; BlockCommands(true);
IF(i1 IN [1..7])THEN
 BEGIN DeleteUpCard(i1); NofRet:=MAX0(0,NofRet-1);
 END;
Printer;
END;
PROCEDURE TForm3.Button4Click(Sender: TObject); {Main off}
VAR i:INTEGER;
BEGIN FOR i:=1 TO nm DO NextMainItem; Printer;
END;
PROCEDURE TForm3.Button5Click(Sender: TObject); {Scroll Main }
VAR i:INTEGER;
BEGIN kk1:=main[nm]; FOR i:=nm DOWNTO 2 DO main[i]:=main[i-1];
main[1]:=kk1; Printer;
END;
PROCEDURE TForm3.Button6Click(Sender: TObject);{from stack to main deck}
BEGIN grs:=1; PrintClick(' FROM ','Stack to deck'); Wait(click1);
i1:=icoor; grs:=0; BlockCommands(true);
IF(i1 IN [1..7])THEN DeleteUpCard(i1);
Printer;
END;
PROCEDURE TForm3.Button7Click(Sender: TObject);{reOrder the row stack}
VAR   i,j,k,n,ii,ncou:INTEGER; x,y,cl:LONGINT;
LABEL Lend;
BEGIN IF(NoReOrd=0)THEN Exit;
grs:=1; PrintClick(' Row? ','ReOrder'); Wait(click1);
i:=icoor; j:=jcoor; grs:=0;
BlockCommands(true); n:=pil[i].n1+pil[i].n2;
IF(NOT(i IN [1..7]))THEN GOTO Lend; IF(NOT(j IN [1..n]))THEN GOTO Lend;
ncou:=n-j; FOR ii:=1 TO ncou DO IF(n>1)THEN
 BEGIN kk1:=pil[i].ca[n]; pil[i].n1:=n-1; pil[i].n2:=1;
 FOR j:=n DOWNTO 2 DO pil[i].ca[j]:=pil[i].ca[j-1];
 pil[i].ca[1]:=kk1;
 END;
NoReOrd:=MAX0(0,NoReOrd-1);
TurnLastStack;
Lend: Printer;
END;
PROCEDURE TForm3.Button8Click(Sender: TObject); {from stacks to tops}
VAR   i,j,k,ii,kk:INTEGER;
LABEL LL;
BEGIN FOR kk:=1 TO 5 DO
 BEGIN FOR i:=1 TO 7 DO IF(pn(i)>0)THEN FOR k:=1 TO 4 DO
  BEGIN IF(tn(k)<>0)THEN
  IF((pcm(i)-tcm(k)=1)AND(NOT difcol(pcc(i),tcc(k))))THEN j:=i
                                                     ELSE GOTO LL
                    ELSE
  IF((pcm(i)=1)AND(NOT difcol(pcc(i),k)))THEN j:=i ELSE GOTO LL;
  i1:=j; l1:=pn(i1);
  kk1:=pil[i1].ca[l1]; ii:=kk1.c;
  Inc(tops[ii].n1); j:=tn(ii); tops[ii].ca[j]:=kk1; Dec(pil[i1].n2);
  LL:;
  TurnLastStack;
  END;
 END;
Printer;
END;
PROCEDURE TForm3.Button9Click(Sender: TObject);
BEGIN AcMenu:=true; Close;
END;
{-----------------------}
BEGIN


END.


PROCEDURE TForm3.Quit1Click(Sender: TObject);
BEGIN Application.Terminate;
END;
PROCEDURE TForm3.ToggleDisplay1Click(Sender: TObject);
BEGIN NoDispl:=NOT NoDispl; Printer;
END;
