PROGRAM vmria;

USES  Forms,   Graphics, Controls, Windows, Messages, SysUtils, Classes,
      Dialogs, Menus,    StdCtrls, Grids,   ExtCtrls,
      vzlocom, vmria0,   varfun,   vspectr, vpmodel,  vgfit,    vmriasp,
      vmriafl, vmriasgm, vmriahlp, vmriahkl,vmriauto, vtest,    vpeaksr,
      vmriarit,vmriarix, vstdcons, vmria00,
  vmria1 in 'vmria1.pas' {Form1},
  vmria2 in 'vmria2.pas' {Form2},
  vmria3 in 'vmria3.pas' {Form3},
  vmria4 in 'vmria4.pas' {Form4};

{$R *.RES}
PROCEDURE InitializeForms;
BEGIN ResizeF1(1.5,1); ResizeF2(1.5,1); ResizeF2(1,1); scrsize:=1;
HideComponents;
END;
PROCEDURE Inipr;
VAR   i,j,k,iop,cl:INTEGER; ss:STRING; ocom:BOOLEAN; r:REAL;
BEGIN mriamode:=0; ModalRes:=1; dsfn:=vmdir;
IF(defspdir='')THEN defspdir:=vmdir;
iop:=3; ocom:=false;
i:=Length(vmdir); ss:=vmdir; IF(ss[i]<>'\')THEN ss:=ss+'\';
s:=FormatDateTime('dd',Date)+FormatDateTime('hhnn',Time);
outfn:=ss+'m'+s+'.res';
Form2.OpenDialog1.Title:='   Select the file';
REPEAT L0rec:='Enter file name';
MakeFormV(0,20,630,430,0); SaveHelp(ExtSize_n,ExtSize);
cl:=clBtnFace; Form2.Color:=cl;
s:='The analysis results are saved in an output file ';
OuttoLabel(Form2.Label4,10,40,cl,clNavy,s);
s:='Standard output file name = m(day hour min).res';
OuttoLabel(Form2.Label3,10,58,cl,clNavy,s);
OuttoLabel(Form2.Label1,10,76,cl,clNavy,'Output file:  '+outfn);
WITH CB1rec DO
 BEGIN nitems:=4; indx:=iop;
 ar[1]:='Change the file name';
 ar[2]:='Abort';
 ar[3]:='Go on';
 ar[4]:=' Put comments to the output file ';
 END;
MakeRadioGroup(1,0,200,135,260,150);
WITH Form2 DO
 BEGIN ShowModal; iop:=RadioGroup1.ItemIndex+1;
 END;
CASE iop OF
1: BEGIN iop:=3; GetFilename(outfn,1);
   IF(ModalRes=0)THEN
    BEGIN ModalRes:=0; Exit;
    END;
   END;
2: BEGIN ModalRes:=0; Exit;
   END;
3: BREAK;
4: BEGIN PutComment(ocom); iop:=3;
   END;
ELSE END;
UNTIL false;

AssignFile(fout,outfn); {$I-} ReWrite(fout); {$I+};
ok:=(IOresult=0); IF NOT ok THEN
 BEGIN s:='Output file failure: possibly shared or read only';
 ShowMess(s); Exit;
 END;
IF(ocom)THEN WITH Form2.Memo1.Lines DO
 FOR i:=1 TO Count DO Writeln(fout,Strings[i-1]);

s:=ss+'vmria.fn'; IF(FileExists(s))THEN GetSetInfo(s);
r:=scrsize; IF(r<>1)THEN
 BEGIN ResizeF1(r,r); ResizeF2(r,r);
 END;
FOR i:=0 TO 4 DO spec[i]:=TSpectrum.Create(vmdir);
s:=ss+'vmria.def'; IF(FileExists(s))THEN DefInfo(s,0);
FOR i:=0 TO 6 DO pmod[i]:=TPeakModel.Create;
gfit:=TParameter.Create(npmax,nmmax,upintx);  WITH gfit DO
 BEGIN mpoint:=0; FormCB; cb.eps:=0.1; cb.step:=0.99; cb.damp:=0.01;
 npar:=npmax; FormParameters; npar:=0; nfr:=0; cw:=cb; {cb}
 END;
FOR i:=1 TO 6 DO WITH lat[i] DO  {lattice}
 BEGIN syng:=1; nlatt:=0; nsg:=1; sett:=1; csym:=0; nat:=0; nhkl:=0;
 lerrc:=5; aerrc:=10; coW:=1; Wl0:=5; Wl1:=0; SetSpaceGroupInfo(i);
 h0:=0; k0:=0; l0:=1; WITH lpd DO
  BEGIN a:=4; b:=4; c:=4; alpha:=90; beta:=90; gamma:=90;
  END;
 FOR j:=1 TO 48 DO
  BEGIN FOR k:=1 TO 9 DO mut[k,j]:=0;
  FOR k:=1 TO 3 DO mut[(k-1)*3+k,j]:=1;
  END;
 END;
ResetAtoms;
FOR i:=1 TO 6 DO FOR j:=1 TO 4000 DO WITH hkla[j,i] DO {hkl}
 BEGIN Fkc:=0; Fks:=0; dk:=0; h:=0; k:=0; l:=0; mul:=0; txtc:=1;
 END;
imod1:=0; imod2:=0;
parfn:=vmdir; savfn:=vmdir;
FormDN2effSp; SaveHelp(NyetI_n,NyetI); Form1.N1.Enabled:=false;
ic1:=spec[1].a11; ic2:=spec[1].a22; cadl:=ic2-ic1+1;
Form1.Items1.CopyToClipBoard;
ResetVMria;
END;
{********}
BEGIN Application.Initialize; scrsize:=1; fntsize:=10;
GetDir(0,vmdir); s:=vmdir+'\vmria.fn'; inifn:=vmdir; evfn:=vmdir;
Application.CreateForm(TForm1, Form1);
Application.CreateForm(TForm4, Form4);
Application.CreateForm(TForm2, Form2);
Application.CreateForm(TForm3, Form3);
InitializeForms;
Inipr; IF(ModalRes=0)THEN Exit;
Application.Run;
END.

      (ionn:''; ffaca:(,,,,,,
      ,);),

      (ionn:'TM2'; ffaca:(0.0983,18.324,0.3380, 6.918, 0.5875,2.662,
      -0.0241,0.0404);),


{WM_GETMINMAXINFO
 lpmmi (LPMINMAXINFO) lParam;}
{VAR Info: TWMGetMinMaxInfo;
Form1.WMGetMinMaxInfo(VAR Info: TWMGetMinMaxInfo);}

