UNIT vtest;
INTERFACE {}
USES
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, vzlocom,  varfun,   vmria0,  vmriahkl, vmriasp,  vspectr,
  vmria2,  vmriafl,  vdata,    vpeaksr, vmriaup,  vstdcons, vgfit,
  vpmodel, vmria3,   vmriarit, vmria00;

PROCEDURE TestMode;
PROCEDURE SetZrO2;
PROCEDURE SetOrthoRh;
PROCEDURE SetCubic;
PROCEDURE SetTriclinic;
PROCEDURE Set2Phases;
PROCEDURE SetChernyshev;
PROCEDURE TestRietveld;
PROCEDURE TestAutoindexing;
PROCEDURE TestUpeak;
PROCEDURE TestSmallSp;
PROCEDURE TestSomeThing{(F:TForm)};
PROCEDURE SettheTestData;
PROCEDURE TestThis;
PROCEDURE ViewResFile;
PROCEDURE TestBalaSp;
PROCEDURE RNGener;
VAR jndex:INTEGER;
    oktest:BOOLEAN = false;
IMPLEMENTATION{-----------------------------------------------}
PROCEDURE MakeCalcul;
VAR   i,j,iph,iat,ic,it,il,iop:INTEGER; tr:ARRAY[1..3] OF REAL;
      z,x,ht,kt,lt,r1,r2,xj,yj,zj,xtj,ytj,ztj:REAL; ss,s:STRING;
 {PROCEDURE FormStr(sg:REAL);
 BEGIN ConvertStr(sg*xtj,7,2); s:=ss+sedz; ConvertStr(sg*ytj,7,2);
 s:=s+sedz; ConvertStr(sg*ztj,7,2); s:=s+sedz;
 END;
 PROCEDURE FormStrHKL(sg:REAL);
 BEGIN ConvertStr(sg*ht,7,2); s:=ss+sedz; ConvertStr(sg*kt,7,2);
 s:=s+sedz; ConvertStr(sg*lt,7,2); s:=s+sedz;
 END;}
LABEL L1;
BEGIN iop:=1; r1:=0;
L1: L0rec:='Calculations';
MakeForm(0); WITH CB1rec DO
 BEGIN nitems:=4{1}; indx:=iop;
 ar[1]:=' Get arccos(X)';
 ar[2]:=' Get arcsin(X)';
 ar[3]:=' Get arctg(X)';
 ar[4]:=' Get angles';
 {ar[5]:=' Get Symmetric Atoms';
 ar[6]:=' Get Equivalent HKL''s';}
 {ar[1]:='Test m"';}
 END;
MakeRadioGroup(1,0,5,10,270,270);
L1rec:='X = '; ConvertStr(r1,10,4); E1rec:=sedz;
MakeEdits(10,40,300,120,1);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex; iop:=i+1; Zval(Edit1.Text,r1);
 MakeFormV(250,20,375,430,1);
 CASE iop OF
 {1: WITH pmod[1] DO
     BEGIN Writeln(fout,'*  '+spmodn[typ],rl:8:3);
     FOR i:=1 TO 193 DO
      BEGIN x:=i; z:=(x-67.43)/5.37; Getffzfzz(z,ff,fz,fzz);
      Writeln(fout,z:8:3,ff:9:3,fz:9:4,fzz:9:4,morr[i]:9:5);
      END;
     Exit;
     END;}
 1..3: BEGIN il:=1;
       CASE i+1 OF
       1: r2:=arccos(r1);
       2: r2:=arcsin(r1);
       3: r2:=arctan(r1);
       ELSE END;
    r2:=r2*radian; ConvertStr(r2,8,2); LB1rec.ar[1]:=sedz;
       END;
 5: BEGIN {il:=0; FOR iph:=1 TO nph DO WITH lat[iph] DO
     FOR it:=1 TO ntlv+1 DO WITH LB1rec DO
      BEGIN FOR ic:=1 TO 3 DO
       IF(it=1)THEN tr[ic]:=0 ELSE tr[ic]:=tlv[ic,it-1];
      FOR iat:=1 TO nat DO WITH atoms[iat,iph] DO
       BEGIN xj:=x; yj:=y; zj:=z; FOR j:=1 TO nut DO
        BEGIN xtj:=ut[1,j]*xj+ut[2,j]*yj+ut[3,j]*zj+shv[1,j]+tr[1];
        ytj:=ut[4,j]*xj+ut[5,j]*yj+ut[6,j]*zj+shv[2,j]+tr[2];
        ztj:=ut[7,j]*xj+ut[8,j]*yj+ut[9,j]*zj+shv[3,j]+tr[3];
        ss:=IntToStr(iph)+'  '+IntToStr(iat)+'  '+name;
        FormStr(1); Inc(il); ar[il]:=s; IF(csym=1)THEN
         BEGIN FormStr(-1); Inc(il); ar[il]:=s;
         END;
        END;
       END;
      END;}
    END;
 6: BEGIN {il:=0; FOR iph:=1 TO nph DO WITH lat[iph] DO WITH LB1rec DO
    FOR j:=1 TO nhkl DO WITH hkla[j,iph] DO FOR i:=1 TO nut DO
     BEGIN ht:=ut[1,i]*h+ut[4,i]*k+ut[7,i]*l;
     kt:=ut[2,i]*h+ut[5,i]*k+ut[8,i]*l;
     lt:=ut[3,i]*h+ut[6,i]*k+ut[9,i]*l;
     ConvertStr(dk,7,4); ss:=IntToStr(iph)+'  '+sedz;
     FormStrHKL(1); Inc(il); IF(i=1)THEN s:='  '+s; ar[il]:=s;
     IF(csym=1)THEN
      BEGIN FormStrHKL(-1); Inc(il); ar[il]:=s;
      END;
     END;}
    END;
 ELSE END;
 END;
LB1rec.nitems:=il; MakeListBox(10,10,340,360);
Form2.ShowModal; IF(ModalRes=0)THEN Exit; GOTO L1;
END;
PROCEDURE TestSomeThing{(F:TForm)};
VAR   i:INTEGER; s:STRING;
LABEL L1;
BEGIN L0rec:='Test';
L1: MakeForm(0); WITH CB1rec DO
 BEGIN nitems:=12; indx:=12;
 ar[1]:=' SuminOutput';
 ar[2]:=' SmirnovAnalysis';
 ar[3]:=' TestRietveld';
 ar[4]:=' TestAutoindexing';
 ar[5]:=' TestUpeak';
 ar[6]:=' TestThis';
 ar[7]:=' View res-file';
 ar[8]:=' Make text file';
 ar[9]:=' Random N Generator';
 ar[10]:=' Set debug keys';
 ar[11]:=' Make calculations';
 ar[12]:=' Test aniso';
 END;
MakeRadioGroup(1,0,5,10,170,250);
WITH LB1rec DO
 BEGIN nitems:=9;
 ar[1]:='z.ini= R,PM,UP,FS.';
 ar[2]:='mag.ini = R,PM,FS.';
 ar[3]:='';
 ar[4]:='';
 ar[5]:='';
 ar[6]:='auph2.ini = AU';
 ar[7]:='tric.ini = AU';
 ar[8]:='tar.ini = UP';
 ar[9]:='exp.ini = UP';
 ar[10]:='';
 END;
MakeListBox(180,10,155,200);

WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 CASE i OF
 0: SuminOutput;
 1: SmirnovAnalysis;
 2: TestRietveld;
 3: TestAutoindexing;
 4: TestUpeak;
 5: TestThis;
 6: ViewResFile;
 7: BEGIN s:=''; GetFilename(s,1); IF(ModalRes<>0)THEN
     BEGIN L0rec:='Edit the file '; MakeFormV(10,20,620,430,0);
     MakeMemo(0,610); WITH Form2.Memo1 DO
      BEGIN Form2.ShowModal; IF(ModalRes=0)THEN Exit;
      i:=MessageDlg('Save the file?',MtWarning,[mbYes,mbNo],0);
      IF(i=mrYes)THEN Lines.SaveToFile(s) ELSE Exit;
      END;
     END;
    END;
 8: RNGener;
 9: BEGIN MakeFormV(250,20,360,430,0);
    WITH CB1rec DO
     BEGIN nitems:=7;
     ar[1]:='  Print each iteration';
     ar[2]:='  Anisotropy test';
     ar[3]:='  Indexing test';
     ar[4]:='  Powder Match test';
     ar[5]:='  Peak Search test';
     ar[6]:='  Magnetic test';
     ar[7]:='  hkl test';
     END;
    MakeCheckListBox(5,120,200,200);
    Form2.CheckListBox1.Checked[0]:=false;
    Form2.CheckListBox1.Checked[1]:=false;
    Form2.CheckListBox1.Checked[2]:=false;
    Form2.CheckListBox1.Checked[3]:=false;
    Form2.CheckListBox1.Checked[4]:=false;
    Form2.CheckListBox1.Checked[5]:=false;
    Form2.CheckListBox1.Checked[6]:=false;
    WITH Form2 DO
     BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
     debugV.cbipr:=CheckListBox1.Checked[0];
     debugV.aniso:=CheckListBox1.Checked[1];
     debugV.indtest:=CheckListBox1.Checked[2];
     debugV.powdmath:=CheckListBox1.Checked[3];
     debugV.peaksear:=CheckListBox1.Checked[4];
     debugV.magnetic:=CheckListBox1.Checked[5];
     debugV.hkli:=CheckListBox1.Checked[6];
     END;
    END;
 10: BEGIN MakeCalcul;
     END;
 11: BEGIN WITH spec[1] DO
      BEGIN a1:=1; a2:=1024; a11:=301; a22:=740; dback:=1;
      w0:=6; w1:=0; dw0:=5; dw1:=100; spin:=true; smosp:=1;
      FPath:=25; chw:=64; delay:=0; Theta:=75;
      FOR i:=1 TO 6 DO bkpar[i]:=0; smosp:=1;
      END;
     WITH lat[1] DO WITH lpd DO
      BEGIN a:=4; b:=5; c:=6; alpha:=90; beta:=90; gamma:=100;
      nsg:=14; sett:=1; nat:=1; syng:=syngon(nsg,sett); coW:=1;
      SetSpaceGroupInfo(1);
      vol:=getvol(lpd); InverseLatPar(lpd,lpi,voli,0); FormLatMatrix(1);
      WITH atoms[1,1] DO
       BEGIN name:='H'; occ:=1; x:=0.1; y:=0.2; z:=0.3; t11:=0.15;
       t12:=0; t13:=0; t22:=0; t23:=0; t33:=0; scat:=sctlen[1];
       END;
      END;
     END;
 ELSE END;
 END;
IF(i IN [5,6])THEN
 BEGIN IF(i=5)THEN CB1rec.indx:=7; IF(i=6)THEN CB1rec.indx:=6; GOTO L1;
 END;
END;
PROCEDURE RNGener;
VAR   jx,i,j,k,im,n,li,lj,ii,jj,si,ate:INTEGER; e1,e2,sig:REAL;
LABEL L1;
BEGIN L0rec:='Test random number generator'; n:=100; ate:=1; im:=0;
L1: MakeFormV(50,20,560,430,0); WITH CB1rec DO
 BEGIN nitems:=3; indx:=im+1;
 ar[1]:=' Uniform(0,1)';
 ar[2]:=' Normal(0,1)';
 ar[3]:=' Poisson(1)';
 END;
MakeRadioGroup(1,0,5,10,170,80);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:='N of numbers'; strgrNn[1,1]:=n;
strgrT[2]:=''; strgrNn[2,1]:=0;
PuttoTable(185,10,2,2,1,8);
s:=' Try '+IntToStr(ate);
OuttoLabel(Form2.Label5,425,10,clMaroon,clWhite,s);

WITH Form2.Image1 DO
 BEGIN Left:=exs(240); Top:=exs(235); Width:=exs(280); Height:=exs(110);
 Visible:=true; WITH Canvas DO
  BEGIN Brush.Color:=clBtnFace; Brush.Color:=clYellow;
  FillRect(Rect(0,0,exs(280),exs(110)));
  END;
 END;
WITH Form2.Image2 DO
 BEGIN Left:=0; Top:=exs(120); Width:=exs(516); Height:=exs(110);
 Visible:=true; WITH Canvas DO
  BEGIN Brush.Color:=0; FillRect(Rect(0,0,exs(516),exs(110)));
  END;
 END;
step:=exs(500)/Float(n);
CASE im OF
0: BEGIN FOR i:=1 TO n DO onl[i]:=rndm(-1)*100; onl[n]:=onl[n]*2;
   sig:=SQRT(1/12)*100;
   j:=0; FOR i:=1 TO n DO IF(rinfun(onl[i],50-sig,50+sig))THEN Inc(j);
   END;
1: BEGIN sig:=SQRT(1)*15; FOR i:=1 TO n DO
    BEGIN rannor(e1,e2); onl[i]:=AMAX1(0,AMIN1(100,e1*15+50));
    END;
   j:=0; FOR i:=1 TO n DO IF(rinfun(onl[i],50-sig,50+sig))THEN Inc(j);
   END;
2: BEGIN sig:=SQRT(1)*10; FOR i:=1 TO n DO
    BEGIN jj:=0; FOR ii:=1 TO 10 DO
     BEGIN rpois(k); jj:=jj+k;
     END;
    onl[i]:=AMAX1(0,AMIN1(100,Float(jj)));
    END;
   j:=0; FOR i:=1 TO n DO IF(rinfun(onl[i],0,sig))THEN Inc(j);
   END;
ELSE END;
si:=Round(sig); WITH Form2.Image2.Canvas DO
 BEGIN FOR i:=1 TO n DO
  BEGIN li:=Round(step*i)+5; lj:=exs(Round(onl[i]))+5;
  FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
   IF((ABS(ii)+ABS(jj))<2)THEN Pixels[li+ii,lj+jj]:=clFuchsia;
  END;
 Pen.Color:=clRed; MoveTo(exs(0),exs(55)); LineTo(exs(515),exs(55));
 MoveTo(exs(0),exs(55-si)); LineTo(exs(515),exs(55-si));
 MoveTo(exs(0),exs(55+si)); LineTo(exs(515),exs(55+si));
 END;
e1:=0; FOR i:=1 TO n DO e1:=e1+onl[i]; e1:=e1/n*2;
e2:=0; FOR i:=1 TO n DO e2:=AMAX1(e2,onl[i]);
FOR i:=1 TO 100 DO buf4[i]:=0;
FOR i:=1 TO n DO
 BEGIN ii:=Round(onl[i]); IF(infun(ii,1,100))THEN Inc(buf4[ii]);
 END;
jx:=0; FOR i:=1 TO 100 DO jx:=MAX0(jx,buf4[i]);
OuttoLabel(Form2.Label6,185,100,clBlue,clWhite,' True interval =100');
WITH Form2.Image1.Canvas DO FOR i:=1 TO 100 DO
 BEGIN li:=3*i+3; lj:=exs(105)-exs(Round(buf4[i]/Float(jx)*100));
 FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
  IF((ABS(ii)+ABS(jj))<2)THEN Pixels[li+ii,lj+jj]:=clBlue;
 END;
WITH LB1rec DO
 BEGIN nitems:=6;
 ConvertStr(e1,8,2); ar[1]:='Average estimate = '+sedz;
 ConvertStr(e2,8,2); ar[2]:='Max estimate = '+sedz;
 ConvertStr(e2*Float(n+1)/n,8,2); ar[3]:='UnBias Max estimate = '+sedz;
 ConvertStr(sig,8,2); ar[4]:='Sigma = '+sedz;
 ConvertStr(Float(j*100)/n,7,0);
 ar[5]:='Confident n = '+IntToStr(j)+'  '+sedz+'%';
 ar[6]:='Sample max= '+IntToStr(jx);
 END;
MakeListBox(5,235,230,130);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
im:=Form2.RadioGroup1.ItemIndex;
Zval(Form2.StringGrid1.Cells[0,0],har[1]); n:=Round(har[1]);
Inc(ate); GOTO L1;
END;
PROCEDURE TestArith(VAR y,w,f:REAL; i,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
    f  = a*exp(-(x-p)^2/w^2)
 computes function value + 1-st derivatives, Dec 20 2004}
VAR r,ex,x,z:REAL; j:INTEGER;
BEGIN {y:=spec[numsp].y[i]; w:=SQRT(y+1); x:=FLOAT(i); WITH testlsm DO
 BEGIN drv[7]:=0; f:=0; FOR j:=1 TO 3 DO
  BEGIN z:=(x-par[2*j].p)/par[7].p; ex:=exp(-SQR(z));r:=par[2*j-1].p*ex;
  drv[2*j-1]:=ex; drv[2*j]:=2*r*z/par[7].p;
  drv[7]:=drv[7]+2*r*SQR(z)/par[7].p; f:=f+r;
  END;
 END;}
END;
PROCEDURE TestRegul(iit:INTEGER);
BEGIN {Dummy}
END;
PROCEDURE TestThis;
VAR m,i,j,k,n:INTEGER; d,q,h,T,lamb,z,c,a,v:REAL; vc:VECTOR;
VAR cmax,xx:REAL;
BEGIN
{L0rec:=''; MakeForm(0);
OuttoLabel(Form2.Label5,5,10,clMaroon,clWhite,'Select parameter type');
WITH CB1rec DO
 BEGIN nitems:=3; indx:=1;
 ar[1]:='w^+s^2';
 ar[2]:='(1-s)m + s*m"';
 ar[3]:='w*(1+s)';
 END;
MakeRadioGroup(1,0,20,30,270,150);
WITH CB1rec DO
 BEGIN nitems:=3;
 ar[1]:='Use Lorenz';
 ar[2]:='Use real';
 ar[3]:='Add noise';
 END;
MakeCheckListBox(20,200,270,70);
Form2.CheckListBox1.Checked[0]:=false;
Form2.CheckListBox1.Checked[1]:=false;
Form2.CheckListBox1.Checked[2]:=false;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex; debugV.uparith[i+1]:=true;
 END;
q:=0; c:=31; v:=c/7; h:=1/v; WITH spec[numsp] DO
 BEGIN FOR i:=1 TO Round(c) DO
  BEGIN d:=Round(c/2)+1; z:=(i-d)/v; y[i]:=EXP(-SQR(z)/2); q:=q+y[i];
  END;
 Writeln(fout,'S= ',q:9:4,v:9:4,(q*h):9:4,(v*SQRT(2*pi)):9:4);
 FOR i:=1 TO Round(c) DO onl[i]:=y[i]/q;
 t:=0; FOR i:=1 TO Round(c) DO t:=t+onl[i];
 spin:=true; a11:=1; a22:=150; w0:=6; a2:=150;
 FOR i:=1 TO 150 DO
  BEGIN z:=(i-41)/4; y[i]:=100*EXP(-SQR(z)/2);
  z:=(i-81)/(4+(2*i-151)/149); y[i]:=y[i]+100*EXP(-SQR(z)/2);
  END;
 FOR i:=1 TO 150 DO FOR j:=1 TO Round(c) DO WITH Form2 DO
  BEGIN z:=(i-126+Float(j))/(4+(2*i-151)/149);
  y[i]:=y[i]+100*EXP(-SQR(z)/2)*onl[j];
  IF(CheckListBox1.Checked[0])THEN y[i]:=y[i]+100/(1+SQR(z))*onl[j];
  IF(CheckListBox1.Checked[2])THEN
   y[i]:=AMAX1(0,y[i]+(rndm(-1)-0.5)*SQRT(y[i]));
  END;
 END;}
{---------------------}
END;
PROCEDURE SetChernyshev;
{pressured hexagonal cell}
CONST arr:ARRAY[1..21,1..4] OF REAL = (
   {d(A)   two-th   Io/Imax  FWHM}
   (5.5752,   7.41,   5,  0.16),
   (4.3354,   9.53,  14,  0.13),
   (3.8625,  10.70,   2,  0.15),
   (3.6090,  11.45,  86,  0.14),
   (3.3639,  12.29,  81,  0.18),
   (3.2810,  12.60,   5,  0.23),
   (2.7809,  14.88,  77,  0.16),
   (2.5963,  15.94,  18,  0.21),
   (2.4109,  17.17, 100,  0.19),
   (2.3678,  17.49,  67,  0.15),
   (2.3235,  17.83,  32,  0.24),
   (2.1655,  19.14,  11,  0.16),
   (2.0175,  20.56,   8,  0.25),
   (1.9280,  21.52,  15,  0.23),
   (1.8997,  21.85,   4,  0.18),
   (1.8030,  23.04,   7,  0.22),
   (1.7808,  23.33,  10,  0.16),
   (1.7285,  24.04,   1,  0.14),
   (1.7024,  24.42,   4,  0.37),
   (1.5905,  26.16,   3,  0.30),
   (1.5194,  27.41,  11,  0.28) );
VAR i:INTEGER;
BEGIN mdsp:=21; lat[1].syng:=2; vmax[1]:=500; nph:=1;
FOR i:=1 TO mdsp DO
 BEGIN dspa[i].d:=arr[i,1]; dspa[i].e:=0.01/SQRT(arr[i,3]);
 END;
ArrangeDSpacings;
au_comm:='True: unknown';
END;
PROCEDURE TestAutoindexing;
VAR i:INTEGER;
BEGIN L0rec:='Set the data for autoindexing test';
MakeForm(0);
s:=SelOps; OuttoLabel(Form2.Label9,5,10,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=6; indx:=1;
 ar[1]:=' Set ZrO2 data';
 ar[2]:=' Set OrthoRhombic';
 ar[3]:=' Set Cubic';
 ar[4]:=' Set Triclinic';
 ar[5]:=' Set 2 Phases(Monoc+Cub)';
 ar[6]:=' Set Chernyshev data';
 ar[7]:=' Set UPPW6 data';
 END;
MakeRadioGroup(1,0,40,50,250,140);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 END;
CASE i OF
0: SetZrO2;
1: SetOrthoRh;
2: SetCubic;
3: SetTriclinic;
4: Set2Phases;
5: SetChernyshev;
ELSE END;
END;
PROCEDURE Set2Phases;
CONST ar:ARRAY[1..30] OF REAL = (
 {5-661 * CuO Copper Oxide  Monoclinic = 4.684, 3.425, 5.129, 99.47}
 2.751,2.530,2.523,2.323,2.312,1.959,1.866,1.778,1.714,1.581,
 1.505,1.418,1.410,1.375,1.304,
 {6-289 * RbCl Rubidium Chloride  Cubic 6.58}
 3.8,3.291,2.327,1.984,1.900,1.645,1.510,1.472,1.343,1.266,
 1.1637,1.1123,1.0968,1.0404,1.0034
 );
CONST er:ARRAY[1..30] OF REAL = (
 0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,
 0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,
 0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002
 );
VAR i:INTEGER;
BEGIN mdsp:=30; lat[1].syng:=2; lat[2].syng:=5; nph:=2;
vmax[1]:=100; vmax[2]:=500; FOR i:=1 TO mdsp DO
 BEGIN dspa[i].d:=ar[i]; dspa[i].e:=er[i];
 END;
ArrangeDSpacings;
au_comm:=
 'True: A1=4.68  B1=3.43  C1=5.13  b1=99.5  A2=6.58  V1=81  V2=285'
END;
PROCEDURE SetTriclinic;
{       11-646     Triclinic
 CuSO_4.5H_2O  l=1.5405   F_30 = 37.8 (.021,37)}
CONST ar:ARRAY[1..30] OF REAL = (
 10.4,5.73,5.68,5.48,5.21,5.15,4.84,4.73,4.66,4.28,
 4.00,3.99,3.71,3.57,3.54,3.48,3.45,3.30,3.26,3.18,
 3.06,3.05,2.978,2.904,2.880,2.867,2.838,2.824,2.788,2.749
 );
CONST er:ARRAY[1..30] OF REAL = (
 0.01,0.003,0.005,0.002,0.01,0.005,0.01,0.001,0.005,0.008,0.009,0.002,
 0.001,0.01,0.005,0.01,0.006,0.001,0.005,0.006,0.007,0.003,0.01,0.009,
 0.01,0.002,0.005,0.002,0.003,0.003
 );
VAR i:INTEGER;
BEGIN mdsp:=30; lat[1].syng:=1; vmax[1]:=500; nph:=1;
FOR i:=1 TO mdsp DO
 BEGIN dspa[i].d:=ar[i]; dspa[i].e:=er[i];
 END;
ArrangeDSpacings;
au_comm:='True: A=10.7  B=6  C=6.1  a=107  b=103  g=82   V=363'
END;
PROCEDURE SetOrthoRh;
{a-Pb_4O_3Cl_2 l=1.54200 (A)       6-405     Orthorhombic
 a=13.06  b= 5.58  c= 5.62  F_12=2.4 (0.117,43)}
CONST ar:ARRAY[1..12] OF REAL = (
 6.50,3.75,3.26,2.92,2.77,2.18,2.12,1.965,1.741,1.714,1.686,1.629);
CONST er:ARRAY[1..12] OF REAL = (
 0.003,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,0.002,
 0.002);
VAR i:INTEGER;
BEGIN mdsp:=12; lat[1].syng:=3; vmax[1]:=500; nph:=1;
FOR i:=1 TO mdsp DO
 BEGIN dspa[i].d:=ar[i]; dspa[i].e:=er[i];
 END;
ArrangeDSpacings;
au_comm:='True: A=6.98  B=9.18  C=6.50  V=416.6 eps=0.00197'
END;
PROCEDURE TestUpeak;
VAR i:INTEGER; z:REAL;
BEGIN L0rec:='Set the data for peak analysis test';
MakeForm(0);
s:=SelOps; OuttoLabel(Form2.Label9,5,10,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=5; indx:=1;
 ar[1]:=' Set small peak spectrum';
 ar[2]:=' Set bala spectrum';
 ar[3]:=' Set Assymmetric-Peak Spectrum';
 ar[4]:=' Set exponential spectrum';
 ar[5]:=' Set torok data';
 END;
MakeRadioGroup(1,0,40,50,250,170);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 END;
CASE i OF
0: TestSmallSp;
1: TestBalaSp;
2: WITH taranh DO WITH spec[numsp] DO
    BEGIN FOR i:=1 TO n DO
     BEGIN y[i]:=taran[i]; e[i]:=SQRT(ABS(y[i])+1); x[i]:=i;
     END;
    a1:=1; a11:=1; a2:=n; a22:=a2; spin:=true; tofang:=2;
    spx:=23149; spn:=0; sfn:='taran.spc';
    END;
3: WITH spec[numsp] DO
    BEGIN FOR i:=1 TO 512 DO
     BEGIN z:=i; y[i]:=1000*EXP(-z/15)+500*EXP(-z/35)+300*EXP(-z/75)+25;
     e[i]:=SQRT(y[i]+1); x[i]:=i;
     y[i]:=AMAX1(0,y[i]+(rndm(-1)-0.5)*e[i]);
     END;
    a1:=1; a11:=1; a2:=512; a22:=a2; spin:=true; tofang:=2;
    spx:=1761; spn:=0; sfn:='expo.spc';
    END;
4: WITH torokh DO WITH spec[numsp] DO
    BEGIN FOR i:=1 TO n DO
     BEGIN y[i]:=torok[i]; e[i]:=0.01; x[i]:=i;
     END;
    a1:=1; a11:=1; a2:=n; a22:=a2; spin:=true; tofang:=2;
    spx:=29; spn:=0; sfn:='torok.spc';
    END;
ELSE END;
END;
PROCEDURE TestBalaSp;
VAR i:INTEGER;
BEGIN WITH balah DO WITH spec[1] DO
 BEGIN FOR i:=1 TO n DO
  BEGIN y[i]:=bala[i]; e[i]:=SQRT(ABS(y[i])+1); x[i]:=i;
  END;
 a1:=1; a11:=1; a2:=n; a22:=a2; spin:=true; tofang:=2;
 spx:=145387; spn:=-399; sfn:='bala.spc';
 END;
END;
PROCEDURE SetZrO2;
CONST ar:ARRAY[1..18] OF REAL = (
 3.70169,3.64325,3.16788,2.84455,2.60991,2.54369,2.34525,2.32216,
 2.25584,2.19429,2.06860,2.02282,1.99292,1.86184,1.82162,1.80594,
 1.61282,1.59463
 );
CONST er:ARRAY[1..18] OF REAL = (
 0.003,0.001,0.002,0.003,0.001,0.001,0.001,0.002,0.001,0.002,0.002,
 0.001,0.003,0.002,0.001,0.001,0.002,0.001
 );
CONST xr:ARRAY[1..18] OF REAL = (
 707.3,696.1,605.5,543.8,499.0,486.4,448.6,444.1,431.5,419.8,395.8,
 387.0,381.3,356.3,348.7,345.7,308.8,305.4
 );
VAR i:INTEGER;
BEGIN mdsp:=18; lat[1].syng:=2; vmax[1]:=150; nph:=1;
r:=0.001; FOR i:=1 TO mdsp DO WITH dspa[i] DO
 BEGIN d:=ar[i]*(1+r); r:=r*(-1); e:=er[i]; x:=xr[i];
 END;
ArrangeDSpacings;
au_comm:='True: A=5.32  B=5.22  C=5.15  b=99.3  V=141.2';
END;
PROCEDURE SetCubic;
{         6-696     Cubic  alpha-Fe l=1.5405  a=2.8664 F6=225.2}
CONST ar:ARRAY[1..6] OF REAL = (
 2.0268,1.4332,1.1702,1.0134,0.9064,0.8275);
CONST er:ARRAY[1..6] OF REAL = (
 0.0001,0.0003,0.0002,0.0005,0.0005,0.001);
VAR i:INTEGER;
BEGIN mdsp:=6; lat[1].syng:=5; vmax[1]:=50;
FOR i:=1 TO mdsp DO
 BEGIN dspa[i].d:=ar[i]; dspa[i].e:=er[i];
 END;
ArrangeDSpacings; au_comm:='True: A=2.03'
END;
PROCEDURE TestRietveld;
VAR i,j:INTEGER; mn:STRING; Fc,Fs,Fm:REAL;
LABEL L1;
BEGIN {Form ZrO2 spectra} FOR i:=1 TO 1024 DO
 BEGIN spec[1].y[i]:=0; spec[2].y[i]:=0;
 spec[1].e[i]:=1; spec[2].e[i]:=1;
 END;
nsp:=1; nph:=1; FOR i:=1 TO 746 DO
 BEGIN spec[1].y[i+59]:=zro2[i]; spec[2].y[i+159]:=zro2[i]*1.25;
 spec[1].e[i+59]:=SQRT(zro2[i]); spec[2].e[i+159]:=SQRT(zro2[i])*1.25;
 END;
WITH spec[1] DO
 BEGIN a1:=1; a2:=1024; a11:=305; a22:=740; dback:=5;
 sfn:='\zlok\z.spc'; effn:=false; absn:=false;
 w0:=6.714; w1:=1.461; dw0:=2; dw1:=1; spin:=true; smosp:=1;
 FPath:=25; chw:=64; delay:=-1.187; Theta:=75;
 w0:=5; w1:=0; dw0:=4; dw1:=10; FOR j:=1 TO 6 DO bkpar[j]:=0;
 END;
WITH spec[2] DO
 BEGIN a1:=1; a11:=405; a22:=840; dback:=5; delay:=-101.187; spin:=true;
 w0:=6.714; w1:=1.461; dw0:=2; dw1:=1; sfn:='\zlok\zz.sp';
 FPath:=25; chw:=64; Theta:=75; w0:=5; w1:=0; dw0:=4; dw1:=10;
 effn:=false; absn:=false; FOR j:=1 TO 6 DO bkpar[j]:=0; smosp:=1;
 END;
WITH lat[1] DO
 BEGIN WITH lpd DO
  BEGIN a:=5.15367; b:=5.21982; c:=5.31867;
  alpha:=90; beta:=99.199; gamma:=90;
  {a:=5.14519; b:=5.21024; c:=5.31226;}
  {a:=5.15679; b:=5.22174; c:=5.32191;}
  END;
 nsg:=14; sett:=2; nat:=4; {keycos:=0;} syng:=syngon(nsg,sett); coW:=1;
 SetSpaceGroupInfo(1);
 vol:=getvol(lpd); InverseLatPar(lpd,lpi,voli,0); FormLatMatrix(1);
 END;
WITH atoms[1,1] DO
 BEGIN name:='Zr'; occ:=0.98; x:=0.27580; y:=0.04040; z:=0.20890;
 t11:=0.15; t12:=0; t13:=0; t22:=0; t23:=0; t33:=0;
 END;
WITH atoms[2,1] DO
 BEGIN name:='O'; occ:=1; x:=0.0690; y:=0.34200; z:=0.3450; t11:=0.4;
 t12:=0; t13:=0; t22:=0; t23:=0; t33:=0;
 END;
WITH atoms[3,1] DO
 BEGIN name:='O';  occ:=1; x:=0.45100; y:=0.75800; z:=0.47900;
 t11:=0.2; t12:=0; t13:=0; t22:=0; t23:=0; t33:=0;
 END;
WITH atoms[4,1] DO
 BEGIN name:='Hf'; occ:=0.02; x:=0.27580; y:=0.04040; z:=0.20890;
 t11:=0.15; t12:=0; t13:=0; t22:=0; t23:=0; t33:=0;
 END;
WITH lat[1] DO
 BEGIN FOR i:=1 TO nat DO
  BEGIN mn:=atoms[i,1].name;
  UpCaseStr(mn); Compress(mn); IF(Length(mn)=1)THEN mn:=' '+mn;
  FOR j:=1 TO 100 DO IF(mn=elch[j])THEN GOTO L1;
  L1: WITH atoms[i,1] DO
   BEGIN name:=mn; scat:=sctlen[j]; rad:=radius[j]; aw:=atomwt[j];
   sigs:=afsigs[j]; siga:=afsiga[j];
   END;
  END;
 END;
cadl:=436;  {cb.damp:=0.05; cb.step:=0.95;}
FormMillerIndices(1.577,3.8889,1);
FOR i:=1 TO lat[1].nhkl DO WITH hkla[i,1] DO
 BEGIN StructFactor(0,1,h,k,l,mul,0,Fc,Fs,Fm);
 Fkc:=Fc; Fks:=Fs; Fkm:=Fm;
 END;
nophasi:=false;
WITH spec[1] DO FOR i:=a1 TO a2 DO x[i]:=chtod(Float(i));
WITH spec[2] DO FOR i:=a1 TO a2 DO x[i]:=chtod(Float(i));
END;
PROCEDURE TestMode;
VAR i:INTEGER; ok:BOOLEAN;
BEGIN
END;
PROCEDURE TestSmallSp;
CONST spmord:ARRAY[1..1619] OF REAL = (
43,63,66,61,51,57,61,56,49,52,49,60,49,51,62,57,47,59,48,42,50,52,63,80,
81,96,114,96,71,51,63,54,56,57,41,43,46,34,48,62,61,41,40,50,54,55,47,
53,49,58,50,46,52,51,57,44,47,78,36,50,51,55,48,63,48,55,48,54,57,52,45,
60,64,59,51,43,56,66,63,54,54,53,52,60,52,51,53,75,78,64,63,65,76,73,99,
138,167,285,436,464,428,313,209,147,90,58,77,57,46,44,67,54,46,57,49,48,
58,43,54,52,59,89,85,131,219,322,432,647,682,620,454,259,144,71,56,46,
52,34,56,33,37,38,34,43,40,36,32,32,37,33,33,28,37,44,38,44,45,41,40,34,
36,40,47,28,31,36,38,37,45,37,46,34,38,35,28,36,28,24,45,27,34,41,36,34,
29,33,26,44,27,18,26,41,29,37,37,43,31,41,34,35,37,36,57,44,68,69,81,95,
108,99,117,100,123,164,164,162,138,105,74,60,36,40,27,29,34,29,30,42,30,
28,34,29,47,51,72,79,76,80,80,61,56,42,58,54,37,43,37,39,31,35,24,24,29,
38,31,38,38,26,32,31,22,24,22,35,33,36,30,26,26,30,29,39,25,25,31,30,37,
26,21,28,27,35,36,33,23,34,33,31,25,24,33,29,26,29,35,22,31,24,45,19,28,
22,29,21,22,24,19,19,20,18,22,17,16,15,17,29,24,28,12,19,28,14,23,24,14,
20,19,23,18,14,15,25,30,15,18,11,16,18,27,24,22,25,15,18,20,17,20,13,21,
15,20,18,29,12,21,23,25,19,25,20,15,28,23,17,22,27,16,16,20,31,21,24,22,
20,16,28,20,17,23,19,21,11,19,22,21,21,12,19,21,11,21,22,27,23,21,15,15,
18,16,20,15,18,19,16,14,19,13,20,20,12,14,18,23,9,15,16,15,15,14,11,13,
16,19,14,9,15,19,11,19,12,6,21,12,8,8,7,10,13,14,16,9,11,12,12,11,14,14,
9,16,16,22,14,13,11,14,18,16,8,17,10,9,8,10,10,9,13,8,12,13,6,8,11,7,12,
13,10,10,13,11,11,8,7,12,9,5,11,10,4,16,11,13,7,11,13,8,15,8,11,13,9,5,
7,9,10,11,17,12,10,13,12,11,10,13,10,9,11,14,7,20,19,29,42,49,60,69,70,
47,43,21,23,9,12,10,8,9,8,15,10,9,9,13,9,5,14,11,10,10,10,9,5,4,12,9,6,
8,9,9,10,9,10,11,12,6,5,12,9,7,12,9,4,11,5,8,9,4,15,5,8,10,8,2,6,5,9,3,
4,6,10,8,9,6,9,8,10,7,7,5,9,11,9,8,7,13,16,7,14,19,18,29,20,14,10,11,14,
10,9,6,12,9,9,6,9,8,9,13,6,5,8,7,9,8,11,9,9,8,15,9,8,8,13,6,4,7,7,10,6,
9,8,9,5,7,3,10,7,9,4,9,3,9,8,5,8,10,5,7,8,6,5,6,12,11,8,3,8,6,7,13,6,6,
8,8,5,11,3,5,12,7,5,6,11,7,5,8,5,8,5,2,6,7,12,7,7,4,8,5,7,9,6,1,9,2,6,4,
5,3,8,8,4,8,8,10,8,6,10,8,10,7,3,3,10,4,4,5,4,6,5,11,6,8,9,5,7,5,4,7,8,
6,8,5,6,7,3,5,7,4,6,2,3,2,10,7,1,8,4,5,0,8,4,4,8,6,8,4,5,12,5,4,3,9,6,9,
7,7,6,7,10,16,8,9,9,3,1,3,0,4,6,4,1,6,3,5,4,4,6,7,3,7,4,3,6,6,9,5,8,3,4,
5,3,6,8,4,5,11,7,4,10,2,3,8,5,5,2,0,1,8,8,9,4,8,4,7,7,7,5,7,3,4,2,2,5,1,
2,4,4,4,4,2,7,3,5,7,4,13,7,2,6,3,7,3,6,5,1,9,1,7,12,2,3,9,4,5,4,2,1,3,2,
7,8,4,2,5,5,11,4,4,8,7,7,5,11,6,6,4,4,1,5,8,7,11,7,7,3,5,3,7,6,7,4,5,1,
7,3,9,8,6,3,6,5,6,4,3,3,6,8,11,8,5,5,4,4,8,5,7,4,8,6,6,2,7,5,5,5,5,10,6,
3,4,6,7,3,5,11,3,7,4,11,8,5,4,8,3,7,6,4,4,4,7,2,6,2,3,10,5,4,8,7,8,6,3,
1,9,4,6,4,5,6,7,3,2,11,5,9,4,4,6,8,13,11,20,22,44,60,109,125,189,197,
184,144,106,74,49,18,12,11,9,5,2,4,7,3,3,6,3,4,1,11,6,5,2,2,7,5,4,2,5,1,
4,4,7,4,7,5,6,4,6,4,3,5,9,5,1,2,3,2,2,1,3,1,4,6,4,6,4,3,4,2,4,3,6,2,3,7,
6,3,5,4,4,6,4,4,4,6,4,0,6,3,6,1,6,9,2,3,5,3,1,2,3,4,6,3,3,4,1,2,1,3,4,4,
7,5,6,3,2,6,9,6,4,7,1,3,4,3,1,2,8,6,4,8,3,4,2,7,3,3,2,3,7,5,5,5,4,4,3,6,
7,2,6,1,7,2,2,2,7,7,3,8,1,6,1,3,8,5,5,4,5,1,4,4,5,4,6,3,9,4,8,3,2,6,6,9,
5,6,6,2,7,3,2,5,4,5,1,9,6,3,2,3,3,6,6,3,5,3,2,2,6,8,1,4,6,8,5,2,9,5,9,9,
7,7,12,8,17,10,22,25,54,90,137,208,369,415,513,543,589,456,336,215,144,
65,24,16,4,4,2,2,6,2,2,0,3,1,4,4,5,4,3,1,5,3,6,0,3,2,3,1,4,2,1,2,3,3,5,
2,1,2,2,1,2,1,1,4,2,2,4,0,2,4,1,1,6,1,1,2,0,3,2,1,2,1,1,2,0,2,5,3,2,3,2,
2,2,2,1,5,2,1,1,1,2,2,1,1,3,4,0,4,3,1,1,2,2,3,2,2,2,0,2,4,1,0,2,0,0,1,0,
0,4,1,1,2,2,1,1,4,2,2,1,0,1,2,1,0,1,2,2,2,2,5,0,1,1,2,3,0,3,2,2,1,2,0,0,
1,2,1,1,1,4,0,2,1,1,1,1,2,0,2,2,1,1,0,2,2,1,3,3,2,4,1,0,1,1,1,2,3,3,0,3,
0,1,4,3,3,2,0,0,0,0,2,1,0,3,1,0,2,0,2,1,0,1,1,1,2,0,2,1,0,1,0,1,1,1,3,1,
0,0,0,2,0,1,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,1,0,1,0,1,1,0,1,0,1,0,0,0,1,
0,0,0,1,0,0,3,0,0,0,0,1,1,0,2,0,1,0,1,1,0,0,0,3,0,0,0,0,1,0,1,1,1,0,3,0,
0,1,0,0,1,0,0,0,1,1,1,1,0,0,1,0,1,1,0,0,0,1,0,1,0,0,1,0,1,3,1,1,1,1,6,8,
3,7,12,8,21,23,14,26,16,13,9,8,3,1,4,2,0,0,0,0,0,0,1,1,1,0,1,0,0,0,1,0,
0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1);
VAR i:INTEGER;
BEGIN WITH spec[numsp] DO
 BEGIN FOR i:=1 TO 1619 DO y[i]:=spmord[i]; e[i]:=SQRT(ABS(y[i])+1);
 a1:=1; a2:=1619; a11:=1; a22:=1619; spin:=true; tofang:=2;
 spx:=682; spn:=0; sfn:='small.spc';
 END;
END;
PROCEDURE SettheTestData;
VAR i,j:INTEGER; r:REAL;
BEGIN L0rec:='Set up the spectrum'; MakeForm(0);
s:=SelOps; OuttoLabel(Form2.Label5,5,10,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=4; indx:=1;
 ar[1]:='Set up '+'ZrO2 Spectrum';
 END;
MakeRadioGroup(1,0,50,30,200,200);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 END;
CASE i OF
0: WITH spec[numsp] DO
  BEGIN FOR i:=1 TO 746 DO
   BEGIN IF(i<=59)THEN r:=0 ELSE r:=zro2[i];
   y[i]:=r; e[i]:=SQRT(r); x[i]:=j;
   END;
  a1:=1; a2:=746; a11:=305; a22:=740; dback:=5; sfn:='ZrO_2.spc';
  w0:=6.714; w1:=1.461; dw0:=2; dw1:=1; spin:=true; smosp:=1;
  FPath:=25; chw:=64; delay:=-1.187; Theta:=75;
  w0:=5; w1:=0; dw0:=4; dw1:=10; FOR j:=1 TO 6 DO bkpar[j]:=0;
  END;
ELSE END;
END;
PROCEDURE ViewResFile;
VAR s:STRING; i:INTEGER;
BEGIN L0rec:=''; MakeFormV(0,0,630,430,0);
MakeMemo(5,610); Form2.Memo1.Clear;
{$I-} Reset(fout); {$I+};
WHILE(NOT EoF(fout))DO
 BEGIN Readln(fout,s); Form2.Memo1.Lines.Add(s);
 END;
Form2.ShowModal;
CloseFile(fout); AssignFile(fout,outfn); Rewrite(fout);
WITH Form2.Memo1.Lines DO FOR i:=1 TO Count DO
 BEGIN s:=Strings[i-1]; Writeln(fout,s);
 END;
END;
{----}
END.

*******************************************
TYPE TMat55  = ARRAY[1..5,1..5] OF BYTE;

TYPE TLetter = CLASS
  mat:TMat55;
  sum:INTEGER;    {Sum of units}
  PUBLIC { Public declarations }
  PROCEDURE GetSum;
  PROCEDURE GetStr;
  PRIVATE { Private declarations }
  END;
TYPE MATRA = ARRAY[1..8,1..8] OF REAL;
PROCEDURE Multiply(VAR k:INTEGER; VAR mx:REAL);

CONST alet:TMat55 = ((0,0,1,0,0),(0,1,0,1,0),(0,1,0,1,0),(0,1,1,1,0),
                     (0,1,0,1,0));
      blet:TMat55 = ((0,1,1,0,0),(0,1,0,1,0),(0,1,1,0,0),(0,1,0,1,0),
                     (0,1,1,0,0));
VAR i:INTEGER;
    a,b,c,mat:MATRA;
    lets:ARRAY[1..5] OF TLetter; slet:ARRAY[1..5] OF STRING[5];
    letc:TLetter;
PROCEDURE FormAlphaB;
VAR i,j,k:INTEGER; s,sr:STRING; ch1,ch2:CHAR;
BEGIN AssignFile(ft,'\zlok\a.sav'); Rewrite(ft);
FOR ch1:='A' TO 'F' DO
 BEGIN FOR ch2:='A' TO 'Z' DO
  BEGIN s:=ch1+ch2; Writeln(ft,s);
  END;
 FOR ch2:='0' TO '9' DO
  BEGIN s:=ch1+ch2; Writeln(ft,s);
  END;
 END;
CloseFile(ft);
END;
PROCEDURE TLetter.GetSum;
VAR i,j:INTEGER;
BEGIN sum:=0; FOR i:=1 TO 5 DO FOR j:=1 TO 5 DO sum:=sum+mat[i,j];
END;
*         3-643
* sodium phosphate, parameters unknown
*Weights:  0.004 0.004 0.003 0.008 0.013 0.013 0.010 0.010
4.61 3.45 2.95 2.55 1.77 1.66 1.50 1.42
*         3-906     Orthorhombic
*AgN3 l=0.70926  Ibam (72)
* a=5.58  b= 5.93  c= 6.04  F_17=6.6 (0.0071,37)
4.08 2.97 2.80 2.41 2.11 2.04 1.86 1.78 1.68 1.58
1.53 1.50 1.41 1.33 1.27 1.23 1.20
*         4-664     Cubic
* LiCl      l=1.5405   (225 F)
* a=5.1396   F_14 = 135.1 (.0078, 9)
2.967 2.570 1.817 1.550 1.484  1.285 1.1791 1.1493 1.0491 0.9892
0.9086 0.8688 0.8566 0.8126
* Weight Int.:
100 86 58 29 16 4 10 12 8 9 2 10 6 4
*         4-784     Cubic
* AU-aurum  l=1.54056  (225 F)
* a=4.0786   F_9 = 128.5 (.0078, 9)
2.3550 2.0390 1.4420 1.2300 1.1774 1.0196 0.9358 0.9120 0.8325
* Weight Int.:
100 52 32 36 12 6 23 22 23
*         5-324
* C12 H12 N2 O3, l=2.2896
8.94   7.63   7.14   6.82   5.27   5.09   4.09   4.42   4.17   4.09
3.80   3.70   3.54   3.43   3.19   3.10   2.94   2.73   2.70   2.62
2.51   2.46   2.39   2.33   2.28   1.97   1.93   1.87   1.84
*         5-390     Cubic
* alpha-Sn  l=1.5405  a=6.489 F15=54
3.751 2.294 1.956 1.622 1.489   1.325 1.249 1.147 1.0968 1.0260
0.9895 0.9365 0.9087 0.8671 0.8450
* Weight Int.:
100 83 53 12 20 21 11 6 10 9 4 3 7 13 12
*         5-392     Monoclinic
* W18 O49  l=1.5418  a=18.28 b=3.775 c=13.98 be=115.2
12.9   8.27  6.54  6.11  5.22     4.59  4.54  4.43  4.37  3.78
 3.73  3.63  3.48  3.44  3.40     3.39  3.31  3.25  3.21  3.17
 3.05  3.02  2.958 2.937 2.910
* Weights Int.:
  35  15  5  10  10      15  10  20  10  100    50  55  5  55  40
  50   5 15   5  30      10  15  15  15   40
*         5-661     Monoclinic
* CuO Copper Oxide  l=1.5405
* a=4.684 b=3.425 c=5.129 be=99.47     F30=17.5(.037,46)
2.751  2.530  2.523  2.323  2.312     1.959  1.866  1.778  1.714  1.581
1.505  1.418  1.410  1.375  1.304     1.265  1.262  1.196  1.170  1.162
1.1585 1.1556 1.1233 1.0916 1.0737    1.0394 1.0178 1.0074 0.9921 0.9808
* Weight Int.
12 49 100 96 30  3 25 2 8 14   20 12 15 19 7   6 7 2 5 3
2 4 2 6 2  1 3 4 1 4
*         5-667     Cubic
* Cu2O    l=1.5405  a=4.2696 F12=48
3.020 2.465 2.135 1.743 1.510   1.287 1.233 1.0674 0.9795 0.9548
0.8715 0.8216
* Weight Int.:
9 100 37 1 27 17 4 2 4 3 3 3
*         6-289     Cubic
* RbCl Rubidium Chloride  l=1.5405  a=6.5810 F24=70.9(.0141,24)
3.8    3.291  2.327  1.984  1.900     1.645  1.510  1.472  1.343  1.266
1.1637 1.1123 1.0968 1.0404 1.0034     .9920  .9497  .9215  .9126  .8794
 .8568  .8227  .8040  .7980
* Weight Int.:
30 100 65 14 20  10 4 20 14 4   4 2 6 6 2  4 2 2 4 6  2 2 2 4
*         6-696     Cubic
* alpha-Fe l=1.5405  a=2.8664 F6=225.2
2.0268 1.4332 1.1702 1.0134 0.9064 0.8275
* Weight Int.:
100 20 30 10 12 6
*         9-466     Triclinic
* NaAlSi_3O_8 l=1.5405   F_30=19.2(.013,122)
* a=8.144 b=12.787 c=7.160 al=94.26 be=116.6 ga=87.67
6.39 5.94 5.59 4.03 3.857  3.780 3.684 3.663 3.509 3.484
3.375 3.196 3.151 2.964 2.933  2.866 2.843 2.787 2.639 2.563
2.538 2.511 2.496 2.460 2.443  2.431 2.405 2.388 2.320 2.278
* Weight Int.:
20 2 2 16 8  25 20 16 10 2  8 100 10 10 16
8 2 2 6 8  2 2 6 6 4  2 2 4 4 2
*        12-848     Triclinic
* CH_2(CO_2H)_2 Malonic Acid l=1.5405   F_30 = 69.4 (.010,42)
* a=5.341 b=8.403 c=5.156 al=100.72 be=94.98 ga=108.47
7.76 5.06 5.00 4.72 3.85       3.83 3.75 3.67 3.58 3.54
3.47 3.34 3.29 3.16 2.863      2.778 2.705 2.691 2.660 2.621
2.557 2.546 2.531 2.502 2.441  2.394 2.360 2.267 2.252 2.238
*Weight Int.:
5 5 45 75 3    45 100 3 45 50    1 7 19 3 3
1 35 50 15 19  1 3 7 13 3        5 17 11 3 5
*        13-676a
* L-LysineDihydrochloride
* a=      b=      c=      al=       be=      ga=
1.347 1.292 1.244 1.226 1.208 1.185 1.157
*Weight Int.:
2 2 2 2 2  2 2      Monoclinic
*        22-0257
* g-DyCl3, l=1.5418
* a=6.91 b=11.97 c=6.40 beta=111.2 F-15 = 1.9 (0.058,138)
6.45  5.95  5.63  3.38  3.24  2.817 2.727 2.483 2.111 2.055
1.989 1.882 1.718 1.657 1.608
*  CuNiAl 2 phases (3.83,3.89,11.65),(4.18)
3.6378 2.9143 2.7489 2.7273 2.3314 2.2330 1.9913 1.9446 1.9145 1.7338
1.6176 1.6001 1.5826 1.5710 1.4933 1.4796 1.4571 1.3744 1.3643 1.2952
1.2356 1.2126 1.1775 1.1661 1.1165 1.0780
2.0915 1.4789 1.2076 1.0458
* (20-1817, oxalic acid, Monocl,l=1.5405 )
* a=5.30 b= 6.09 c=5.51 beta=115.2 F-15 = 5.7 (0.109,21)
3.84  3.65  3.05  2.73  2.59  2.44  2.41  2.30  2.28  2.24
2.14  2.08  2.04  2.00

PROCEDURE SetW18;
{         5-392     Monoclinic
 W18 O49  l=1.5418  a=18.28 b=3.775 c=13.98 be=115.2}
CONST ar:ARRAY[1..25] OF REAL = (
 12.9,8.27,6.54,6.11,5.22,4.59,4.54,4.43,4.37,3.78,3.73,3.63,3.48,3.44,
 3.40,3.39,3.31,3.25,3.21,3.17,3.05,3.02,2.958,2.937,2.910 );
CONST er:ARRAY[1..25] OF REAL = (
 0.03,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.01,0.01,
 0.01,0.01,0.01,0.01,0.01,0.01,0.01,0.01,0.005,0.005,0.005);
VAR i:INTEGER;
BEGIN mdsp:=25; lat[1].syng:=2; vmax[1]:=1200;
FOR i:=1 TO mdsp DO
 BEGIN dspa[i].d:=ar[i]; dspa[i].e:=er[i];
 END;
ArrangeDSpacings;
END;
  HKL_max/min_ph1    4  -4    4  -4    4    V_max=    500   N_ref=  364
  Par_max_ph1   21.30   21.30   21.30  135.00  135.00   90.00
  Par_min_ph1    2.00    2.00    2.00   90.00   90.00   60.00
* N of trials =     5184  Chi2/df =       0.76   Dif(A) = 0.00325

    Phase No 1   Vol=   362.38

  A = 6.1164     6.1164  +-  0.0073
  B = 11.0942    11.0942  +-  0.0089
  C = 7.1554     5.9647  +-  0.0089

  alpha = 105.09     87.96  +-    0.05
  beta  = 127.29     72.63  +-    0.04
  gamma =  70.16     70.16  +-    0.05

        Powder Indexing
   N    h    k    l phase     d_exp     d_fit      Dif.   chi2
   1    0    1    0        10.40000  10.40785   0.00785   0.6
   2   -1   -1    1         5.73000   5.73084   0.00084   0.1
   3    0    0    1         5.68000   5.67731  -0.00269   0.3
   4   -1    0    1         5.48000   5.47969  -0.00031   0.0
   5    0    2    0         5.21000   5.20392  -0.00608   0.4
   6    0   -1    1         5.15000   5.14489  -0.00511   1.0
   7    0    1    1         4.84000   4.83737  -0.00263   0.1
   8    1    0    0         4.73000   4.72804  -0.00196   3.8
   9   -1   -2    1         4.66000   4.65966  -0.00034   0.0
  10   -1    1    1         4.28000   4.27876  -0.00124   0.0
  11   -1   -2    0         4.00000   4.00182   0.00182   0.0
  12    0   -2    1         3.99000   3.98423  -0.00577   8.3
  13    0    2    1         3.71000   3.70351  -0.00649  42.1
  14   -1   -1    2         3.57000   3.56711  -0.00289   0.1
  15   -1   -3    1         3.54000   3.53270  -0.00730   2.1
  16    0    3    0         3.48000   3.46928  -0.01072   1.1
  17   -1    0    2         3.45000   3.45191   0.00191   0.1
  18   -1   -2    2         3.30000   3.30192   0.00192   3.7
  19   -1    2    1         3.26000   3.25467  -0.00533   1.1
  20   -1   -3    0         3.18000   3.17832  -0.00168   0.1
  21    0   -3    1         3.06000   3.06173   0.00173   0.1
  22   -1    1    2         3.05000   3.04686  -0.00314   1.1
  23   -2   -1    1         2.97800   2.98029   0.00229   0.1
  24   -2   -2    1         2.90400   2.90392  -0.00008   0.0
  25    1    1    1         2.88000   2.88296   0.00296   0.1
  26    0    3    1         2.86700   2.86836   0.00136   0.5
  27    0    0    2         2.83800   2.83866   0.00066   0.0
  28   -2    0    1         2.82400   2.82787   0.00387   3.7
  29    0   -1    2         2.78800   2.79099   0.00299   1.0
  30   -1   -4    1         2.74900   2.74552  -0.00348   1.3
Average  d - d_calc (A) =      0.00325
PROCEDURE TestThisOld;
VAR i,j,k,n:INTEGER; d,q,x,B,T,lamb,z,c,a,al,be,ga,v:REAL; vc:VECTOR;
BEGIN d:=3.7168; q:=1/SQR(d);
d:=1; q:=2; FOR i:=1 TO 300 DO
 BEGIN d:=d*(1-1/q); q:=q*2; Writeln(fout,d);
 END;
ShowMess(FloatToStr(d));Exit;
B:=10; T:=100; lamb:=1/T; c:=0; k:=0; n:=1000000;
FOR i:=1 TO n DO
 BEGIN x:=rndexp(lamb); IF(x<=B)THEN
  BEGIN c:=c+x; Inc(k);
  END;
 END;
q1:=c/n; q2:=c/k;
q3:=T-B*EXP(-B/T)/(1-EXP(-B/T)); q4:=1-EXP(-B/T);
Writeln(fout,q1:10:4,q2:10:4,q3:10:4,q4:10:4);
FOR i:=1 TO 500 DO
 BEGIN z:=i*0.2; q4:=z-B*EXP(-B/z)/(1-EXP(-B/z))-q2;
 Writeln(fout,z:8:4,q4:8:4);
 END;
Exit;
WITH vc DO
 BEGIN x:=3; y:=4; z:=5;
 END;
Exit; r:=10.1222*8.9184*8.3845; ShowMess(FloatToStr(r));
{Writeln(fout,EuclNorm(vc));}
c:=10.1419; b:=8.9184; a:=10.122; be:=COS(131.12/radian);
al:=COS(90/radian); ga:=COS(90/radian); {My monocl.examp}
v:=DCellVolume(a,b,c,al,be,ga); Writeln(fout,'v0 = ',v:10:2);
Writeln(fout,a:10:4,b:10:4,c:10:4,be:9:2);
MakeMostRectAng(a,b,c,al,be,ga,v,2);
Writeln(fout,a:10:4,b:10:4,c:10:4,be:9:2);
v:=DCellVolume(a,b,c,al,be,ga); Writeln(fout,'v1 = ',v:10:2);
c:=10.1720; b:=18.3240; a:=9.8680; be:=COS(117.55/radian);
al:=COS(90/radian); ga:=COS(90/radian); {Armel's monocl.examp}

v:=DCellVolume(a,b,c,al,be,ga); Writeln(fout,'v0 = ',v:10:2);
Writeln(fout,a:10:4,b:10:4,c:10:4,be:9:2);
MakeMostRectAng(a,b,c,al,be,ga,v,2);
v:=DCellVolume(a,b,c,al,be,ga); Writeln(fout,'v1 = ',v:10:2);
c:=10.1198; a:=8.3798; be:=COS(114.32/radian); {LeBail's example}
a:=11.1095; b:=6.1153; c:=5.9683; {triclinic most rectang.}
al:=COS(107.41/radian); be:=COS(92.10/radian); ga:=COS(70.19/radian);
v:=DCellVolume(a,b,c,al,be,ga); Writeln(fout,'v0 = ',v:10:2);
MakeMostRectAng(a,b,c,al,be,ga,v,1);
v:=DCellVolume(a,b,c,al,be,ga); Writeln(fout,'v1 = ',v:10:2);
Writeln(fout,a:9:4,b:9:4,c:9:4,v:10:2);
Writeln(fout,arccos(al)*radian:9:2);
Writeln(fout,arccos(be)*radian:9:2);
Writeln(fout,arccos(ga)*radian:9:2);
END;

PROCEDURE TestArith2(VAR y,w,f:REAL; i,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
    f  = a*(1-s)*exp(-(x-p)^2/w^2) + hi*s*exp")
 computes function value + 1-st derivatives, Dec 20 2004}
VAR w2,ff,hi,wi,si,r,ex,x,z,a,sic:REAL; j:INTEGER;
BEGIN y:=spec[numsp].y[i]; w:=1/(y); x:=FLOAT(i); WITH testlsm DO
 BEGIN drv[7]:=0; drv[8]:=0; f:=0;
 wi:=par[7].p; sic:=par[8].p; w2:=wi*wi;
 FOR j:=1 TO 3 DO
  BEGIN a:=par[2*j-1].p; z:=(x-par[2*j].p)/wi; ex:=exp(-SQR(z));
  CASE j OF
  1: hi:=0;
  2: hi:=0;
  3: hi:=1;
  ELSE END;
  si:=sic*hi; ff:=2*SQR(z)-1; r:=(1-si+2*si*ff/w2); f:=f+a*ex*r;
  IF(oktest)THEN Writeln(fout,i:7,z:8:2,ex:8:2,ff:8:2,r:8:2);
  drv[2*j-1]:=ex*r;
  drv[2*j]:=-2*a*ex*z/wi*(si-1-2*si/w2*ff+4*si/w2);
  drv[7]:=drv[7]+2*a*ex/wi*(z*z*r+(2*si-8*si*z*z)/w2);
  drv[8]:=drv[8]+a*ex*(2*ff/w2-1);
  END;
 END;
END;
PROCEDURE TestArith1(VAR y,w,f:REAL; i,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
    f  = (a/w)*exp(-(x-p)^2/w^2) w=(wi^2+h_i*s^2)
 computes function value + 1-st derivatives, Dec 20 2004}
VAR hi,wi,r,ex,x,z:REAL; j:INTEGER;
BEGIN y:=spec[numsp].y[i]; w:=SQRT(y+1); x:=FLOAT(i); WITH testlsm DO
 BEGIN drv[7]:=0; drv[8]:=0; f:=0; wi:=par[7].p; FOR j:=1 TO 3 DO
  BEGIN
  CASE j OF
  1: hi:=0;
  2: hi:=0;
  3: hi:=1;
  ELSE END;
  wi:=par[7].p+hi*par[8].p; z:=(x-par[2*j].p)/wi; ex:=exp(-SQR(z));
  r:=par[2*j-1].p*ex;
  drv[2*j-1]:=ex/wi; drv[2*j]:=2*r*z/par[7].p/wi; f:=f+r/wi;
  drv[7]:=drv[7]+r*par[7].p/(wi*wi*wi)*(4*SQR(z)-1);
  drv[8]:=drv[8]+r*par[7].p*hi/(wi*wi*wi)*(4*SQR(z)-1);
  END;
 END;
END;


