UNIT vmriauto;
INTERFACE
USES Windows, Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,    vzlocom,  varfun,   vmria0,
     vmria2,  vgfit,    vmriahkl, vmriartv, vmriarit, vmriahlp, vmriafl,
     vspectr, vmriaup,  vpeaksr,  vmriainf, vmriacry, vmriarix,vstdcons,
     vmria00;


PROCEDURE PrepareAutoindexing;
PROCEDURE AutoIndexingFit;
PROCEDURE ArrangeHKL(h,k,l,syn:INTEGER; VAR zh,zk,zl:INTEGER);
PROCEDURE ShowAutoResults(mo:INTEGER);
PROCEDURE PrintAllReflections;
PROCEDURE MakeAutoIndexing;
PROCEDURE EnterdSpacings;
PROCEDURE FitFlightPathetc;
PROCEDURE OnlyIndexing(VAR ok:BOOLEAN; VAR f:REAL);
PROCEDURE TransformDErrors;
PROCEDURE DeleteDSpacings;
PROCEDURE PrintFinalState(ipr,npr:INTEGER);
PROCEDURE Make2ThtoD;
PROCEDURE CheckDStepsForSymm(iph,isy:INTEGER);
PROCEDURE ChangeDSpacings;
PROCEDURE EnterDFromScreen;

VAR enspm:INTEGER;  {enter d-spacings mode}
    refine:BOOLEAN; {refine peaks mode}
    m0,m00:INTEGER;

IMPLEMENTATION
PROCEDURE MakeAutoIndexing;
VAR   i,iop:INTEGER; {-1=autoindexing 0=norm 1=lattice par.}
LABEL Lbeg;
BEGIN IF(mdsp=0)THEN iop:=1 ELSE iop:=2;
Lbeg: L0rec:=aapi; MakeForm(0);
s:=selops; OuttoLabel(Form2.Label1,5,20,clGreen,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=13; indx:=iop;
 ar[1]:='         Enter D-spacings';
 ar[2]:=' Prepare the '+aapi;
 ar[3]:=' Make the '+aapi;
 ar[4]:=' Show Results';
 ar[5]:=' Save Results';
 ar[6]:=' Print all reflections';
 ar[7]:='         Refine Flight Path (or Lambda)';
 ar[8]:='         Transform the d-errors';
 ar[9]:='         Change d-spacings';
 ar[10]:='         Change Cell Parameters';
 ar[11]:=' Delete close d-spacings';
 ar[12]:=' 2thetas -> d';
 ar[13]:=' Exit';
 END;
MakeRadioGroup(1,0,10,40,290,320);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; i:=RadioGroup1.ItemIndex;
 END;
CASE i OF
0: BEGIN CheckSavings(ok,s); EnterdSpacings;
   iop:=2; IF(ModalRes=0)THEN iop:=1;
   END;
1: BEGIN CheckSavings(ok,s); IF(NOT ok)THEN Exit;
   IF(mdsp=0)THEN
    BEGIN ShowMess('Error, no d-spacings for indexing');
    iop:=1; GOTO Lbeg;
    END;
   IF(NOT auclass)THEN
    BEGIN aufit:=TAulsm.Create(27,27,mdsp); auclass:=true;
    WITH aufit DO
     BEGIN FormCB; cb.eps:=0.1; npar:=27; FormParameters; npar:=0;
     ntrnd:=1;
     END;
    END;
   PrepareAutoindexing; iop:=3;
   END;
2: BEGIN IF(noprep[2])THEN
    BEGIN ShowMess('First make the preparation'); iop:=2; GOTO Lbeg;
    END;
   AutoIndexingFit; nosavedA:=true; iop:=4;
   END;
3,4: BEGIN IF(nofit[2])THEN
    BEGIN ShowMess('First make the fitting'); iop:=3; GOTO Lbeg;
    END;
   ShowAutoResults(i-1); IF(i=3)THEN iop:=5 ELSE iop:=13;
   END;
5: BEGIN Makedk; PrintAllReflections; iop:=13;
   END;
6: FitFlightPathetc;
7: TransformDErrors;
8: ChangeDSpacings;
9: BEGIN IF(noprep[2])THEN
    BEGIN ShowMess('First make the preparation'); iop:=2; GOTO Lbeg;
    END;
   ChangeCellPars; iop:=3;
   END;
10: BEGIN DeleteDSpacings; iop:=2;
    END;
11: BEGIN Make2ThtoD; iop:=2;
    END;
12: Exit;
ELSE END;
GOTO Lbeg;
END;
PROCEDURE AutoIndexingFit;
{To organize the fitting of the lattice parameters,
 par contains the optimum lattice, dspa(ass,irfl,ph) optimum indices,
 to find multiphase lattice parameters by trial method, May 7 1991}
VAR   i,j,iph,ipsh,ni,itr:INTEGER; ok:BOOLEAN; r,rr:REAL;
LABEL Lend,Lag,Lfit;
 PROCEDURE MakeCurrS;
 BEGIN dispbut:=true; MakeCurrInfo; Form2.Button5.Visible:=false;
 Form2.Show;
 END;
BEGIN ntrT:=0; IF(keyAuto=-1)THEN {Only indexing}
 BEGIN OnlyIndexing(ok,r); ntrT:=1; MakeCurrS;
 PrintFinalState(1,1); ShowMess('Indexing done'); GOTO Lend;
 END;
L0rec:='Check the data and make the fit'; MakeForm(1);
Savehelp(MakeAuI_n,MakeAuI); s:='MODE = '+SetIndx.ar[keyAuto+2];
OuttoLabel(Form2.Label5,50,2,clGreen,clWhite,s);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:=' N of tries ='; strgrNn[1,1]:=aufit.ntries;
strgrT[2]:=' N of Iterations ='; strgrNn[2,1]:=cw.gnit;
strgrT[3]:=' Step =';       strgrNn[3,1]:=cw.step;
strgrT[4]:=' Damp =';       strgrNn[4,1]:=cw.damp;
strgrT[5]:=' Delta =';       strgrNn[5,1]:=cw.delta;
strgrT[6]:=' Beta =';       strgrNn[6,1]:=cw.beta;
strgrT[7]:=' Skip =';       strgrNn[7,1]:=cw.skip;
IF(keyAuto=1)THEN
 BEGIN FOR i:=1 TO mdsp DO dspa[i].ph:=1; cw.iconv:=0;
 {cw.drv:=true;} strgrNn[1,1]:=1;
 END;
PuttoTable(45,20,7,7,1,9);
OuttoLabel(Form2.Label6,5,175,clRed,clWhite,' Selection criterion ');
OuttoLabel(Form2.Label7,155,175,clTeal,clWhite,' Volume minimization ');
WITH CB1rec DO
 BEGIN nitems:=3; indx:=cw.liqu+1;
 ar[1]:='C'; ar[2]:='Least modulus'; ar[3]:='Least squares';
 END;
MakeRadioGroup(1,0,1,193,135,72);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=vmintyp+1;
 ar[1]:=' as A^2+B^2+C^2 '; ar[2]:=' as ABC ';
 END;
MakeRadioGroup(2,0,140,193,170,72);
WITH CB1rec DO
 BEGIN nitems:=5; ar[1]:=' Measures against bad reflections';
 ar[2]:=' Deterministic parameter trials';
 ar[3]:=' ALT parametrization ';
 ar[4]:=' Display current fitting';
 ar[5]:=' Use volume restriction';
 END;
IF(keyAuto<>1)THEN MakeCheckListBox(20,285,265,88);
FOR iph:=1 TO nph DO CheckDStepsForSymm(iph,lat[iph].syng);
WITH Form2.CheckListBox1 DO
 BEGIN Checked[0]:=BadRMes;
 Checked[1]:=false; IF(aufit.ntrnd<>0)THEN Checked[1]:=true;
 Checked[3]:=dispfit; Checked[4]:=volc;
 END;
WITH Form2 DO WITH aufit DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 7 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
 ntries:=Round(har[1]); WITH cw DO
  BEGIN gnit:=Round(har[2]); step:=har[3]; damp:=har[4]; delta:=har[5];
  beta:=har[6]; skip:=Round(har[7]); liqu:=RadioGroup1.ItemIndex+1;
  END;
 vmintyp:=RadioGroup2.ItemIndex;
 IF(NOT CheckListBox1.Checked[1])THEN ntrnd:=0 ELSE ntrnd:=ntrnd_0;
 BadRMes:=CheckListBox1.Checked[0];
 auparmod:=0; {IF(CheckListBox1.Checked[2])THEN auparmod:=1;}
 dispfit:=CheckListBox1.Checked[3]; volc:=CheckListBox1.Checked[4];
 IF(keyAuto=1)THEN
  BEGIN ntries:=1; ntrnd:=0;
  END;
 END;
{Check the data and number of reflections}
WITH aufit DO
 BEGIN FOR iph:=1 TO nph DO {Form the volume weights}
  BEGIN j:=(iph-1)*6+1; rr:=(par[j].p*par[j+1].p*par[j+2].p)/mdsp;
  qv[iph]:=1/AMAX1(1,powerRR(rr,0.677777));
  IF(vmintyp=1)THEN qv[iph]:=1/AMAX1(1,rr);
  END;
 END;
Lag: IF(aufit.ntrnd<>0)THEN  {  Deterministic S T E P S}
 BEGIN L0rec:='Set the bin amounts'; MakeForm(1);
 MaketheButton(Form2.Button7,50,265,130,20,'Calculate new N');
 strgrW[0]:=230; strgrW[1]:=70;
 s:='Number of bins in '; N_calc:=1; itr:=1; FOR iph:=1 TO nph DO
  BEGIN strgrNn[7,1]:=MAX0(1,aufit.ntrnd);
  FOR i:=1 TO 6 DO strgrNn[i,1]:=MAX0(1,ddstep[i+(iph-1)*6].nst);
  strgrT[1]:=s+'A';   strgrT[2]:=s+'B'; strgrT[3]:=s+'C';
  strgrT[4]:=s+'alpha'; strgrT[5]:=s+'beta'; strgrT[6]:=s+'gamma';
  strgrT[7]:='Number of tries in each bin'; j:=7; IF(iph<>1)THEN j:=6;
  PuttoTable(10,30,j,j,1,8);
  IF(nph>1)THEN OuttoLabel(Form2.Label5,70,210,clGreen,clWhite,
   ' Phase N '+IntToStr(iph));
  WITH Form2 DO WITH aufit DO
   BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
   FOR i:=1 TO 7 DO
    BEGIN Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
    IF(ModalRes=0)THEN
     BEGIN ShowMess(wrnum); Exit;
     END;
    END;
   FOR i:=1 TO 6 DO dstepnst[iph,i]:=MAX0(1,Round(ABS(har[i])));
   IF(iph=1)THEN ntrnd_0:=Round(har[7]);
   CheckDStepsForSymm(iph,lat[iph].syng);
   FOR i:=1 TO 6 DO itr:=itr*ddstep[i+(iph-1)*6].nst;
   END;
  END;
 s:='Total N of tries= '+IntToStr(itr*aufit.ntrnd);
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN GOTO Lag;
 END;
               {Loop over lattice parameters}
IF(dispfit)THEN MakeCurrS;
Lfit: WITH aufit DO
 BEGIN cb:=cw; cb.iconv:=1; IF(keyAuto=1)THEN cb.iconv:=0;
 cb.ipr:=0; IF(debugV.cbipr)THEN cb.ipr:=1;
 TrialFit; AssignHKLs; ntrT:=ntrT+ntries*MAX0(1,ntrnd);      { F I T }
 PrintFinalState(ntries+1,ntries);
 END;          {End of trial loop;}
WITH aufit DO
 BEGIN ConvertStr(Ftot,12,2); s:='Chi^2 =  '+sedz+crc;
 ConvertStr(Fanx,10,5); s:=s+'d-diff(A)='+sedz+crc+'Stop fitting?';
 FOR i:=1 TO npar DO parar[i].p:=par[i].p;
 i:=MessageDlg(s,MtConfirmation,[mbYes,mbNo],0);
 IF(i=mrNo)THEN GOTO Lfit;
 WITH Form2.Image3.Canvas DO
  BEGIN Brush.Color:=0; FillRect(Rect(0,0,516,50));
  END;
 END;
Lend: WITH aufit DO
 BEGIN FOR iph:=1 TO nph DO WITH lat[iph] DO {UpDate lattice}
  BEGIN WITH lpd DO
   BEGIN i:=(iph-1)*6; a:=par[i+1].p; b:=par[i+2].p; c:=par[i+3].p;
   alpha:=par[i+4].p; beta:=par[i+5].p; gamma:=par[i+6].p;
   IF((syng=2)AND(sett=1))THEN
    BEGIN beta:=alpha; gamma:=par[i+5].p; ZExchange(b,c)
    END;
   vol:=DCellVolume(a,b,c,alpha,beta,gamma);
   alpha:=arccos(alpha)*radian; beta:=arccos(beta)*radian;
   gamma:=arccos(gamma)*radian;
   END;
  InverseLatPar(lpd,lpi,voli,0); FormLatMatrix(iph);
  WITH lper DO
   BEGIN i:=(iph-1)*6; a:=par[i+1].e; b:=par[i+2].e; c:=par[i+3].e;
   alpha:=par[i+4].e; beta:=par[i+5].e; gamma:=par[i+6].e;
   alpha:=alpha*radian/SQRT(1-SQR(par[i+4].p));
   beta:=beta*radian/SQRT(1-SQR(par[i+5].p));
   gamma:=gamma*radian/SQRT(1-SQR(par[i+6].p));
   END;
  END;
 END;
nophasi:=false; nofit[2]:=false;
FOR j:=1 TO 24 DO Write(fout,'***'); Writeln(fout);
Writeln(fout,'* Starting '+aapi+'     Mode= ',SetIndx.ar[keyAuto+2]);
FOR iph:=1 TO nph DO WITH aufit DO
 BEGIN Writeln(fout,'* Phase ',iph:1,'  Minimizer = ',vmin[iph]:12:6,
  '  symmetry= ',syngar[lat[iph].syng,0]);
 Writeln(fout,'  HKL_max/min_ph'+IntToStr(iph),hmax[iph]:5,hmin[iph]:4,
  kmax[iph]:5,kmin[iph]:4,lmax[iph]:5,'    V_max=',
 vmax[iph]:7:0,'   N_ref=',lat[iph].nhkl:5); ni:=(iph-1)*6;
 Write(fout,'  Par_max_ph'+IntToStr(iph));
 FOR j:=ni+1 TO ni+3 DO Write(fout,par[j].pu:8:2);
 FOR j:=ni+4 TO ni+6 DO Write(fout,arccos(par[j].pl)*radian:8:2);
 Writeln(fout);
 Write(fout,'  Par_min_ph'+IntToStr(iph));
 FOR j:=ni+1 TO ni+3 DO Write(fout,par[j].pl:8:2);
 FOR j:=ni+4 TO ni+6 DO Write(fout,arccos(par[j].pu)*radian:8:2);
 Writeln(fout);
 END;
Writeln(fout,'* N of trials = ',ntrT:8);
END;
PROCEDURE PrepareAutoindexing;
VAR   i,ii,iph,j,khkl,isyn:INTEGER; r,z:REAL;
 PROCEDURE AccountForSymmetry(j,isy:INTEGER);
 VAR i:INTEGER;
 BEGIN
 CASE isy OF
 2: BEGIN parar[j+4].pl:=90; parar[j+4].p:=90; parar[j+4].pu:=90;
    parar[j+6].pl:=90; parar[j+6].p:=90; parar[j+6].pu:=90;
    END;
 3: BEGIN FOR i:=4 TO 6 DO WITH parar[j+i] DO
     BEGIN pl:=90; p:=90; pu:=90;
     END;
    END;
 4: BEGIN FOR i:=4 TO 6 DO WITH parar[j+i] DO
     BEGIN pl:=90; p:=90; pu:=90;
     END;
    parar[j+2].pl:=parar[j+1].pl; parar[j+2].p:=parar[j+1].p;
    parar[j+2].pu:=parar[j+1].pu; parar[j+2].n:=parar[j+1].n;
    END;
 5: BEGIN FOR i:=4 TO 6 DO WITH parar[j+i] DO
     BEGIN pl:=90; p:=90; pu:=90;
     END;
    parar[j+2].pl:=parar[j+1].pl; parar[j+2].p:=parar[j+1].p;
    parar[j+2].pu:=parar[j+1].pu;
    parar[j+3].pl:=parar[j+1].pl; parar[j+3].p:=parar[j+1].p;
    parar[j+3].pu:=parar[j+1].pu;
    parar[j+2].n:=parar[j+1].n; parar[j+3].n:=parar[j+1].n;
    END;
 6: BEGIN FOR i:=4 TO 5 DO WITH parar[j+i] DO
     BEGIN pl:=90; p:=90; pu:=90;
     END;
    parar[j+6].pl:=120; parar[j+6].p:=120; parar[j+6].pu:=120;
    parar[j+2].pl:=parar[j+1].pl; parar[j+2].pu:=parar[j+1].pu;
    parar[j+2].n:=parar[j+1].n;
    END;
 7: BEGIN parar[j+2].pl:=parar[j+1].pl; parar[j+2].p:=parar[j+1].p;
    parar[j+2].pu:=parar[j+1].pu;
    parar[j+3].pl:=parar[j+1].pl; parar[j+3].p:=parar[j+1].p;
    parar[j+3].pu:=parar[j+1].pu;
    parar[j+5].pl:=parar[j+4].pl; parar[j+5].p:=parar[j+4].p;
    parar[j+5].pu:=parar[j+4].pu;
    parar[j+6].pl:=parar[j+4].pl; parar[j+6].p:=parar[j+4].p;
    parar[j+6].pu:=parar[j+4].pu;
    parar[j+2].n:=parar[j+1].n; parar[j+3].n:=parar[j+1].n;
    parar[j+5].n:=parar[j+4].n; parar[j+6].n:=parar[j+4].n;
    END;
 ELSE END;
 END;
LABEL L1,L2;
{***************************}
BEGIN L0rec:=aapi; MakeForm(1);
noprep[2]:=true; nofit[2]:=true; SaveHelp(PrepAuI_n,PrepAuI);
FOR i:=1 TO 27 DO WITH parar[i] DO
 BEGIN n:=i; a:=1; b:=0;
 END;
                      {Loop}
IF(NOT cb_init[mriamode+1])THEN
 BEGIN aufit.FormCB; cw:=aufit.cb;
 END;
FOR iph:=1 TO nph DO
 BEGIN L0rec:=' Phase= '+IntToStr(iph);
 {*}
 MakeForm(1); IF(iph=1)THEN    {Mode: full,indexing..}
  BEGIN s:='Select the mode for '+aapi+' ';
  OuttoLabel(Form2.Label1,40,3,clGreen,clWhite,s);
  CB1rec:=SetIndx; CB1rec.indx:=keyAuto+2;
  MakeRadioGroup(1,0,25,20,260,90);
  END;
 s:=' Select the symmetry ';
 OuttoLabel(Form2.Label2,5,180,clMaroon,clWhite,s);
 WITH CB1rec DO
  BEGIN nitems:=7; indx:=lat[iph].syng;
  FOR i:=1 TO 7 DO ar[i]:='  '+syngar[i,0]+'  '+syngar[i,1];
  END;
 MakeCombo(5,200,190); WITH CB1rec DO
  BEGIN nitems:=7; indx:=lat[iph].nlatt+1;
  FOR i:=1 TO nitems DO ar[i]:=' Type '+nlatar[i];
  END;
 OuttoLabel(Form2.Label3,45,130,clMaroon,clWhite,
  ' Select lattice type ---> ');
 MakeRadioGroup(2,0,200,117,100,150);
 WITH CB1rec DO
  BEGIN nitems:=6;
  ar[1]:='Set automatically hkl bounds';
  ar[2]:='Set automatically the volume';
  ar[3]:='Initialize automatically parameters ';
  ar[4]:='Fit cynematic parameters';
  ar[5]:='Fit d-spacings';
  ar[6]:='Use space group';
  {IF(iph>1)THEN nitems:=3;}
  END;
 MakeCheckListBox(15,272,290,103); WITH Form2.CheckListBox1 DO
  BEGIN Checked[0]:=aubhkl; Checked[1]:=autovol; Checked[2]:=aui;
  IF(iph=1)THEN
   BEGIN Checked[3]:=(keylatt=1); Checked[4]:=(dstype=0);
   END;
  Checked[5]:=usespg;
  END;

 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  IF(iph=1)THEN
   BEGIN keyAuto:=RadioGroup1.ItemIndex-1;
   IF(keyAuto=1)THEN
    BEGIN IF(nph<>1)THEN
     BEGIN ShowMess('In this mode N of phases = 1'); nph:=1; Exit;
     END;
    j:=0; FOR i:=1 TO mdsp DO WITH dspa[i] DO j:=ABS(h)+ABS(k)+ABS(l);
    IF(j=0)THEN
     BEGIN ShowMess('No indexed data'); Exit;
     END;
    END;
   END;
  WITH lat[iph] DO
   BEGIN i:=ComboBox1.ItemIndex+1; IF(i<>syng)THEN nstact:=false;
   syng:=i; nlatt:=RadioGroup2.ItemIndex; IF(syng=7)THEN nlatt:=6;
   IF(NOT CheckSyng_Latt(syng,nlatt))THEN
    ShowMess('Symmetry and type not compatible');
   END;
  aubhkl:=CheckListBox1.Checked[0]; autovol:=CheckListBox1.Checked[1];
  aui:=CheckListBox1.Checked[2]; usespg:=CheckListBox1.Checked[5];
  WITH CheckListBox1 DO
   BEGIN IF(iph=1)THEN
    BEGIN IF(Checked[3])THEN keylatt:=1 ELSE keylatt:=0;
    IF(Checked[4])THEN dstype:=0;
    END;
   END;
  END;
 r:=0; FOR i:=1 TO mdsp DO r:=r+ABS(dspa[i].x);
 IF((r=0)AND(dstype<>0))THEN
  BEGIN ShowMess('Error, channels(2thetas)=0'); Exit;
  END;
 mriamode:=1; pararmod:=1;
 {*}  {Set hkl bounds}
 MakeForm(1); j:=2;
 CASE lat[iph].syng OF
 1: j:=6; 2: j:=4; 3: j:=3; 5: j:=1;
 ELSE END;
 IF((keyAuto>=0)AND(mdsp<j))THEN
  BEGIN s:='Warning! N of D-spacings < n of parameters';
  OuttoLabel(Form2.Label2,10,200,clRed,clWhite,s);
  END;
 IF(aubhkl)THEN
  BEGIN ii:=2; IF(keyAuto=-1)THEN ii:=3; IF(iph>1)THEN ii:=0;
  j:=Round(dspa[1].d/dspa[mdsp].d+0.5)+ii;
  hmax[iph]:=j; hmin[iph]:=-j; kmax[iph]:=j; kmin[iph]:=-j;
  lmax[iph]:=j;
  END;
  IF(autovol)THEN
   BEGIN vmax[iph]:=powerRI(dspa[1].d,3)*3;
   IF(iph>1)THEN vmax[iph]:=vmax[1]*0.5;
   END;
  strgrT[1]:=' h_max ='; strgrNn[1,1]:=hmax[iph];
  strgrT[2]:=' h_min ='; strgrNn[2,1]:=hmin[iph];
  strgrT[3]:=' k_max ='; strgrNn[3,1]:=kmax[iph];
  strgrT[4]:=' k_min ='; strgrNn[4,1]:=kmin[iph];
  strgrT[5]:=' l_max ='; strgrNn[5,1]:=lmax[iph];
  CASE lat[iph].syng OF
  1,7: ;
  2,6: strgrNn[4,1]:=AMAX0(kmin[iph],0);
  ELSE
   BEGIN strgrNn[2,1]:=AMAX0(hmin[iph],0);
   strgrNn[4,1]:=MAX0(kmin[iph],0);
   END;
  END;
 IF(keyAuto=1)THEN
  BEGIN strgrT[1]:=' '; strgrNn[1,1]:=0;
  strgrT[2]:=' '; strgrNn[2,1]:=0; strgrT[3]:=' '; strgrNn[3,1]:=0;
  strgrT[4]:=' '; strgrNn[4,1]:=0; strgrT[5]:=' '; strgrNn[5,1]:=0;
  vmin[iph]:=0;
  END;
 strgrT[6]:=' Volume_max='; strgrNn[6,1]:=Round(vmax[iph]);
 strgrT[7]:=' Minimizer =';  strgrNn[7,1]:=vmin[iph];
 strgrW[0]:=110; strgrW[1]:=90;
 s:='Set hkl bounds';
 OuttoLabel(Form2.Label3,15,15,clMaroon,clAqua,s);
 PuttoTable(50,40,7,7,1,8);
 r:=0; FOR i:=1 TO mdsp DO r:=r+dspa[i].x; IF(r=0)THEN
  OuttoLabel(Form2.Label4,15,315,clMaroon,clAqua,
  'Channels (angles) in dsp-distribution = 0');

 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 7 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
  vmax[iph]:=har[6]; {volume max}
  vmin[iph]:=har[7]; {volume minimizer}
  IF(keyAuto=1)THEN GOTO L1;
  hmax[iph]:=Round(har[1]); hmin[iph]:=Round(har[2]);
  kmax[iph]:=Round(har[3]); kmin[iph]:=Round(har[4]);
  lmax[iph]:=Round(har[5]);
  IF((har[1]<har[2])OR(har[3]<har[4])OR((har[5]*har[6])=0))THEN
   ShowMess('Wrong HKL bounds or cell volume');
  CASE lat[iph].syng OF
  1,7: ;
  2,6: kmin[iph]:=MAX0(kmin[iph],0);
  ELSE hmin[iph]:=MAX0(hmin[iph],0); kmin[iph]:=MAX0(kmin[iph],0); END;
  END;

L1: MakeForm(1); r:=radian;       {Parameters}
 s:='Set lattice parameters and their bounds';
 OuttoLabel(Form2.Label3,15,15,clMaroon,clAqua,s);
 s:='                  Lower      Parameter    Upper   ';
 OuttoLabel(Form2.Label4,15,35,clMaroon,clAqua,s);
 strgrW[0]:=70; strgrW[1]:=65; strgrW[2]:=75; strgrW[3]:=65;
 strgrT[1]:=' A ='; strgrT[2]:=' B ='; strgrT[3]:=' C =';
 strgrT[4]:='alpha ='; strgrT[5]:='beta  ='; strgrT[6]:='gamma =';
 j:=(iph-1)*6; IF(aui)THEN  {Ini par}
  BEGIN FOR i:=1 TO 3 DO WITH parar[j+i] DO
   BEGIN p:=dspa[iph].d+0.25; pl:=2; pu:=p*AMAX0(3-iph,1);
   END;
  FOR i:=4 TO 6 DO WITH parar[j+i] DO
   BEGIN p:=90; pl:=90; pu:=135;
   END;
  IF(lat[iph].syng=7)THEN FOR i:=4 TO 6 DO WITH parar[j+i] DO
   BEGIN pl:=45; pu:=90;
   END;
  IF(lat[iph].syng=1)THEN
   BEGIN parar[j+6].pl:=60; parar[j+6].pu:=90;
   END;
  IF(lat[iph].syng=6)THEN
   BEGIN parar[j+6].pl:=120; parar[j+6].p:=120; parar[j+6].pu:=120;
   END;
  IF((NOT nophasi)AND(keyAuto=-1))THEN WITH lat[iph].lpd DO
   BEGIN parar[j+1].p:=a; parar[j+2].p:=b; parar[j+3].p:=c;
   parar[j+4].p:=alpha; parar[j+5].p:=beta; parar[j+6].p:=gamma;
   END;
  AccountForSymmetry(j,lat[iph].syng);
  END;
 FOR i:=1 TO 3 DO WITH parar[j+i] DO
  BEGIN strgrNn[i,2]:=p; strgrNn[i,1]:=pl; strgrNn[i,3]:=pu;
  END;
 FOR i:=4 TO 6 DO WITH parar[j+i] DO
  BEGIN IF(ABS(p)<=1)THEN p:=r*arccos(sign(p)*AMIN1(1,ABS(p)));
  IF(ABS(pl)<=1)THEN pl:=r*arccos(sign(pl)*AMIN1(1,ABS(pl)));
  IF(ABS(pu)<=1)THEN pu:=r*arccos(sign(pu)*AMIN1(1,ABS(pu)));
  strgrNn[i,2]:=p; strgrNn[i,1]:=pl; strgrNn[i,3]:=pu;
  Arrange2(strgrNn[i,1],strgrNn[i,3]);
  END;
 PuttoTable(15,55,6,6,3,7);

 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  WITH StringGrid1 DO FOR i:=1 TO 6 DO
   BEGIN Zval(Cells[0,i-1],parar[j+i].pl);
   Zval(Cells[1,i-1],parar[j+i].p); Zval(Cells[2,i-1],parar[j+i].pu);
   END;
  END;
 AccountForSymmetry(j,lat[iph].syng);
 IF(keyAuto=-1)THEN FOR i:=1 TO 6 DO WITH parar[i] DO
  BEGIN pl:=p; pu:=p;
  END;
 WITH lat[iph].lpd DO
  BEGIN a:=parar[j+1].p; b:=parar[j+2].p; c:=parar[j+3].p;
  alpha:=parar[j+4].p; beta:=parar[j+5].p; gamma:=parar[j+6].p;
  IF((a*b*c=0)OR(alpha*beta*gamma=0))THEN
   BEGIN ShowMess('Wrong lattice parameters'); Exit;
   END;
  END;
 WITH lat[iph] DO
  BEGIN lpd0:=lpd; vol:=getvol(lpd); vol0:=vol;
  InverseLatPar(lpd,lpi,voli,0);
  END;
 FOR i:=4 TO 6 DO WITH parar[j+i] DO
  BEGIN pl:=COS(pl/r); p:=COS(p/r); pu:=COS(pu/r); Arrange2(pl,pu);
  END;
 FOR i:=1 TO 6 DO WITH parar[j+i] DO
  BEGIN IF(pl>pu)THEN
   BEGIN ShowMess('Wrong parameter bounds '+IntToStr(i)+
   ' Exchanged.'); Arrange2(pl,pu);
   END;
  IF(p<pl)THEN p:=pl; IF(p>pu)THEN p:=pu;
  END;
 END;
{Cynematic}
IF(keylatt=1)THEN
 BEGIN L0rec:=''; MakeForm(1);
 s:='Enter cynematic parameters and bounds';
 OuttoLabel(Form2.Label1,10,10,clGreen,clWhite,s);
 WITH spec[numsp] DO
  BEGIN r:=Fpath; z:=theta; j:=0; IF(tofang=1)THEN
   BEGIN r:=lambda; z:=0; j:=1;
   END;
  FOR i:=1 TO 3 DO strgrT[i]:=cynpar[i,j];
  strgrNn[1,2]:=r; strgrNn[2,2]:=z; strgrNn[3,2]:=delay;
  strgrNn[1,1]:=r; strgrNn[2,1]:=z; strgrNn[3,1]:=delay-1;
  strgrNn[1,3]:=r; strgrNn[2,3]:=z; strgrNn[3,3]:=delay+1;
  END;
 PuttoTable(15,35,3,3,3,7);

 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  WITH StringGrid1 DO FOR i:=0 TO 2 DO WITH aufit DO
   BEGIN j:=nph*6+i+1; Zval(Cells[0,i],parar[j].pl);
   Zval(Cells[1,i],parar[j].p); Zval(Cells[2,i],parar[j].pu);
   WITH parar[j] DO
   IF(((i=0)AND(p=0))OR(NOT rinfun(p,pl,pu)))THEN
    BEGIN ShowMess('Wrong parameters'); Exit;
    END;
   END;
  END;
 END;
MakeParComments;
                         {Loop end}
WITH aufit DO {Form ntries}
 BEGIN mpoint:=mdsp; npar:=nph*6+keylatt*3; ntries:=0;
 FOR iph:=1 TO nph DO
  BEGIN CASE lat[iph].syng OF
  1: i:=4000; 2: i:=3000; 3: i:=2000; 5: i:=1000;
  ELSE i:=2000; END;
  ntries:=ntries+i;
  END;
 FOR i:=1 TO npar DO par[i]:=parar[i];
 END;
SetIniPar(1,1); IF(keyAuto<>1)THEN
 BEGIN IF(usespg)THEN EnterPhaseInformation(2);
 FormHKL; j:=0; FOR i:=1 TO nph DO j:=j+lat[i].nhkl; IF(j=0)THEN
  BEGIN ShowMess('No hkls generated'); Exit;
  END;
 END             ELSE {keyAuto=1}
 BEGIN FOR i:=1 TO mdsp DO WITH hkla[i,1] DO
  BEGIN h:=dspa[i].h; k:=dspa[i].k; l:=dspa[i].l; dk:=dspa[i].d;
  END;
 lat[1].nhkl:=mdsp;
 END;
{Check the data and number of reflections}
khkl:=0; FOR i:=1 TO nph DO khkl:=khkl+lat[i].nhkl;
nasm[i]:=3;  {attach minimal reflection number to symmetry}
isyn:=lat[i].syng; IF(isyn=1)THEN nasm[i]:=7; IF(isyn=2)THEN nasm[i]:=5;
IF(isyn=3)THEN nasm[i]:=4;
IF(mdsp>khkl)THEN
 BEGIN ShowMess('Error, more ds than hkls '+
       IntToStr(mdsp)+' < '+IntToStr(khkl)); Exit;
 END;
L2: WITH aufit DO
 BEGIN Ftot:=1E19; Fanx:=1E19; Fabx:=1E19;
 END;
WITH cw DO  {Form CB}
 CASE keyAuto OF
 0: BEGIN gnit:=8; step:=0.95; damp:=0.025; iconv:=1; alpha:=1; chi:=0;
    END;
 1: BEGIN iconv:=0; gnit:=30; step:=0.25;
    END;
 ELSE END;
noprep[2]:=false; MakeForm(1); WITH LB1rec DO
 BEGIN nitems:=nph+2;
 ar[1]:=aapi+' Data prepared'; IF(keyAuto<1)THEN
  BEGIN ar[2]:='For '+IntToStr(mdsp)+' reflections hkls generated';
  FOR i:=1 TO nph DO
   BEGIN ar[i+2]:=IntToStr(lat[i].nhkl)+' for phase '+IntToStr(i);
   END;
  END;
 IF(keyAuto=1)THEN nitems:=1;
 END;
MakeListBox(20,40,270,120); Form2.ShowModal;
WITH Form2 DO
 BEGIN Left:=0; Top:=0; Width:=exs(550); Height:=exs(410);
 WITH Image2.Canvas DO
  BEGIN Brush.Color:=clGreen; FillRect(Rect(Left,Top,Width,Height));
  END;
 END;
END;
PROCEDURE ShowAutoResults(mo:INTEGER);
{mo=   2: show,  3: save;      Version: Apr 13 2001}
CONST btyp:ARRAY[1..6] OF CHAR = ('A','B','C','F','I','R');
VAR i,j,iph,iat,ni,i0,h2,h1,k2,k1,l2,l1,zh,zk,zl:INTEGER;
    s,sc:STRING; vv,ch,cr,r,w,pp:REAL;
    aa:ARRAY[1..6] OF REAL;
 PROCEDURE ParOut(p,e:REAL; n:INTEGER; ss:STRING);
 BEGIN ConvertStr(p,10,n); s:='  '+ss+sedz+'  +- ';
 ConvertStr(e,7,n); s:=s+sedz; StringOut(s,mo);
 END;
 PROCEDURE CheckBravais(isg:INTEGER);
 VAR i,j:INTEGER;
 BEGIN FOR j:=1 TO 6 DO
  BEGIN aa[j]:=0; IF(CheckSyng_Latt(isg,j))THEN
   FOR i:=1 TO mdsp DO WITH dspa[i] DO
    CASE j OF
    1: IF(((l+k)MOD 2)=0)THEN aa[j]:=aa[j]+1;
    2: IF(((l+h)MOD 2)=0)THEN aa[j]:=aa[j]+1;
    3: IF(((h+k)MOD 2)=0)THEN aa[j]:=aa[j]+1;
    4: IF((((l+k)MOD 2)=0)AND(((h+k)MOD 2)=0))THEN aa[j]:=aa[j]+1;
    5: IF(((l+k+h)MOD 2)=0)THEN aa[j]:=aa[j]+1;
    6: IF(((-h+l+k)MOD 3)=0)THEN aa[j]:=aa[j]+1;
    ELSE END;
  END;
 FOR i:=1 TO 6 DO aa[i]:=aa[i]/mdsp;
 END;
BEGIN IF((mo=3)AND(NOT nosavedA))THEN Exit;
IF(mo=2)THEN
 BEGIN L0rec:='Output of fitting results';
 MakeForm(1); Savehelp(AutoIRes_n,AutoIRes);
 END;
FOR iph:=1 TO nph DO WITH lat[iph] DO WITH aufit DO
 BEGIN MakeMemo(1,330); j:=(iph-1)*6;
 FOR i:=1 TO 6 DO aa[i]:=par[j+i].p;
 s:='  Chi2/df = '+FltoSt(Ftot,2);
 IF(keyAuto<>-1)THEN StringOut(s,mo);
 StringOut('  Dif(A)  = '+FltoSt(Fanx,5),mo);
 vol:=DCellVolume(aa[1],aa[2],aa[3],aa[4],aa[5],aa[6]);
 StringOut(' ',mo); ConvertStr(vol,8,2);
 StringOut('    Phase No '+IntToStr(iph)+'   Vol= '+sedz,mo);
 StringOut(' ',mo);
 ParOut(par[j+1].p,par[j+1].e,dignum,'A = ');
 ParOut(par[j+2].p,par[j+2].e,dignum,'B = ');
 ParOut(par[j+3].p,par[j+3].e,dignum,'C = '); StringOut(' ',mo);
 pp:=arccos(par[j+4].p)*radian;
 r:=par[j+4].e*radian/SQRT(1-SQR(par[j+4].p));
 ParOut(pp,r,2,'alpha = ');
 pp:=arccos(par[j+5].p)*radian;
 r:=par[j+5].e*radian/SQRT(1-SQR(par[j+5].p));
 ParOut(pp,r,2,'beta  = ');
 pp:=arccos(par[j+6].p)*radian;
 r:=par[j+6].e*radian/SQRT(1-SQR(par[j+6].p));
 ParOut(pp,r,2,'gamma = ');
 IF(syng<=2)THEN
  BEGIN StringOut(' ',mo);
  MakeMostRectAng(aa[1],aa[2],aa[3],aa[4],aa[5],aa[6],vv,syng);
  IF(NOT mracell)THEN
   BEGIN IF(syng=1)THEN
    MakeMostRectAng(aa[1],aa[2],aa[3],aa[4],aa[5],aa[6],vv,syng);
   FOR i:=1 TO 6 DO par[j+i].p:=aa[i];
   s:='The most rectangular unit cell.'; ConvertStr(vv,6,1);
   s:=s+'  Vol= '+sedz; StringOut(s,mo);
   s:=' '; FOR i:=1 TO 3 DO
    BEGIN ConvertStr(aa[i],8,4); s:=s+sedz;
    END;
   StringOut(s,mo);
   s:=' '; FOR i:=4 TO 6 DO
    BEGIN ConvertStr(arccos(aa[i])*radian,8,2); s:=s+sedz;
    END;
   StringOut(s,mo);
   END;
  END;
 CheckBravais(syng);
 FOR i:=1 TO 6 DO IF((aa[i]>0.9)AND(nlatt<>i))THEN
  BEGIN s:='Probability for '+btyp[i]+'= '; ConvertStr(aa[i],6,2);
  s:=s+sedz; StringOut(s,mo);
  END;
 StringOut(' ',mo); IF(mo=2)THEN
  BEGIN Form2.ShowModal; IF(ModalRes=0)THEN Exit;
  END;
 END;
IF(keylatt=1)THEN WITH aufit DO
 BEGIN MakeMemo(1,410); j:=(iph-1)*6;
 StringOut('    Cynematic parameters',mo);
 WITH par[j+1] DO ParOut(p,e,dignum,com+' = ');
 WITH par[j+3] DO ParOut(p,e,dignum,com+'= ');
 IF(mo=2)THEN
  BEGIN Form2.ShowModal; IF(ModalRes=0)THEN Exit;
  END;
 END;
{Show indexing}
L0rec:='   N    h    k    l           d_exp     d_fit      Dif.   chi2';
IF(mo=2)THEN
 BEGIN MakeFormV(1,20,540,430,0);
 END    ELSE
 BEGIN s:=bblank+aapi; StringOut(s,mo); StringOut(L0rec,mo);
 END;
GetDDeviations;{Calculate Diffs}
FOR iph:=1 TO nph DO
 BEGIN h2:=-1000; h1:=1000; k2:=-1000; k1:=1000; l2:=-1000; l1:=1000;
 MakeMemo(1,525);
 IF(nph<>1)THEN StringOut(bblank+'Phase '+IntToStr(iph),mo);
 ch:=0; ni:=0; FOR i:=1 TO mdsp DO WITH dspa[i] DO IF(ph=iph)THEN
  BEGIN Inc(ni); r:=i; ConvertStr(r,4,0); s:=sedz;
  ArrangeHKL(h,k,l,lat[iph].syng,zh,zk,zl);
  r:=zh; ConvertStr(r,5,0); s:=s+sedz;
  r:=zk; ConvertStr(r,5,0); s:=s+sedz;
  r:=zl; ConvertStr(r,5,0); s:=s+sedz;
  ConvertStr(d,12,5); s:=s+sedz;
  r:=th; {IF(keylatt=1)THEN r:=spec[numsp].chtod(th);}
  ConvertStr(r,10,5); s:=s+sedz;
  w:=e; IF(w<>0)THEN w:=1/w; r:=r-d; ch:=ch+SQR(r*w);
  ConvertStr(r,10,5); s:=s+sedz; ConvertStr(SQR(r*w),6,1); s:=s+sedz;
  StringOut(s,mo);
  {Get real max indices ranges and eps}
  h2:=MAX0(h2,zh); h1:=MIN0(h1,zh); k2:=MAX0(k2,zk); k1:=MIN0(k1,zk);
  l2:=MAX0(l2,zl); l1:=MIN0(l1,zl);
  END;
 ConvertStr(Faph[iph],12,5); s:='Average  d - d_calc (A) = '+sedz;
 StringOut(s,mo);
 ConvertStr(Fapx[iph],12,5); s:='Max      d - d_calc (A) = '+sedz;
 StringOut(s,mo);
 ConvertStr(eps_av,12,5); s:='Average exp_error   (A) = '+sedz;
 StringOut(s,mo);
 CountVisibleReflections(ni,iph);
 s:='N(d-visible) / N(d_exp) = '+IntToStr(ni)+' / '+IntToStr(nasr[iph]);
 StringOut(s,mo);
 s:='  Phase '+IntToStr(iph)+'  real hkl range:'; StringOut(s,mo);
 s:='      ('; sc:=IntToStr(h1); AdjustSt(sc,5); s:=s+sc+',';
 sc:=IntToStr(h2); AdjustSt(sc,5); s:=s+sc+'),  (';
 sc:=IntToStr(k1); AdjustSt(sc,5); s:=s+sc+',';
 sc:=IntToStr(k2); AdjustSt(sc,5); s:=s+sc+'),  (';
 sc:=IntToStr(l1); AdjustSt(sc,5); s:=s+sc+',';
 sc:=IntToStr(l2); AdjustSt(sc,5); s:=s+sc+')';
 StringOut(s,mo);
 cr:=1/(AMAX1(Faph[iph],0.00001)*AMAX0(ABS(ni-mdsp),1));
 StringOut(' ',mo); ConvertStr(cr,12,3); s:=sedz;
 CASE lat[iph].syng OF
 1: j:=6;
 2: j:=4;
 3: j:=3;
 5: j:=1;
 ELSE j:=2; END;
 ConvertStr(ch/AMAX0(nasr[iph]-j,1),10,2);
 s:=s+'   phase chi2/N(d) = '+sedz; StringOut('  Criterion = '+s,mo);
 IF(mo=2)THEN Form2.ShowModal;
 END;
IF(nph>1)THEN {Compare phase 1 with others}
 BEGIN L0rec:=''; MakeForm(1); MakeMemo(1,525);
 s:='Closest to ds of phase 1 among others'; StringOut(s,mo);
 FOR i:=1 TO mdsp DO
  BEGIN vv:=1E15; IF(dspa[i].ph=1)THEN
   BEGIN FOR j:=1 TO mdsp DO WITH dspa[j] DO IF((j<>i)AND(ph<>1))THEN
    BEGIN r:=ABS(dspa[i].d-d); IF(r<vv)THEN
     BEGIN ni:=j; vv:=r;
     END;
    END;
   ConvertStr(dspa[i].d,9,5); s:=sedz; ConvertStr(dspa[ni].d,9,5);
   s:=s+' closest= '+sedz+'  phase '+IntToStr(dspa[ni].ph);
   StringOut(s,mo);
   END;
  END;
 IF(mo=2)THEN Form2.ShowModal;
 END;
IF(mo=3)THEN nosavedA:=false;
END;
PROCEDURE EnterdSpacings;
VAR   i,j,kk,ix:INTEGER; xx,z,r:REAL; s:STRING; m5:BOOLEAN;
LABEL L1;
BEGIN L0rec:='Form the d-distribution';
SaveHelp(EntDSpGr_n,EntDSpGr); MakeForm(1);
s:=' There are '+IntToStr(npeak)+' points marked ';
OuttoLabel(Form2.Label6,50,5,clAqua,clBlack,s);
s:=' Specify data source ';
OuttoLabel(Form2.Label5,10,50,clGreen,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=5; indx:=enspm;
 ar[1]:='file'; ar[2]:='graph points'; ar[3]:='find peaks';
 ar[4]:='screen info'; ar[5]:='spectrum ds';
 END;
MakeRadioGroup(1,0,150,30,150,120);
s:=' Enter data type ';
OuttoLabel(Form2.Label6,10,180,clGreen,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=4; indx:=1;
 ar[1]:='d-spacings'; ar[2]:='thetas';
 ar[3]:='2_thetas'; ar[4]:='TOF-channels';
 END;
MakeRadioGroup(2,0,150,160,150,120);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:=' Refine peak positions (if from graph)';
 END;
MakeCheckListBox(20,300,280,20);
IF(refine)THEN Form2.CheckListBox1.Checked[0]:=true;
au_comm:=' ';
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 enspm:=RadioGroup1.ItemIndex+1; dstype:=RadioGroup2.ItemIndex;
 refine:=false; IF(Form2.CheckListBox1.Checked[0])THEN refine:=true;
 END;
IF(enspm=3)THEN {***Find the peaks}
 BEGIN REPEAT IF(NOT psclass)THEN peaksr:=TPeakSearch.Create;
 psclass:=true;
 FindthePeaks; IF(ModalRes=0)THEN Exit;
 s:=IntToStr(npeak)+' peaks found. Proceed? If NO - retry.';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0);
 IF(i=mrNo)THEN ok:=false ELSE ok:=true;
       UNTIL ok;
 FOR i:=1 TO npeak DO WITH dspa[i] DO
  BEGIN z:=marka[i]; d:=spec[numsp].chtod(marka[i]);
  END;
 END;
IF(enspm IN [2,3,5])THEN {***From graph points}
 BEGIN IF(npeak=0)THEN
  BEGIN ShowMess('Error, no marked points'); ModalRes:=0; Exit;
  END;
 IF(refine AND NOT spec[numsp].spin)THEN
  BEGIN ShowMess('Refinement failure: no spectrum '+IntToStr(numsp));
  Exit;
  END;
 mdsp:=0; m5:=(enspm=5);
 FOR i:=1 TO npeak DO IF(rinfun(marka[i],3,16381)OR m5)THEN
  BEGIN j:=Round(marka[i]); xx:=spec[numsp].y[j]; ix:=j;
  Inc(mdsp); IF(enspm=5)THEN GOTO L1;
  IF(refine)THEN
   BEGIN FOR kk:=j-3 TO j+3 DO IF(spec[numsp].y[kk]>xx)THEN
    BEGIN xx:=spec[numsp].y[kk]; ix:=kk;
    END;
   xx:=0; z:=0; FOR kk:=-2 TO 2 DO
    BEGIN r:=ABS(spec[numsp].y[ix+kk]); xx:=xx+kk*r; z:=z+r;
    END;
   xx:=xx/AMAX1(1,z)+ix; ix:=Round(xx);
   END;
  marka[i]:=ix; dspa[mdsp].e:=epsauto;
  IF(spec[numsp].tofang=1)THEN z:=spec[numsp].x[ix] ELSE z:=xx;
  L1:WITH spec[numsp] DO IF(enspm=5)THEN
   BEGIN dspa[mdsp].d:=x[ix]; dspa[mdsp].x:=ix;
   END                              ELSE
   BEGIN dspa[mdsp].d:=chtod(xx); dspa[mdsp].x:=z;
   END;
  END;
 END;
IF(enspm=1)THEN {***From file}
 BEGIN L0rec:='Enter the D-Spacings FileName';
 IF(dstype IN [1..3])THEN
  BEGIN WITH spec[numsp] DO IF(dstype=3)THEN tofang:=0 ELSE tofang:=1;
  GetTOFInfo;
  END;
 GetFilename(dsfn,0); IF(ModalRes=0)THEN Exit; ReadDSpacings(dsfn);
 END;
IF(enspm=4)THEN EnterDFromScreen;{***From screen}

IF(mdsp<>0)THEN ArrangeDSpacings; InfoaboutAutoindexing;
END;
PROCEDURE OnlyIndexing(VAR ok:BOOLEAN; VAR f:REAL);
VAR i:INTEGER;
BEGIN AssignHKLs;
FOR i:=1 TO nph DO ok:=ok AND (nasr[i] >= nasm[i]);
IF(nph=1)THEN ok:=true;
END;
PROCEDURE FitFlightPathetc;
VAR i,j,kj,iter,ii,kk:INTEGER; z,s,c,o:REAL; ss:STRING;
CONST co:REAL = 505.556;
 PROCEDURE deriv(i:INTEGER);
 BEGIN r:=dspa[i].x; WITH spec[numsp] DO
  BEGIN s:=SIN(pa[2]/radian)*co; c:=COS(pa[2]/radian)*co; z:=s*pa[1];
  o:=chw*(r+pa[3]); fth:=o/z; ffr[1]:=-(o*s)/SQR(z);
  ffr[3]:=chw/z; z:=chw*(r+pa[3])/(z*z); ffr[2]:=-z*c*pa[1]/radian;
  END;
 END;
BEGIN WITH spec[numsp] DO IF(NOT spin)THEN
 BEGIN ShowMess('No spectrum (or any) '+IntToStr(numsp)); Exit;
 END;
IF(mdsp=0)THEN
 BEGIN ShowMess('No d-spacing array'); Exit;
 END;
z:=0; FOR i:=1 TO mdsp DO z:=z+ABS(dspa[i].x);
IF(z<=1)THEN
 BEGIN ShowMess('No channels in d-spacing array'); Exit;
 END;
IF(spec[numsp].tofang=0)THEN L0rec:='Fitting FPath, Theta, Delay'
                        ELSE L0rec:='Fitting Lambda, Zero_shift';
MakeForm(1); SaveHelp(FitFTD_n,FitFTD);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1;
 IF(spec[numsp].tofang=0)THEN
  BEGIN ar[1]:=' Fit  FlightPath and Delay';
  ar[2]:=' Fit  Theta and Delay';
  END                    ELSE
  BEGIN ar[1]:=' Fit  Lambda'; ar[2]:=' Fit  Zero_shift ';
  END;
 END;
ss:='Select parameters to be fitted (only 2)';
OuttoLabel(Form2.Label5,5,20,clGreen,clWhite,ss);
MakeRadioGroup(1,0,50,50,240,70);
ss:='Enter parameters and their bounds';
OuttoLabel(Form2.Label6,5,180,clGreen,clAqua,ss);
ss:=' Lower           Initial             Upper';
OuttoLabel(Form2.Label7,105,200,clGreen,clWhite,ss);
ss:=' Bound         Parameter      Bound';
OuttoLabel(Form2.Label8,105,215,clGreen,clWhite,ss);
strgrW[0]:=90; strgrW[1]:=75; strgrW[2]:=75; strgrW[3]:=75;
strgrT[1]:=' F-Path(m)';
strgrT[2]:=' Theta(deg)';
strgrT[3]:=' Delay(chan)';
WITH spec[numsp] DO
 BEGIN strgrNn[1,2]:=FPath; strgrNn[2,2]:=theta; strgrNn[3,2]:=delay;
 strgrNn[1,1]:=FPath-0.1; strgrNn[2,1]:=theta-3; strgrNn[3,1]:=delay-1;
 strgrNn[1,3]:=FPath+0.1; strgrNn[2,3]:=theta+3; strgrNn[3,3]:=delay+1;
 END;
PuttoTable(5,235,3,3,3,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 kk:=RadioGroup1.ItemIndex; IF(kk=0)THEN kk:=2 ELSE kk:=1;
 END;
FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[1,i-1],pa[i]);
FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],pal[i]);
FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[2,i-1],pau[i]);
pal[kk]:=pa[kk]; pau[kk]:=pa[kk];
step:=0.15; chio:=1E10; FOR iter:=1 TO 100 DO
 BEGIN chi:=0; FOR i:=1 TO 3 DO
  BEGIN vec3[i]:=0; FOR j:=1 TO 3 DO mat3[i,j]:=0;
  END;
 FOR j:=1 TO mdsp DO
  BEGIN fex:=dspa[j].d; sigi:=dspa[j].e; IF(sigi<>0)THEN sigi:=1/sigi;
  deriv(j); ffr[kk]:=0; FOR i:=1 TO 3 DO
   BEGIN vec3[i]:=vec3[i]+sigi*(fex-fth)*ffr[i];
   FOR kj:=1 TO 3 DO mat3[i,kj]:=mat3[i,kj]+sigi*ffr[i]*ffr[kj];
   END;
  chi:=chi+sigi*SQR(fex-fth);
  END;
 FOR i:=1 TO 3 DO mat3[kk,i]:=0; FOR i:=1 TO 3 DO mat3[i,kk]:=0;
 mat3[kk,kk]:=1;
 FOR i:=1 TO 3 DO mat3[i,i]:=mat3[i,i]*1.1; InvertMatrix3(ok,true,det);
 IF(NOT ok)THEN
  BEGIN ShowMess('Determinant not ok = '+FloatToStr(det)); BREAK;
  END;
 FOR i:=1 TO 3 DO
  BEGIN dp[i]:=0; FOR j:=1 TO 3 DO dp[i]:=dp[i]+mat3[i,j]*vec3[j];
  END;
 eps:=0; FOR i:=1 TO 3 DO
  BEGIN pa[i]:=pa[i]+step*dp[i]; IF(pa[i]<pal[i])THEN pa[i]:=pal[i];
  IF(pa[i]>pau[i])THEN pa[i]:=pau[i]; eps:=eps+SQR(dp[i]);
  END;
 eps:=SQRT(eps);
 IF((chi>chio)OR(eps<0.001))THEN BREAK;
 END;
MakeForm(1);
WITH LB1rec DO
 BEGIN nitems:=5; ar[1]:=' Fitting finished.';
 ConvertStr(chi/2,10,2); ar[2]:=' Chi2= '+sedz;
 ConvertStr(eps,10,2); ar[2]:=ar[2]+'   Eps= '+sedz;
 ConvertStr(pa[1],10,5); ar[3]:='   FPath = '+sedz;
 ConvertStr(pa[2],10,3); ar[4]:='   Theta = '+sedz;
 ConvertStr(pa[3],10,3); ar[5]:='   Delay = '+sedz;
 END;
MakeListBox(25,40,300,100);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:=' UpDate the fitted parameters';
 END;
MakeCheckListBox(50,200,260,20); Form2.ShowModal;
IF(Form2.CheckListBox1.Checked[0])THEN WITH spec[numsp] DO
 BEGIN FPath:=pa[1]; theta:=pa[2]; delay:=pa[3];
 END;
END;
PROCEDURE PrintAllReflections;
VAR zh,zk,zl,i,j,iph,kx,nd:INTEGER; s:STRING; d1,d2,r:REAL; ok:BOOLEAN;
BEGIN L0rec:=' Show all the reflections'; MakeForm(1);
Savehelp(PriARef_n,PriARef);
strgrW[0]:=180; strgrW[1]:=100;
strgrT[1]:=' Interval beginning (A) = ';
strgrNn[1,1]:=dspa[mdsp].d-0.1;
strgrT[2]:=' Interval end (A) = '; strgrNn[2,1]:=dspa[1].d+0.01;
PuttoTable(20,100,2,2,1,8);
ConvertStr(eps_av,8,5); Compress(sedz);
s:=' Average experimental error = '+sedz;
OuttoLabel(Form2.Label5,10,170,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=1;
 ar[1]:=' Save all reflections to res-file ';
 END;
MakeCheckListBox(30,220,270,20);
Form2.CheckListBox1.Checked[0]:=false;
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
ok:=Form2.CheckListBox1.Checked[0];
d1:=har[1]; d2:=har[2]; Arrange2(d1,d2);
L0rec:=' h    k   l    [phase]      d      d_exp.   d_out';
IF(ok)THEN
 BEGIN Writeln(fout,'CALCULATED Ds TO D_exp':40);
 Writeln(fout,L0rec);
 END;
MakeFormV(5,20,480,430,0);
FOR iph:=1 TO nph DO WITH Form2 DO WITH LB1rec DO
 BEGIN BubbleSortHKLs; nd:=0; FOR i:=1 TO lat[iph].nhkl DO {Output}
 IF(rinfun(hkla[i,iph].dk,d1,d2))THEN
  BEGIN Inc(nd); WITH hkla[i,iph] DO
   BEGIN ArrangeHKL(h,k,l,lat[iph].syng,zh,zk,zl);
   r:=zh; ConvertStr(r,5,0); s:=sedz;
   r:=zk; ConvertStr(r,5,0); s:=s+sedz;
   r:=zl; ConvertStr(r,5,0); s:=s+sedz;
   r:=iph; ConvertStr(r,5,0);
   IF(nph=1)THEN s:=s+'     ' ELSE s:=s+sedz;
   ConvertStr(dk,10,5); s:=s+sedz;
   r:=1E15; FOR j:=1 TO mdsp DO IF(ABS(dspa[j].d-dk)<r)THEN
    BEGIN r:=ABS(dspa[j].d-dk); kx:=j;
    END;
   ConvertStr(dspa[kx].d,9,5);
   IF(r<(1.4*dspa[kx].e))THEN s:=s+sedz ELSE s:=s+'      '+sedz;
   END;
  ar[nd]:=s;
  IF(ok)THEN Writeln(fout,s);
  END;
 s:=IntToStr(nd)+' reflections'; ar[nd+1]:=s;
 IF(ok)THEN Writeln(fout,s);
 CountVisibleReflections(j,iph);
 ar[nd+2]:='N of error-resolved ones = '+IntToStr(j); nitems:=nd+2;
 IF(ok)THEN Writeln(fout,ar[nd+2]);
 MakeListBox(5,0,450,370); ShowModal;
 END;
END;
PROCEDURE ArrangeHKL(h,k,l,syn:INTEGER; VAR zh,zk,zl:INTEGER);
{To arrange hkl's,  Version: August 25 1992}
 PROCEDURE SwapI(VAR i1,i2:INTEGER);
 VAR i:INTEGER;
 BEGIN i:=i2; i2:=i1; i1:=i;
 END;
BEGIN zh:=h; zk:=k; zl:=l;
CASE syn OF
1,2,3: ;
4,6:  {Tetragonal,Hexagonal} IF(ABS(h)<ABS(k))THEN
      BEGIN zh:=k; zk:=h;
      END;
5:    BEGIN {Cubic} IF(ABS(h)<ABS(k))THEN SwapI(zh,zk);
      IF(ABS(k)<l)THEN SwapI(zl,zk);
      END;
7:    {RhomboHedral} IF(ABS(h)<ABS(k))THEN SwapI(zh,zk);
ELSE END;
END;
PROCEDURE TransformDErrors;
VAR i,iop:INTEGER; z,c:REAL;
BEGIN IF(mdsp=0)THEN
 BEGIN ShowMess('Error, no d-spacings'); Exit;
 END;
L0rec:='Transform d-errors'; MakeForm(0);
s:='  If intensities I are given instead of d-errors, ';
OuttoLabel(Form2.Label5,5,10,clMaroon,clWhite,s);
s:=' one can get them as:    err = const/sqrt(I) ';
OuttoLabel(Form2.Label6,25,25,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=4; indx:=1;
 ar[1]:='Multiply errors by constant';
 ar[2]:='Turn intensities to errors';
 ar[3]:='Set constant errors';
 ar[4]:='Take errors as part of ds';
 END;
MakeRadioGroup(1,0,20,70,280,100);
strgrW[0]:=150; strgrW[1]:=100;
strgrT[1]:='Constant (part)= '; strgrNn[1,1]:=0.01;
PuttoTable(30,200,1,1,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 iop:=RadioGroup1.ItemIndex; Zval(Form2.StringGrid1.Cells[0,0],c);
 IF(c=0)THEN
  BEGIN ShowMess('Error ,const=0'); Exit;
  END;
 END;
CASE iop OF
0,2,3: BEGIN
   FOR i:=1 TO mdsp DO
   CASE iop OF
   0: dspa[i].e:=dspa[i].e*c;
   2: dspa[i].e:=c;
   3: dspa[i].e:=dspa[i].d*c;
   ELSE END;
       END;
1: BEGIN z:=ABS(dspa[1].e); FOR i:=1 TO mdsp DO z:=AMAX1(z,dspa[i].e);
   IF(z=0)THEN
    BEGIN ShowMess('d-spacing errors=0!'); Exit;
    END;
   IF(z<1)THEN FOR i:=1 TO mdsp DO dspa[i].e:=dspa[i].e/z;
   FOR i:=1 TO mdsp DO
    dspa[i].e:=c/SQRT(AMAX1(ABS(dspa[i].e),0.000001));
   END;
ELSE END;
c:=0; FOR i:=1 TO mdsp DO c:=c+dspa[i].e; eps_av:=c/AMAX0(1,mdsp);
InfoaboutAutoindexing;
END;
PROCEDURE DeleteDSpacings;
VAR i,j,k,n:INTEGER;
BEGIN IF(mdsp=0)THEN
 BEGIN ShowMess('Error, no d-spacings'); Exit;
 END;
L0rec:='delete close ds'; MakeForm(0);
strgrW[0]:=170; strgrW[1]:=100;
strgrT[1]:='N of ds to be deleted';
strgrNn[1,1]:=AMAX0(1,Round(Float(mdsp)/10));
PuttoTable(30,50,1,1,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 Zval(Form2.StringGrid1.Cells[0,0],har[1]);
 n:=MIN0(Round(har[1]),MAX0(0,mdsp-7));
 END;
FOR i:=1 TO n DO
 BEGIN q2:=100000; k:=1; FOR j:=2 TO mdsp DO
  BEGIN q1:=ABS(dspa[j].d-dspa[j-1].d); IF(q1<=q2)THEN
   BEGIN q2:=q1; k:=j;
   END;
  END;
 dspa[k].d:=i*1000;
 END;
j:=0; FOR i:=1 TO mdsp DO IF(dspa[i].d<1000)THEN
 BEGIN Inc(j); dspa[j]:=dspa[i];
 END;
mdsp:=j;
ArrangeDSpacings;
END;
PROCEDURE PrintFinalState(ipr,npr:INTEGER);
VAR i,j,kj,kk,iph,ii:INTEGER; s:STRING; d1,d2,r,ax:REAL;
BEGIN d1:=dspa[mdsp].d; d2:=dspa[1].d; ax:=ABS(d2-d1);
WITH Form2 DO
 BEGIN Left:=0; Top:=0; Width:=exs(550); Height:=exs(410);
 END;
WITH Form2.Image3 DO
 BEGIN Left:=0; Top:=exs(120); Width:=exs(516); Height:=exs(50);
 Visible:=true;
 END;
FOR iph:=1 TO nph DO WITH aufit DO WITH Form2 DO
 BEGIN ii:=(iph-1)*6; ConvertStr(par[1+ii].p,8,3);
 s:='Parameters, ph'+IntToStr(iph)+' = '+sedz;
 ConvertStr(par[2+ii].p,8,3); s:=s+sedz;
 ConvertStr(par[3+ii].p,8,3); s:=s+sedz;
 r:=arccos(par[4+ii].p)*radian; ConvertStr(r,8,2); s:=s+sedz;
 r:=arccos(par[5+ii].p)*radian; ConvertStr(r,8,2); s:=s+sedz;
 r:=arccos(par[6+ii].p)*radian; ConvertStr(r,8,2); s:=s+sedz;
 r:=DCellVolume(par[1+ii].p,par[2+ii].p,par[3+ii].p,par[4+ii].p,
     par[5+ii].p,par[6+ii].p); ConvertStr(r,8,1); s:=s+'      V= '+sedz;
 CASE iph OF
 1: OuttoLabel(Label1,5,50,clGreen,clWhite,s);
 2: OuttoLabel(Label2,5,64,clGreen,clWhite,s);
 3: OuttoLabel(Label3,5,78,clGreen,clWhite,s);
 4: OuttoLabel(Label4,5,92,clGreen,clWhite,s);
 ELSE END;
 ConvertStr(d1,8,4); OuttoLabel(Label8,0,173,clMaroon,clAqua,sedz);
 ConvertStr(d2,8,4); OuttoLabel(Label9,460,173,clMaroon,clAqua,sedz);
 OuttoLabel(Label10,5,190,clMaroon,clAqua,
  ' ds calculated (aqua, etc.) versus experimental (magenta);');
 END;
WITH Form2.Image3.Canvas DO
 BEGIN Brush.Color:=0; FillRect(Rect(0,0,exs(516),exs(50)));
 Pen.Color:=clFuchsia;
 FOR i:=1 TO mdsp DO WITH dspa[i] DO
  BEGIN r:=(d-d1)/AMAX1(ax,0.0001)*500; Pen.Color:=clFuchsia;
  j:=Round(r); kj:=Round(e/AMAX1(ax,0.000001)*500); kj:=MIN0(kj,3);
  MoveTo(exs(j+5),exs(30)); LineTo(exs(j+5),exs(48));
  MoveTo(exs(j-kj+5),exs(30)); LineTo(exs(j+5),exs(48));
  MoveTo(exs(j+kj+5),exs(30)); LineTo(exs(j+5),exs(48));
  MoveTo(exs(j-kj+5),exs(30)); LineTo(exs(j+2*kj+5),exs(30));
  r:=(th-d1)/AMAX1(ax,0.0001)*500; j:=Round(r); r:=ABS(d-th);
  IF(r>aufit.Fanx)THEN kk:=20 ELSE kk:=29;
  CASE ph OF
  1: Pen.Color:=clAqua;
  2: Pen.Color:=clYellow;
  3: Pen.Color:=clWhite;
  4: Pen.Color:=clLime;
  ELSE END;
  MoveTo(exs(j+5),0); LineTo(exs(j+5),exs(kk));
  END;
 OuttoLabel(Form2.Label4,5,350,clMaroon,clAqua,au_comm);
 END;
END;
PROCEDURE ChangeDSpacings;
BEGIN IF(mdsp=0)THEN
 BEGIN ShowMess('No d-spacings'); Exit;
 END;
EnterDFromScreen;
END;
PROCEDURE EnterDFromScreen;
VAR i,j,kk:INTEGER; r,z:REAL; s:STRING;
BEGIN L0rec:='Edit(add/delete) d-spacings: d,err,x[,h,k,l,ph]';
MakeFormV(170,20,360,430,0); SaveHelp(EntDSpGr_n,EntDSpGr);
MakeMemo(0,345); WITH Form2.Memo1.Lines DO
 BEGIN Clear; FOR i:=1 TO mdsp DO WITH dspa[i] DO
  BEGIN r:=d; ConvertStr(r,8,4); s:=sedz;
  r:=e; ConvertStr(r,8,4); s:=s+sedz;
  r:=x; ConvertStr(r,8,2); s:=s+sedz;
  r:=h; ConvertStr(r,4,0); s:=s+sedz;
  r:=k; ConvertStr(r,4,0); s:=s+sedz;
  r:=l; ConvertStr(r,4,0); s:=s+sedz;
  r:=ph; ConvertStr(r,4,0); s:=s+sedz;
  Add(s);
  END;
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 mdsp:=Memo1.Lines.Count; kk:=0;
 WITH Memo1.Lines DO FOR i:=1 TO mdsp DO
  BEGIN s:=Strings[i-1]; FOR j:=1 TO 7 DO onl[j]:=0; fffins(j,s);
  IF(j>0)THEN WITH dspa[i] DO
   BEGIN d:=onl[1]; e:=onl[2]; z:=onl[3]; Inc(kk);
   WITH spec[numsp] DO IF((spin)AND(d>0)AND(z=0))THEN z:=dtoch(d);
   x:=z; h:=Round(onl[4]); k:=Round(onl[5]); l:=Round(onl[6]);
   ph:=Round(onl[7]);
   END;
  END;
 mdsp:=kk;
 END;
IF(mdsp<>0)THEN ArrangeDSpacings;
END;
PROCEDURE Make2ThtoD;
VAR i:INTEGER;
BEGIN IF(mdsp=0)THEN
 BEGIN ShowMess('No thetas'); Exit;
 END;
IF(spec[numsp].lambda=0)THEN
 BEGIN ShowMess('No lambda'); Exit;
 END;
FOR i:=1 TO mdsp DO WITH dspa[i] DO
 BEGIN d:=spec[numsp].chtod(x); e:=epsauto;
 END;
ArrangeDSpacings;
END;
PROCEDURE CheckDStepsForSymm(iph,isy:INTEGER);
VAR i,ii:INTEGER;
BEGIN IF(NOT nstact)THEN
 BEGIN FOR i:=1 TO 6 DO dstepnst[iph,i]:=1; ntrnd_0:=1;
 CASE isy OF
 1: BEGIN FOR i:=1 TO 3 DO dstepnst[iph,i]:=6;
    FOR i:=4 TO 6 DO dstepnst[iph,i]:=2;
    END;
 2: BEGIN FOR i:=1 TO 3 DO dstepnst[iph,i]:=8; dstepnst[iph,5]:=4;
    END;
 3: BEGIN ii:=16; IF(iph>1)THEN ii:=4;
    FOR i:=1 TO 3 DO dstepnst[iph,i]:=ii;
    END;
 4,6: BEGIN ii:=40; IF(iph>1)THEN ii:=4;
      dstepnst[iph,1]:=ii; dstepnst[iph,3]:=ii;
      END;
 5: BEGIN i:=50; IF(iph>1)THEN i:=5; dstepnst[iph,1]:=i;
    END;
 7: BEGIN dstepnst[iph,1]:=40; dstepnst[iph,4]:=40;
    END;
 ELSE END;
 nstact:=true;
 END;
FOR i:=1 TO 6 DO ddstep[i+(iph-1)*6].nst:=dstepnst[iph,i];
aufit.ntrnd:=ntrnd_0;
END;

BEGIN dsfn:=''; enspm:=1; refine:=true; dispfit:=true;
END.
