UNIT vdomus2;

INTERFACE

USES  Windows, Messages, SysUtils, Classes, Graphics, Controls,  Forms,
      Dialogs, StdCtrls, vzlocom,  Grids,   ExtCtrls, vdomus0, CheckLst,
      vstdcons;

TYPE
  TForm2 = CLASS(TForm)
    Button1: TButton;{OK}
    Button2: TButton;{Cancel}
    Button3: TButton;{Help}
    Button4: TButton;{Save}
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    ListBox1: TListBox;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    CheckListBox1: TCheckListBox;
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
    PROCEDURE Button3Click(Sender: TObject);
    PROCEDURE Button4Click(Sender: TObject);
    PROCEDURE FormCreate(Sender: TObject);
    PROCEDURE FormKeyPress(Sender: TObject; VAR Key: Char);
  PRIVATE{ Private declarations }
  PUBLIC { Public declarations }
  END;
PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
PROCEDURE MakeHeader(cl:LONGINT);
PROCEDURE MaketheButtons(x,y,w:INTEGER);
PROCEDURE MakeEdits(x1,x2,y,w,n:INTEGER);
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
PROCEDURE MakeMemo(x,w:INTEGER);
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
PROCEDURE MakeHelp(m:INTEGER);

VAR
  Form2: TForm2;

IMPLEMENTATION

USES vdomus1, vdomhlp;

{$R *.DFM}
PROCEDURE TForm2.FormCreate(Sender: TObject);
BEGIN KeyPreview:=true;
END;
PROCEDURE TForm2.FormKeyPress(Sender: TObject; VAR Key: Char);
BEGIN {IF(Key=#13)THEN Button1Click(Self);}
IF(Key=#27)THEN Button2Click(Self);
END;
PROCEDURE MakeEdits(x1,x2,y,w,n:INTEGER);
BEGIN WITH Form2 DO
 BEGIN OuttoLabel(Form2.Label1,x1,y,clMaroon,clWhite,L1rec);
 MakeEdit(Form2.Edit1,x2,y-2,w,E1rec); IF(n<2)THEN Exit;
 OuttoLabel(Form2.Label2,x1,y+23,clMaroon,clWhite,L2rec);
 MakeEdit(Form2.Edit2,x2,y+21,w,E2rec); IF(n<3)THEN Exit;
 OuttoLabel(Form2.Label3,x1,y+46,clMaroon,clWhite,L3rec);
 MakeEdit(Form2.Edit3,x2,y+44,w,E3rec); IF(n<4)THEN Exit;
 OuttoLabel(Form2.Label4,x1,y+69,clMaroon,clWhite,L4rec);
 MakeEdit(Form2.Edit4,x2,y+67,w,E4rec);
 END;
END;
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_ListBox(Form2.ListBox1,ix,it,iw,ih);
END;
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_CheckListBox(Form2.CheckListBox1,ix,it,iw,ih);
END;
PROCEDURE MakeHeader(cl:LONGINT);
VAR i:INTEGER;
BEGIN WITH Form2.Font DO
 BEGIN Color:=cl; Style:=[fsBold]; Pitch:=fpFixed; Size:=fntsize;
 s:=' '; Form2.Caption:=s+L0rec;
 END;
END;
PROCEDURE MaketheButtons(x,y,w:INTEGER);
BEGIN MaketheButton(Form2.Button1,x,y,w,20,'OK');
MaketheButton(Form2.Button2,x+w+2,y,w,20,'Cancel');
MaketheButton(Form2.Button3,x+2*w+4,y,w,20,'Help');
Form2.Button1.Default:=true;
END;
PROCEDURE MakeMemo(x,w:INTEGER);
BEGIN Make_Memo(Form2.Memo1,x,w);
END;
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
{nf=cell number to display; n=number of quantities;
 mm=number of columns; if negative FixedRows=1}
BEGIN
MakeStringGrid(Form2.StringGrid1,Form2.StringGrid2,x,t,nf,n,mm,ndig);
END;
PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
BEGIN WITH Form2 DO
 BEGIN Close; Left:=Form1.Top+ix; Top:=Form1.Top+20;
 Width:=iw; Height:=ih; Caption:=''; Color:=clGreen;
 Label1.Visible:=false; Label2.Visible:=false; Label3.Visible:=false;
 Label4.Visible:=false; Label5.Visible:=false; Label6.Visible:=false;
 Label7.Visible:=false;
 Button1.Visible:=false; Button2.Visible:=false; Button3.Visible:=false;
 Button4.Visible:=false;
 StringGrid1.Visible:=false;
 StringGrid2.Visible:=false; {BorderIcons:=[];}
 Edit1.Visible:=false; Edit2.Visible:=false; Edit3.Visible:=false;
 Edit4.Visible:=false;
 RadioGroup1.Visible:=false; RadioGroup2.Visible:=false;
 ListBox1.Visible:=false;
 Memo1.Visible:=false;
 CheckListBox1.Visible:=false;
 { ComboBox1.Visible:=false; Image1.Visible:=false;
 Bevel1.Visible:=false; Bevel2.Visible:=false; Bevel3.Visible:=false;}
 ModalRes:=1;
 END;
END;
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
VAR i:INTEGER;
BEGIN IF(bm=1)THEN ListBsav:=false; ActivateForm2(x,w,h);
{L0rec->}MakeHeader(0);
i:=(w DIV 2)-90; IF(bm=1)THEN i:=i-30; MaketheButtons(i,375,60);
IF(bm=1)THEN WITH Form2.Button4 DO
 BEGIN Left:=exs(i+180+5); Top:=exs(375); Width:=exs(60);
 Height:=exs(20); Visible:=true;
 END;
SaveHelp(blankH_n,blankH);
END;
PROCEDURE TForm2.Button1Click(Sender: TObject);
BEGIN Close; ModalRes:=1;
END;
PROCEDURE TForm2.Button2Click(Sender: TObject);
BEGIN Close; ModalRes:=0;
END;
PROCEDURE TForm2.Button3Click(Sender: TObject);
BEGIN Button1.Enabled:=false; Button2.Enabled:=false;
Button3.Enabled:=false; MakeHelp(0);
END;
PROCEDURE TForm2.Button4Click(Sender: TObject);
VAR i:INTEGER;
BEGIN IF(ListBsav)THEN Exit; s:=Form2.Caption; Writeln(fout,s);
WITH Form2.ListBox1 DO FOR i:=0 TO Items.Count-1 DO
 Writeln(fout,Items[i]); ListBsav:=true;
END;
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
{mo=0 - file name for reading
    1 - file name for writing
    2 - get a string }
VAR   s:STRING; i:INTEGER;
LABEL L1;
BEGIN s:=fn; IF(mo>=1)THEN GOTO L1;     {Read}
fn:=ExtractFileName(s); i:=Pos(s,fn); IF(i<>0)THEN Delete(s,i,100);
ModalRes:=1; WITH Form2.OpenDialog1 DO
 BEGIN Title:=L0rec; FileName:=fn; InitialDir:=s;
 Options:=Options-[ofAllowMultiSelect];
 IF(Execute)THEN s:=FileName
            ELSE
  BEGIN ModalRes:=0; Exit;
  END;
 Compress(s);
 IF(NOT FileExists(s))THEN
  BEGIN ShowMessage('No file '+s); ModalRes:=0;
  END                 ELSE fn:=s;
 END;
Exit;
L1: MakeFormV(250,20,330,430,0); {Write}
OuttoLabel(Form2.Label1,5,30,clMaroon,clWhite,L1rec);
MakeEdit(Form2.Edit1,30,50,260,fn);
Form2.ShowModal; IF(ModalRes=0)THEN Exit; fn:=Form2.Edit1.Text;
IF(mo=2)THEN Exit;               {String}
Compress(fn); ExtractFN(fn,sedz); IF(Length(sedz)=0)THEN
 BEGIN ShowMessage('Empty string'); ModalRes:=0;
 END;
IF((mo=1)AND(FileExists(fn)))THEN
 BEGIN s:='File '+fn+' already exists. Overwrite?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN ModalRes:=0;
 END;
END;
PROCEDURE MakeHelp(m:INTEGER);
VAR i:INTEGER;
BEGIN ActivateForm3(0,590,450); WITH Form3 DO
 BEGIN FOR i:=1 TO MIN0(lhelp,100) DO Memo1.Lines.Add(helpa[i]);
 Button1.Default:=true;
 {IF(m=1)THEN WITH Form4.Label1 DO
  BEGIN Left:=exs(330); Top:=exs(395); Caption:='  To be continued  ';
  Visible:=true;
  END;}
 ShowModal;
 END;
WITH Form2 DO
 BEGIN Button1.Enabled:=true; Button2.Enabled:=true;
 Button3.Enabled:=true;
 END;
END;
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
BEGIN IF(ng=1)THEN BuildRG(Form2.RadioGroup1,m,x,y,w,h)
              ELSE BuildRG(Form2.RadioGroup2,m,x,y,w,h);
END;

END.
