UNIT vedz2;

INTERFACE

USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, ExtCtrls, CheckLst,Grids,    vzlocom,  varfun,
      vedz0,   vstdcons, ComCtrls, vpmodel, vgfit01;

TYPE
  TForm2 = CLASS(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    {OK}Button1: TButton;
    {Cancel}Button2: TButton;
    {Help}Button3: TButton;
    Button4: TButton;
    {PgUp}Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    CheckListBox1: TCheckListBox;
    RadioGroup1: TRadioGroup;
    ListBox1: TListBox;
    Memo1: TMemo;
    Memo2: TMemo;
    Image1: TImage;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    OpenDialog1: TOpenDialog;
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
    PROCEDURE Button4Click(Sender: TObject);
    PROCEDURE Button5Click(Sender: TObject);
    PROCEDURE Button7Click(Sender: TObject);
    PROCEDURE Button8Click(Sender: TObject);
    PROCEDURE Button6Click(Sender: TObject);
    PROCEDURE FormKeyPress(Sender: TObject; VAR Key: Char);
    PROCEDURE Button9Click(Sender: TObject);
    PROCEDURE Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;
PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
PROCEDURE MaketheButtons(x,y,w:INTEGER);
PROCEDURE MakeEdits(x1,x2,y,w,n:INTEGER);
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
PROCEDURE MakeForm(xhead:INTEGER);
PROCEDURE MakeHeader(cl:LONGINT);
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
PROCEDURE MakeMemo(x,w:INTEGER);
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
PROCEDURE ExcelToNFile;
PROCEDURE MemoERes;
PROCEDURE ListTextFile(fn:STRING);
PROCEDURE MakePage1;
PROCEDURE MaketheTable;
PROCEDURE ViewResFile;
PROCEDURE MakeSaving(ae:BOOLEAN);
PROCEDURE ShowSession(VAR i:INTEGER);
PROCEDURE GetLowerLimit(VAR T:REAL; B:REAL; N:INTEGER);
PROCEDURE ArithGau(VAR y,w,f:REAL; i,typ:INTEGER);
PROCEDURE GetDict(separ:CHAR; VAR ndic:INTEGER; ch:CHAR);
PROCEDURE SearchFiles(CONST sh,dir1,dir2:STRING);
PROCEDURE TranslateEngRus(VAR cl:INTEGER);
PROCEDURE InsertString(VAR k:INTEGER);
PROCEDURE PurgeNonAscii(VAR k:INTEGER);
PROCEDURE EditTextFile;
PROCEDURE AjustFortran;
PROCEDURE UnixDosZ;
PROCEDURE TestExpon;
PROCEDURE TestAnisoBroad;
PROCEDURE TestWidthFitting;

VAR Form2: TForm2;
    kpl0,kpl1,dkp:INTEGER;
    N0:INTEGER;

IMPLEMENTATION
{$R *.DFM}
PROCEDURE MakeCentr(cl,d1,dd,sh,ds:INTEGER);
VAR ii,jj,j,k,dsh,shh,kk:INTEGER; vv,jr,kr:REAL;
BEGIN WITH Form2.Image1.Canvas DO FOR j:=1 TO 455 DO FOR k:=1 TO 455 DO
 BEGIN IF(arb[j,k]>=2)THEN Pixels[j,k]:=cl;
 END;
END;
PROCEDURE MakeGraph1(cl,ds,dd,sh:INTEGER);
VAR i,j,k,ic,k0,ii,jj:INTEGER;
BEGIN k0:=20;
WITH Form2 DO WITH Image1 DO WITH Canvas DO FOR j:=0 TO 8 DO
 BEGIN Pen.Color:=cl; FOR i:=-ds TO ds DO
  BEGIN ii:=dd*j+i+k0-sh; jj:=dd*j+i+k0+sh;
  IF((infun(ii,0,450))AND(infun(jj,0,450)))THEN
   BEGIN Moveto(ii,0); Lineto(jj,450);
   END;
  FOR k:=1 TO 455 DO
   BEGIN ic:=Round(dd*j+i+k0-sh+Float(2*sh*k)/455);
   IF(infun(ic,0,450))THEN arb[ic,k]:=arb[ic,k]+1;
   END;
  ii:=dd*j+i+k0-sh; jj:=dd*j+i+k0+sh;
  IF((infun(ii,0,450))AND(infun(jj,0,450)))THEN
   BEGIN Moveto(0,ii); Lineto(450,jj);
   END;
  FOR k:=1 TO 455 DO
   BEGIN ic:=Round(dd*j+i+k0-sh+Float(2*sh*k)/455);
   IF(infun(ic,0,450))THEN arb[k,ic]:=arb[k,ic]+1;
   END;
  END;
 END;
END;
PROCEDURE MakeGraph2(cl:INTEGER; a,b,gamma:REAL);
VAR i,j,k,ii,jj,ix,jx,x:INTEGER; ds,r:REAL;
BEGIN ds:=225*SIN((90-gamma)/radian);
jx:=Round(450/a/2); ix:=Round((450+2*ds)/b/2);
WITH Form2 DO WITH Image1 DO WITH Canvas DO
 BEGIN Pen.Color:=cl;
 FOR i:=-ix TO ix DO
  BEGIN ii:=225+Round(ds+b*i); jj:=225+Round(-ds+b*i);
  r:=2*ds/450; FOR k:=1 TO 450 DO
   BEGIN x:=Round(ii-k*r);
   IF((infun(x,0,450))AND(infun(k,0,450)))THEN
    BEGIN Pixels[x,k]:=cl;
    IF(arb[x,k]=0)THEN arb[x,k]:=arb[x,k]+1 ELSE
    IF(arb[x,k]=1)THEN arb[x,k]:=arb[x,k]+1 ELSE ;
    END;
   END;
  END;
 FOR j:=-jx TO jx DO
  BEGIN ii:=225+Round(a*j); IF(infun(ii,0,450))THEN
   BEGIN Moveto(0,ii); Lineto(450,ii);
   IF(arb[k,ii]=0)THEN arb[k,ii]:=arb[k,ii]+1 ELSE
   IF(arb[k,ii]=1)THEN arb[k,ii]:=arb[k,ii]+1 ELSE ;
   END;
  {Writeln(fout,j:6,ii:7,a:8:1,b:8:1,gamma:7:1);}
  END;
 FOR i:=-2 TO 2 DO FOR j:=-2 TO 2 DO Pixels[225-i,225-j]:=clLime;
 END;
END;
PROCEDURE ClearScr;
BEGIN WITH Form2 DO WITH Image1 DO WITH Canvas DO WITH Brush DO
 BEGIN Color:=0; Style:=bsSolid;
 FillRect(Rect(0,0,Width,Height));
 END;
END;
PROCEDURE TestAnisoBroad;
VAR i,j,k,dd,d,dc,colc,ia,ib,ig:INTEGER; st:REAL; ia0,ib0,ig0:INTEGER;
LABEL Lbeg;
BEGIN L0rec:='Lattices'; dd:=50; d:=2; dc:=-15; st:=1; WITH aniwbl DO
 BEGIN a:=40; b:=60; gamma:=90; da:=0; db:=0; dgamma:=0;
 END;
Lbeg: MakeFormV(0,20,500,440,0);
s:=' Enter info'; OuttoLabel(Form2.Label5,25,20,clMaroon,clWhite,s);
strgrW[0]:=120; strgrW[1]:=100;
{strgrT[1]:='Asymmetry '; strgrNn[1,1]:=-15;
strgrT[2]:='Width '; strgrNn[2,1]:=2;
PuttoTable(20,40,2,2,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 dc:=Round(har[1]); d:=Round(har[2]);
 END;}
WITH aniwbl DO
 BEGIN ic:=0; strgrT[1]:='A'; strgrNn[1,1]:=a;
 strgrT[2]:='B'; strgrNn[2,1]:=b;
 strgrT[3]:='Gamma'; strgrNn[3,1]:=gamma;
 strgrT[4]:='dA'; strgrNn[4,1]:=da;
 strgrT[5]:='dB'; strgrNn[5,1]:=db;
 strgrT[6]:='dGamma'; strgrNn[6,1]:=dgamma;
 END;
PuttoTable(20,40,6,6,1,8);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:='Use asymmetry';
 END;
MakeCheckListBox(20,200,200,20);
Form2.CheckListBox1.Checked[0]:=false;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 6 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 WITH aniwbl DO
  BEGIN a:=har[1]; b:=har[2]; gamma:=har[3];
  da:=har[4]; db:=har[5]; dgamma:=har[6];
  END;
 assym:=CheckListBox1.Checked[0];
 END;

MakeFormV(0,20,500,440,0); WITH Form2.Image1 DO
 BEGIN Left:=0; Top:=1; Width:=450; Height:=450;
 Visible:=true;
 END;
WITH Form2 DO WITH Image1 DO WITH Canvas DO
 BEGIN Left:=0; Top:=1; Width:=450; Height:=450; ClearScr;
 {WITH Brush DO
  BEGIN Color:=0; Style:=bsSolid;
  FillRect(Rect(0,0,Width,Height));
  END;}
                {Start}
 colc:=clFuchsia; WITH aniwbl DO
  BEGIN ia:=Round(da); ib:=Round(db); ig:=Round(dgamma);
  END;
 FOR i:=1 TO 455 DO FOR j:=1 TO 455 DO arb[i,j]:=0;
 {MakeGraph1(clAqua,0*d,dd,0*d+dc);}
 WITH aniwbl DO MakeGraph2(clAqua,a,b,gamma);
 ia0:=-ia; ib0:=-ib; ig0:=-ig;
 IF(assym)THEN
  BEGIN ia0:=0; ib0:=0; ig0:=0;
  END;
 WITH aniwbl DO
  FOR i:=ia0 TO ia DO FOR j:=ib0 TO ib DO FOR k:=ig0 TO ig DO
   MakeGraph2(clYellow,a+i,b+j,gamma+k);
 {MakeCentr(colc,0*d+dc,dd,0*d+dc,d);}
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;

 {FOR i:=1 TO 455 DO FOR j:=1 TO 455 DO arb[i,j]:=0;
 MakeGraph1(clAqua,d,dd,0*d+dc);
 MakeCentr(colc,0*d+dc,dd,0*d+dc,d);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;

 ClearScr;
 FOR i:=1 TO 455 DO FOR j:=1 TO 455 DO arb[i,j]:=0;
 MakeGraph1(clLime,d,dd,2*d+dc);
 MakeCentr(colc,2*d+dc,dd,2*d+dc,d);
 MakeGraph1(clLime,d,dd,-2*d+dc);
 MakeCentr(colc,2*d+dc,dd,-2*d+dc,d);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 ClearScr;
 FOR i:=1 TO 455 DO FOR j:=1 TO 455 DO arb[i,j]:=0;
 MakeGraph1(clAqua,d,dd,4*d+dc);
 MakeCentr(colc,4*d+dc,dd,4*d+dc,d);
 MakeGraph1(clAqua,d,dd,-4*d+dc);
 MakeCentr(colc,4*d+dc,dd,-4*d+dc,d);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;}
 END;
GOTO Lbeg;
END;
PROCEDURE TestExpon;
{Test small statistics, observ.interval is determin. Jan 9 2004}
VAR i,j,k,N,m,n1,n2,m1,m2,it,kk:INTEGER;
    re1,r1,r2,T1,T2,Q,ex,B,r,lb,T,lc,p,p0,v0,pt,te,ve,v,re,te1,te2:REAL;
    p1,v1,z,s,a3,a2,a1,a0:REAL; ta:ARRAY[1..5] OF REAL;
    are:ARRAY[0..40] OF INTEGER;
 FUNCTION Fun(x,T:REAL):REAL;
 BEGIN Fun:=EXP(-x/T); {Q:=AMAX1(0.000000001,1-ex); Fun:=t-x*ex/Q;}
 END;
{******************************************}
BEGIN  N:=100000; T:=200; B:=20; step:=1;
Writeln(fout,'B_true,T_true ',B:8:0,T:9:0);
r:=1-exp(-B/T); Writeln(fout,'1-e_B ',r:10:5);
r1:=exp(-B/T)-exp(-2*B/T); Writeln(fout,'e_B-e_2B ',r1:10:5);
r2:=r/r1; Writeln(fout,'Ratio= ',r2:10:5);
ex:=B/ln(r2); Writeln(fout,'t_est= ',ex:10:5);
{FOR j:=1 TO 5 DO FOR k:=1 TO 5 DO}
{MakeDistr; MaxLikHood; ShowMess('Done'); Exit;}
kk:=20;  ve:=0; m:=0; p:=0; v:=0;
FOR it:=1 TO kk DO
 BEGIN n1:=0; n2:=0; te:=0; N:=100*it; FOR j:=0 TO 40 DO are[j]:=0;
 FOR j:=1 TO N DO
  BEGIN r:=rndexp(1/T); {event}
  te:=te+EXP(-r/T);
  IF(r<B)THEN
   BEGIN Inc(n1); {p:=p+r; v:=v+r*r;}
   END;
  IF(rinfun(r,B,2*B))THEN
   BEGIN Inc(n2); {p:=p+r; v:=v+r*r;}
   END;
  {p1:=p1+n1; v1:=v1+SQR(n1);}
  IF(rinfun(r,0,2*B))THEN
   BEGIN k:=MIN1(r/step,40); Inc(are[k]);
   END;
  END;
 eps:=0.0001; te1:=0;
 r:=0; IF(n2<>0)THEN r:=Float(n1-n2)/SQRT(AMAX0(1,n2));
 k:=1;{ 1 sigma confidence}
 IF(r>=Float(k))THEN
  BEGIN r2:=1; IF(n2<>0)THEN r2:=Float(n1)/Float(n2);
  te1:=B/(ln(r2)+eps); p:=p+te1; v:=v+SQR(te1); Inc(m);
  END;
 N0:=k*k*Round(SQR(T/B)*(T/B-1)); te:=te/N;
 {IF(te1<>0)THEN te2:=p/(n1+n2)+2*B*exp(-2*B/te1)/(1-exp(-2*B/te1));}
 Writeln(fout,'n1-n2,r_n ',n1:5,n2:5,r:6:2,
 ' Te=',te1:7:2,'     n1+n2 should be > ',N0:5,' ts=',te:6:3);
 END;
IF(m<>0)THEN
 BEGIN p:=p/m; v:=(v-SQR(p))/m;
 END;
Writeln(fout,'Av.Test,sigma,m ',p:9:2,SQRT(ABS(v)):12:2,m:4);
{Writeln(fout,(te/20):9:2,SQRT(ABS((ve/20-SQR(te/20)))):12:2);}
{te1:=2*B/ln(Float(N)/Float(MAX0(1,N-n1-n2)));
Writeln(fout,r:9:0,re:9:2,te1:10:2,' =est');}
ShowMess('Done'); Exit;
END;
PROCEDURE UnixDosZ;
VAR i,j,k,res:INTEGER; bufs:ARRAY[1..512] OF BYTE; s:STRING[72];
BEGIN k:=0; WHILE(NOT Eof(fbyt))DO
 BEGIN BlockRead(fbyt,bufs,512,res);
 FOR i:=1 TO 512 DO buf[k+i]:=bufs[i]; k:=k+res;
 END;
s:=tblank+tblank+tblank; j:=0; FOR i:=1 TO k DO
 BEGIN IF((buf[i]<>10)AND(j<72))THEN
  BEGIN Inc(j); s[j]:=Chr(buf[i]);
  END                           ELSE
  BEGIN Writeln(fo,s); s:=tblank+tblank+tblank; j:=0;
  END;
 END;
END;
PROCEDURE AjustFortran;
VAR   Rdel:BOOLEAN; i:INTEGER;
LABEL Lend;
BEGIN
REPEAT Readln(ft,fn); Rdel:=EoF(ft);
IF((fn=' ')OR(fn=''))THEN CONTINUE;
IF(UpCase(fn[1])='C')THEN GOTO Lend;
s:=Copy(fn,1,5); FOR i:=1 TO 5 DO
 IF(NOT(s[i]IN ['0'..'9',' ']))THEN
   BEGIN fn:='      '+Copy(fn,i,512); GOTO Lend;
   END;
Lend: Writeln(fo,fn);
UNTIL Rdel;
END;
PROCEDURE PurgeNonAscii(VAR k:INTEGER);
VAR ch:CHAR; ok,Rdel:BOOLEAN; cl,i,j,n:INTEGER;
BEGIN k:=0; cl:=0;
REPEAT Readln(ft,fn); Rdel:=EoF(ft); n:=Length(fn); j:=0;
FOR i:=1 TO n DO { Loop }
 BEGIN ch:=fn[i]; IF(ch IN [#0..#31])THEN
  BEGIN fn[i]:=' '; Inc(k);
  END;
 END; {End of string translation}
 REPEAT ok:=true;
 j:=Pos('FC',fn); IF(j<>0)THEN
  BEGIN Delete(fn,j,2); Insert('ue',fn,j); ok:=false; Inc(k);
  END;
 j:=Pos('E4',fn); IF(j<>0)THEN
  BEGIN Delete(fn,j,2); Insert('ae',fn,j); ok:=false; Inc(k);
  END;
 j:=Pos('C4',fn); IF(j<>0)THEN
  BEGIN Delete(fn,j,2); Insert('Ae',fn,j); ok:=false; Inc(k);
  END;
 j:=Pos('D6',fn); IF(j<>0)THEN
  BEGIN Delete(fn,j,2); Insert('Oe',fn,j); ok:=false; Inc(k);
  END;
 j:=Pos('F6',fn); IF(j<>0)THEN
  BEGIN Delete(fn,j,2); Insert('oe',fn,j); ok:=false; Inc(k);
  END;
 j:=Pos('DF',fn); IF(j<>0)THEN
  BEGIN Delete(fn,j,2); Insert('ss',fn,j); ok:=false; Inc(k);
  END;
 j:=Pos('=20',fn); IF(j<>0)THEN
  BEGIN Delete(fn,j,3); Insert(' ',fn,j); ok:=false; Inc(k);
  END;
 UNTIL ok;
Writeln(fo,fn); Inc(cl);
UNTIL Rdel;
END;
PROCEDURE ShowSession(VAR i:INTEGER);
VAR j:INTEGER;
BEGIN L0rec:='    VPATI-2004  Zlokazov V.B.    Session '+IntToStr(nc);
MakeFormV(250,20,330,430,0); s:='Select the session';
OuttoLabel(Form2.Label1,5,10,clMaroon,clWhite,s);
WITH Form2.RadioGroup1 DO
 BEGIN Items.Clear; Columns:=2;
 FOR j:=1 TO 18 DO Items.Add('  Session   '+IntToStr(j+2));
 Left:=20; Top:=30; Width:=300; Height:=340;
 ItemIndex:=3; Visible:=true;
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Application.Terminate;
 i:=RadioGroup1.ItemIndex;
 END;
END;
PROCEDURE ViewResFile;
VAR s:STRING; i:INTEGER;
BEGIN L0rec:=''; MakeFormV(0,0,630,430,0);
MakeMemo(5,610); Form2.Memo1.Clear;
{$I-} Reset(fout); {$I+};
WHILE(NOT EoF(fout))DO
 BEGIN Readln(fout,s); Form2.Memo1.Lines.Add(s);
 END;
Form2.ShowModal;
END;
PROCEDURE TForm2.FormKeyPress(Sender: TObject; VAR Key: Char);
BEGIN IF(Key=#27)THEN Button2Click(Self);
END;
PROCEDURE MaketheTable;
BEGIN strgrW[0]:=140; strgrW[1]:=60;
strgrT[1]:='Save beginning with line '; strgrNn[1,1]:=kpl0;
strgrT[2]:='Save ending with line '; strgrNn[2,1]:=kpl1;
PuttoTable(5,310,2,2,1,8);
END;
PROCEDURE ListTextFile(fn:STRING);
VAR   i,j:INTEGER;
LABEL Lend;
BEGIN kpl0:=1; dkp:=21; AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
L0rec:=''; MakeFormV(0,20,630,430,0);
Make_Memo(Form2.Memo1,0,50); Make_Memo(Form2.Memo2,50,570);
WITH Form2 DO WITH Form2.Memo1 DO
 BEGIN Caption:=''; Clear; ScrollBars:=ssNone; Height:=380;
 Font.Color:=clLime; Brush.Color:=clMaroon;
 END;
WITH Form2 DO WITH Form2.Memo2 DO
 BEGIN Caption:=fn; Clear; ScrollBars:=ssNone; Height:=380;
 Font.Color:=clAqua; Brush.Color:=clBlack;
 MaketheButton(Button5,540,380,70,20,'Page Up');
 MaketheButton(Button8,540,360,70,20,'Page Down');
 MaketheButton(Button7,470,360,70,20,'Home');
 MaketheButton(Button4,470,380,70,20,'Line Up');
 MaketheButton(Button6,5,355,75,20,'Save to A');
 MaketheButton(Button9,81,355,75,20,'Save to E');
 MakePage1;
 ShowModal; IF(ModalRes=0)THEN GOTO Lend;
 END;
Lend: CloseFile(ft); Form2.Memo1.Visible:=false;
Form2.Memo2.Visible:=false;
END;
{*****************************}
PROCEDURE MakePage1;
VAR i,j:INTEGER; s:STRING;
BEGIN kpl1:=kpl0+dkp-1; j:=kpl1; Form2.Memo1.Clear; Form2.Memo2.Clear;
FOR i:=kpl0 TO kpl1 DO
 BEGIN IF(NOT EoF(ft))THEN Readln(ft,s) ELSE s:=' ';
 IF(DosWin)THEN RecodeDtoW(s); ConvertStr(Float(i),5,0);
 {CaretPos.X:=7; SelAttributes.Color:=clAqua;}
 Form2.Memo1.Lines.Add(sedz); Form2.Memo2.Lines.Add(' '+s);
 IF(EoF(ft))THEN j:=MIN0(i,j);
 END;
kpl1:=j; MaketheTable;
END;
PROCEDURE TForm2.Button1Click(Sender: TObject);
BEGIN Close; ModalRes:=1;
END;
PROCEDURE TForm2.Button2Click(Sender: TObject);
BEGIN Close; ModalRes:=0;
END;
PROCEDURE TForm2.Button4Click(Sender: TObject);  {Line Up}
VAR i:INTEGER;
BEGIN WITH Memo1.Lines DO
IF(NOT EoF(ft))THEN Readln(ft,s) ELSE s:=' ';
IF(DosWin)THEN RecodeDtoW(s); IF(NOT EoF(ft))THEN
 BEGIN kpl0:=kpl0+1; kpl1:=kpl1+1; ConvertStr(Float(kpl1),5,0);
 Memo1.Lines.Add(sedz); Memo2.Lines.Add(' '+s);
 END;
WITH Memo1.Lines DO FOR i:=1 TO dkp DO Strings[i-1]:=Strings[i];
WITH Memo2.Lines DO FOR i:=1 TO dkp DO Strings[i-1]:=Strings[i];
Memo1.Lines.Delete(dkp); Memo2.Lines.Delete(dkp); MaketheTable;
END;
PROCEDURE TForm2.Button5Click(Sender: TObject);  {PgUp}
VAR i,j:INTEGER; s:STRING;
BEGIN IF(EoF(ft))THEN Exit; Memo1.Clear; Memo2.Clear;
i:=0; j:=dkp; kpl0:=kpl1+1; WHILE(i<dkp)DO
 BEGIN IF(NOT EoF(ft))THEN Readln(ft,s) ELSE s:=' ';
 IF(DosWin)THEN RecodeDtoW(s); ConvertStr(Float(i+kpl0),5,0);
 Memo1.Lines.Add(sedz); Memo2.Lines.Add(' '+s);
 Inc(i); IF(EoF(ft))THEN j:=MIN0(j,i);
 END;
kpl1:=kpl0+j-1; MaketheTable;
END;
PROCEDURE MakeSaving(ae:BOOLEAN);
VAR i:INTEGER;
BEGIN FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
lsave1:=Round(har[1]); lsave2:=Round(har[2]);
IF(lsave1=0)THEN lsave1:=kpl0; IF(lsave2=0)THEN lsave1:=kpl1;
Reset(ft); FOR i:=1 TO lsave1-1 DO Readln(ft,s);
IF(ae)THEN
 BEGIN AssignFile(fo,'a.sav'); Rewrite(fo);
 END;
FOR i:=1 TO lsave2-lsave1+1 DO
 BEGIN Readln(ft,s); IF(ae)THEN Writeln(fo,s) ELSE Writeln(fout,s);
 END;
IF(ae)THEN CloseFile(fo);
Reset(ft); FOR i:=1 TO kpl0-1 DO Readln(ft,s); MakePage1;
END;
PROCEDURE TForm2.Button6Click(Sender: TObject); {Save to A.SAV}
BEGIN MakeSaving(true);
END;
PROCEDURE TForm2.Button7Click(Sender: TObject);  {Home}
BEGIN DosWin:=true; Reset(ft); kpl0:=1; Memo1.Clear; Memo2.Clear;
MakePage1;
END;
PROCEDURE TForm2.Button8Click(Sender: TObject);  {PgDown}
VAR i:INTEGER;
BEGIN Memo1.Clear; Memo2.Clear; Reset(ft); kpl0:=MAX0(kpl0-dkp,1);
FOR i:=1 TO kpl0-1 DO Readln(ft,s); MakePage1;
END;
PROCEDURE TForm2.Button9Click(Sender: TObject);  {Save to E.RES}
BEGIN MakeSaving(false);
END;

PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
BEGIN WITH Form2 DO
 BEGIN Close; Left:=exs(ix); Top:=exs(20); Width:=exs(iw);
 Height:=exs(ih); Caption:=''; Color:=clGreen; Caption:='';
 Label1.Visible:=false; Label2.Visible:=false;
 Label3.Visible:=false; Label4.Visible:=false;
 Label5.Visible:=false; Label6.Visible:=false;
 Button1.Visible:=false; Button2.Visible:=false;
 Button3.Visible:=false; Button4.Visible:=false;
 Button5.Visible:=false; Button6.Visible:=false;
 Button7.Visible:=false; Button8.Visible:=false;
 Button9.Visible:=false;
 ComboBox1.Visible:=false; ComboBox2.Visible:=false;
 Edit1.Visible:=false; Edit2.Visible:=false;
 Edit3.Visible:=false; Edit4.Visible:=false;
 CheckListBox1.Visible:=false;
 StringGrid1.Visible:=false; StringGrid2.Visible:=false;
 RadioGroup1.Visible:=false;
 ListBox1.Visible:=false;
 Memo1.Visible:=false; Memo2.Visible:=false;
 Image1.Visible:=false;
 ModalRes:=1;
 END;
END;
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
{mo=0 - file name for reading
    1 - file name for writing
    2 - get a string }
VAR   s:STRING; i:INTEGER;
LABEL L1;
BEGIN s:=fn; IF(mo>=1)THEN GOTO L1;     {Read}
fn:=ExtractFileName(s); i:=Pos(s,fn); IF(i<>0)THEN Delete(s,i,100);
ModalRes:=1; WITH Form2.OpenDialog1 DO
 BEGIN Title:=L0rec; FileName:=fn; InitialDir:=s;
 Options:=Options-[ofAllowMultiSelect];
 IF(Execute)THEN s:=FileName
            ELSE
  BEGIN ModalRes:=0; Exit;
  END;
 Compress(s);
 IF(NOT FileExists(s))THEN
  BEGIN ShowMess('No file '+s); ModalRes:=0;
  END                 ELSE fn:=s;
 END;
Exit;
L1: MakeFormV(250,20,330,430,0); {Write}
OuttoLabel(Form2.Label1,5,30,clMaroon,clWhite,L1rec);
MakeEdit(Form2.Edit1,30,50,260,fn);
Form2.ShowModal; IF(ModalRes=0)THEN Exit; fn:=Form2.Edit1.Text;
IF(mo=2)THEN Exit;               {String}
Compress(fn); ExtractFN(fn,sedz); IF(Length(sedz)=0)THEN
 BEGIN ShowMess('Empty string'); ModalRes:=0;
 END;
IF((mo=1)AND(FileExists(fn)))THEN
 BEGIN s:='File '+fn+' already exists. Overwrite?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN ModalRes:=0;
 END;
END;
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
VAR i:INTEGER;
BEGIN IF(bm=1)THEN ListBsav:=false; ActivateForm2(x,w,h);
{L0rec->}MakeHeader(0); Form2.KeyPreview:=true;
i:=(w DIV 2)-90; IF(bm=1)THEN i:=i-30; MaketheButtons(i,375,60);
IF(bm=1)THEN WITH Form2.Button6 DO
 BEGIN Left:=exs(i+180+5); Top:=exs(375); Width:=exs(60);
 Height:=exs(20); Visible:=true;
 END;
END;
PROCEDURE MakeForm(xhead:INTEGER);
BEGIN MakeFormV(250,20,320,430,0);
END;
PROCEDURE MakeHeader(cl:LONGINT);
VAR i:INTEGER;
BEGIN WITH Form2.Font DO
 BEGIN Color:=cl; Style:=[fsBold]; Pitch:=fpFixed; Size:=fntsize;
 s:=''; FOR i:=1 TO 10 DO s:=s+' '; Form2.Caption:=s+L0rec;
 END;
END;
PROCEDURE MakeMemo(x,w:INTEGER);
BEGIN Make_Memo(Form2.Memo1,x,w);
END;
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
BEGIN
MakeStringGrid(Form2.StringGrid1,Form2.StringGrid2,x,t,nf,n,mm,ndig);
END;
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
BEGIN IF(ng=1)THEN BuildRG(Form2.RadioGroup1,m,x,y,w,h)
              ELSE {BuildRG(Form2.RadioGroup2,m,x,y,w,h)};
END;
PROCEDURE MakeEdits(x1,x2,y,w,n:INTEGER);
BEGIN WITH Form2 DO
 BEGIN OuttoLabel(Label1,x1,y,clMaroon,clWhite,L1rec);
 MakeEdit(Edit1,x2,y-2,w,E1rec); IF(n<2)THEN Exit;
 OuttoLabel(Label2,x1,y+23,clMaroon,clWhite,L2rec);
 MakeEdit(Edit2,x2,y+21,w,E2rec); IF(n<3)THEN Exit;
 OuttoLabel(Label3,x1,y+46,clMaroon,clWhite,L3rec);
 MakeEdit(Edit3,x2,y+44,w,E3rec); IF(n<4)THEN Exit;
 OuttoLabel(Label4,x1,y+69,clMaroon,clWhite,L4rec);
 MakeEdit(Edit4,x2,y+67,w,E4rec);
 END;
END;
PROCEDURE MaketheButtons(x,y,w:INTEGER);
BEGIN WITH Form2 DO
 BEGIN MaketheButton(Button1,x,y,w,20,'OK');
 MaketheButton(Button2,x+w+2,y,w,20,'Cancel');
 MaketheButton(Button3,x+2*w+4,y,w,20,'Help');
 END;
END;
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_ListBox(Form2.ListBox1,ix,it,iw,ih);
END;
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_CheckListBox(Form2.CheckListBox1,ix,it,iw,ih);
END;

{*****************************************}
PROCEDURE MemoERes;
VAR i:INTEGER; s:STRING;
BEGIN L0rec:=''; MakeFormV(0,20,630,430,0);
MakeMemo(5,590); {$I-} Reset(fout); {$I+};
WHILE(NoT EoF(fout))DO WITH Form2 DO
 BEGIN Readln(fout,s); Memo1.Lines.Add(s);
 END;
Form2.ShowModal;
END;
PROCEDURE CheckGens;
{Check whether the random generator is homogeneous}
VAR i,j:INTEGER; k,ic,li,lj:LONGINT;
BEGIN MakeFormV(0,0,630,430,0); z_r:=1;
WITH Form2.Image1 DO
 BEGIN Left:=5; Top:=1; Width:=261; Height:=320; Visible:=true;
 WITH Canvas DO
  BEGIN Pen.Style:=psSolid; Font.Color:=clWhite; Brush.Color:=clGreen;
  Font.Style:=[fsBold]; Font.Size:=8;
  END;
 END;
ic:=0; k:=10000;
REPEAT WITH Form2.Image1.Canvas DO
 BEGIN Brush.Color:=0; Brush.Style:=bsSolid;
 FillRect(Rect(0,0,256,256));
 FOR i:=1 TO k DO
  BEGIN li:=Round(rndm(-1)*256); lj:=Round(rndm(-1)*256); Inc(ic);
  Pixels[li,lj]:=clFuchsia; {Writeln(fout,li:5,lj:5);}
  END;
 TextOut(0,305,IntToStr(2*ic)+' points');
 END;
Form2.ShowModal;
UNTIL ModalRes=0;
END;
PROCEDURE ExcelToNFile;
{Transform aspect-files to normal ones}
VAR  i,j,k,kk,i1:INTEGER; s:STRING; first:BOOLEAN;
BEGIN fn1:='.xls'; fn2:='.asp';
GetFilename(fn,0);
s:=ChangeFileExt(fn,'.asp'); ShowMess(fn+'   '+s);
{FOR k:=1 TO 85 DO }
 BEGIN {fn:='\zlok\arch\aspect\'+IntToStr(7829+k);} first:=true;
 AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
 ok:=(IOresult=0); IF NOT ok THEN
  BEGIN Writeln(fout,'Wrong file '+fn); Exit;
  END;
 AssignFile(fo,s); {$I-} Rewrite(fo); {$I+};
 WHILE(NOT EoF(ft))DO
  BEGIN Readln(ft,s); i:=1;
  REPEAT ok:=false; IF(s[i] IN alnums)THEN ok:=true;
  IF(NOT ok)THEN Delete(s,i,1) ELSE Inc(i);
  UNTIL ((i>=Length(s))OR(Length(s)<=0));
  FOR i:=1 TO Length(s) DO IF(s[i]=';')THEN s[i]:=',';
  fffins(kk,s); IF(first)THEN i1:=7 ELSE i1:=5; FOR i:=i1 TO i1 DO
   BEGIN IF(onl[i]>4000)THEN onl[i]:=0; Write(fo,onl[i]:6:0);
   END;
  Writeln(fo); first:=false;
  END;
 CloseFile(ft); CloseFile(fo);
 END;
END;
PROCEDURE GetLowerLimit(VAR T:REAL; B:REAL; N:INTEGER);
VAR i:INTEGER; r,B0,zx,z,mx,ff:REAL;
BEGIN mx:=1E16; FOR i:=1 TO 1000 DO
 BEGIN z:=i*0.001; ff:=N*powerRI(1-z,3)-z; IF(ff<0)THEN BREAK;
 IF((ff>0)AND(ff<mx))THEN
  BEGIN mx:=ff; zx:=z;
  END;
 END;
{GetRealRootCubic(a3,a2,a1,a0,mx);}
B0:=-T*ln(zx); T:=0; IF(zx>0)THEN T:=-B/ln(zx);
END;
PROCEDURE ArithGau(VAR y,w,f:REAL; i,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
    f  = a*exp(-(x/w)^2)
 computes function value + 1-st derivatives, May 11 1999}
VAR ff,fz,x2,wi,wi1,x,z,si,am,ba:REAL; ia,ip,iw,j,k:INTEGER;
BEGIN y:=onl[i]; w:=1/(y+0.001); ia:=3;
WITH testgfit DO WITH tgd DO
 BEGIN ip:=ia+np; iw:=ip+np; x:=i; f:=0; k:=np;
 x2:=(2*x-(1+mp))/((mp-1));
 ba:=par[1].p+par[2].p*x2+par[3].p*(2*x2*x2-1);
 par[1].drv:=1; par[2].drv:=x2; par[3].drv:=2*x2*x2-1;
 wi:=0; wi1:=0; si:=par[iw+1].p+par[iw+2].p*x2; IF(si=0)THEN si:=0.1;
 FOR j:=1 TO k DO
  BEGIN z:=(x-par[ip+j].p)/si; pmod[1].Getffzfzz(z,ff,fz,fzz);
  am:=par[ia+j].p;
  CASE mofit OF
  0: BEGIN f:=f+ff*am;
     par[ia+j].drv:=ff;
     par[ip+j].drv:=-am*fz/si;
     wi:=wi-am*fz*z/si;
     wi1:=wi1-am*fz*z*x2/si;
     END;
  1: BEGIN f:=f+ff*am/si;
     par[ia+j].drv:=ff/si;
     par[ip+j].drv:=-am*fz/SQR(si);
     wi:=wi-am*(ff+fz*z)/SQR(si);
     wi1:=wi1-am*(ff+fz*z*x2)/SQR(si);
     END;
  ELSE END;
  par[iw+1].drv:=wi;
  par[iw+2].drv:=wi1;
  END;
 f:=f+ba;
 END;
END;
PROCEDURE GetDict(separ:CHAR; VAR ndic:INTEGER; ch:CHAR);
{Version 1992, DELPHI 2005; ch: 2= R -> E, 1= E -> R
 In file fn should be opend}
VAR   i,j:INTEGER;
LABEL Lend,Lout;
BEGIN IF(ch='1')THEN  {Skip the Russian-English part}
 WHILE NOT EoF(fad) DO
  BEGIN Readln(fad,fn); IF(fn='* END *')THEN GOTO Lout;
  END;
Lout: Readln(fad); ndic:=0; WHILE NOT EoF(fad) DO
 BEGIN Readln(fad,fn); IF(fn='* END *')THEN GOTO Lend;
 i:=Pos(separ,fn); IF((i=0)AND(Length(fn)>2))THEN
  ShowMess('Error, incorrect line '+fn);
 IF((i<>0)AND(fn[1]<>'*'))THEN
  BEGIN IF(ndic<1100)THEN Inc(ndic)
                     ELSE ShowMess('Error,dictionary larger than 1100');
  s:=Copy(fn,1,i-1); WITH dicRE[ndic] DO IF(ch='1')THEN
   BEGIN eng:=s; rus:=Copy(fn,i+1,Length(fn)-i);
   END                                               ELSE
    BEGIN eng:=Copy(fn,i+1,Length(fn)-i); rus:=s;
    END;
  END;
 END;
Lend: Close(fad);
{Arrange for word length decreasing}
IF(ch='1')THEN FOR i:=1 TO ndic-1 DO FOR j:=1 TO ndic-1 DO
 IF(Length(dicRE[j].eng)<Length(dicRE[j+1].eng))THEN
  BEGIN ExchangeStr(dicRE[j].eng,dicRE[j+1].eng);
  ExchangeStr(dicRE[j].rus,dicRE[j+1].rus);
  END;
IF(ch='2')THEN FOR i:=1 TO ndic-1 DO FOR j:=1 TO ndic-1 DO
 IF(Length(dicRE[j].rus)<Length(dicRE[j+1].rus))THEN
  BEGIN ExchangeStr(dicRE[j].eng,dicRE[j+1].eng);
  ExchangeStr(dicRE[j].rus,dicRE[j+1].rus);
  END;
ShowMess('Dictionary arranged, '+IntToStr(ndic)+' items');
END;
PROCEDURE SearchFiles(CONST sh,dir1,dir2:STRING);
CONST serr:STRING = 'Error! Can''t write the file.';
VAR   ii,i,j,k,age:INTEGER; s,ss,st:STRING; ok:BOOLEAN; b,d1,d2:REAL;
      buf1,buf2:ARRAY[1..8192] OF BYTE;
LABEL Lend,Lend1;
BEGIN ss:=dir1+sh; st:=dir2+sh; nfs:=0; nft:=0;
L0rec:=''; MakeFormV(150,20,430,430,0);
L1rec:=' Full Mask from'; E1rec:=ss; L2rec:=' Full Mask to'; E2rec:=st;
MakeEdits(5,100,250,220,2);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 ss:=Edit1.Text; st:=Edit2.Text;
 END;
IF(FindFirst(ss,faArchive,SR)=0)THEN
 REPEAT b:=FileDateToDateTime(SR.time);
 IF(rinfun(b,t1,t2))THEN
  BEGIN Inc(nfs); WITH fns[nfs] DO
   BEGIN name:=SR.Name; time:=SR.Time; size:=SR.Size; UpCaseStr(name);
   j:=Pos('.',name); IF((j<>0)AND(Copy(name,j,3)='EXE'))THEN Dec(nfs);
   END;
  END;
 UNTIL FindNext(SR)<>0;
FindClose(SR);
IF(FindFirst(st,faArchive,SR)=0)THEN
 REPEAT Inc(nft); WITH fnt[nft] DO
  BEGIN name:=SR.Name; time:=SR.Time; size:=SR.Size; UpCaseStr(name);
  END;
 UNTIL FindNext(SR)<>0;
FindClose(SR);
kf:=0; FOR i:=1 TO nfs DO
 BEGIN FOR j:=1 TO nft DO IF(fns[i].name=fnt[j].name)THEN
  BEGIN IF(fnt[j].time<fns[i].time)THEN
   BEGIN Inc(kf); fns[kf]:=fns[i]; ok:=DeleteFile(st);
   fns[kf].sold:=fnt[j].size; GOTO Lend;
   END                             ELSE GOTO Lend;
  END;
 Inc(kf); fns[kf]:=fns[i]; fns[kf].sold:=0; Lend:;
 END;
{Update}FOR i:=1 TO kf DO WITH fns[i] DO
 BEGIN ss:=dir1+name; st:=dir2+name; ok:=true;
 age:=FileAge(ss); count:=8192; hands:=FileOpen(ss,$0000{read});
 s:=tblank+tblank; s:=s+s; WITH fns[i] DO
  BEGIN Insert(name,s,1); Insert(IntToStr(size),s,16);
  Insert(' -> ',s,24);
  IF(sold<>0)THEN Insert(IntToStr(sold),s,29); Insert(dir2,s,38);
  END;
 handt:=FileCreate(st);
 REPEAT resread:=FileRead(hands,buf,count); IF(resread=0)THEN BREAK;
 reswrit:=FileWrite(handt,buf,resread);
 IF(resread<>reswrit)THEN
  BEGIN ii:=MessageDlg(serr+st,MtWarning,[mbYes,mbAbort],0);
  s:='File '+st+' not copied'; IF(ii=mrAbort)THEN ok:=false;
  Dec(nft); GOTO Lend1;
  END;
 UNTIL (resread=0);
 k:=FileSetDate(handt,age); FileClose(handt);
 {Verify} handt:=FileOpen(st,$0000); k:=FileSeek(hands,0,0);
 REPEAT count:=8192; resread1:=FileRead(hands,buf1,count);
 resread2:=FileRead(handt,buf2,count); IF(resread1=0)THEN BREAK;
 FOR j:=1 TO resread1 DO
  IF((buf1[j]<>buf2[j])OR(resread1<>resread2))THEN
   BEGIN ii:=MessageDlg(st+' verifying failure',MtWarning,
    [mbYes,mbAbort],0); s:='File '+st+' not copied';
   IF(ii=mrAbort)THEN ok:=false; Dec(nft); GOTO Lend1;
   END;
 UNTIL (resread1=0);
 Lend1:Inc(klist); LB1rec.ar[klist+2]:=s; Writeln(fout,s);
 FileClose(hands); FileClose(handt); IF(NOT ok)THEN Exit;
 END;
END;
PROCEDURE TranslateEngRus(VAR cl:INTEGER);
VAR ch:CHAR; Rdel:BOOLEAN; i,j,k,jj,lw,ndic:INTEGER; s0,s1,s2,s3:STRING;
BEGIN IF(RE)THEN ch:='2' ELSE ch:='1';
AssignFile(fad,'c:\zlok\traff.dic'); {$I-} Reset(fad); {$I+};
GetDict('=',ndic,ch); cl:=1; k:=0;
REPEAT Readln(ft,fn); Rdel:=EoF(ft); i:=Length(fn); j:=0;
FCompress(fn); fn:=' '+fn+' ';
FOR i:=1 TO ndic DO { Loop }
 BEGIN s2:=dicRE[i].rus; lw:=Length(s2); s0:=dicRE[i].eng;
 jj:=Length(s0); IF(jj>=1)THEN s1:=Chr(Ord(s0[1])-32)+Copy(s0,2,jj-1);
 IF(lw>=1)THEN s3:=UpCaze(s2[1])+Copy(s2,2,lw-1);
 s1:=' '+s1+' '; s0:=' '+s0+' ';
 FOR jj:=1 TO 2 DO
 IF(ch='2')THEN  { R  -> E}
  BEGIN k:=Pos(s2,fn); IF(k<>0)THEN
   BEGIN Delete(fn,k,lw); Insert(s0,fn,k);
   END;
  k:=Pos(s3,fn); IF(k<>0)THEN
   BEGIN Delete(fn,k,lw); Insert(s1,fn,k);
   END;
  END      ELSE  { E -> R }
  BEGIN {check for article + low case}
  k:=Pos(' a '+s0,fn); IF(k<>0)THEN
   BEGIN Delete(fn,k,jj+3); Insert(s2,fn,k);
   END;
  k:=Pos(' the '+s0,fn); IF(k<>0)THEN
   BEGIN Delete(fn,k,jj+5); Insert(s2,fn,k);
   END;
  k:=Pos(s1,fn); IF(k<>0)THEN {check for upper case}
   BEGIN Delete(fn,k,jj); Insert(s3,fn,k);
   END;
  k:=Pos('A '+s0,fn); IF(k<>0)THEN
   BEGIN Delete(fn,k,jj+2); Insert(s3,fn,k);
   END;
  k:=Pos('The '+s0,fn); IF(k<>0)THEN
   BEGIN Delete(fn,k,jj+4); Insert(s3,fn,k);
   END;
  k:=Pos(s0,fn); IF(k<>0)THEN {check for low case}
   BEGIN Delete(fn,k,jj); Insert(s2,fn,k);
   END;
  END;
 END; {End of string translation}
j:=Length(fn); FOR i:=1 TO j DO {Clean russian characters if R -> E}
IF(((Ord(fn[i]) IN [128..175])OR(Ord(fn[i]) IN [224..239]))
AND(ch='2'))THEN fn[i]:=' ';
WHILE (Pos('  ',fn)<>0) DO
 BEGIN i:=Pos('  ',fn); Delete(fn,i,1);
 END;
FCompress(fn); Writeln(fo,fn); Inc(cl);
UNTIL Rdel;
{Compress}{ComprFile(cl);}
END;
PROCEDURE InsertString(VAR k:INTEGER);
VAR mo,ip,l:INTEGER;
BEGIN L0rec:=''; MakeFormV(250,20,330,430,0);
{s:=; OuttoLabel(Form2.Label5,5,,clMaroon,clWhite,s);}
WITH CB1rec DO
 BEGIN nitems:=4; indx:=1;
 ar[1]:='Insert between lines';
 ar[2]:='Insert in line';
 ar[3]:='Overwrite in line';
 ar[4]:='Add to line';
 END;
MakeRadioGroup(1,0,20,10,270,100);
L1rec:='String to be inserted'; E1rec:='';
L2rec:='Position '; E2rec:='1';
MakeEdits(10,130,150,180,2);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 mo:=RadioGroup1.ItemIndex;
 sword:=Edit1.Text; Zval(Edit2.Text,r); ip:=Round(r);
 END;
l:=Length(sword); k:=0;
WHILE NOT EoF(ft) DO
 BEGIN Readln(ft,s); Inc(k);
 CASE mo OF
 0: BEGIN Writeln(fo,s); Writeln(fo,sword);
    END;
 1: BEGIN IF(ip<=(Length(s)-l+1))THEN Insert(sword,s,ip); Writeln(fo,s);
    END;
 2: BEGIN IF(ip<=(Length(s)-l+1))THEN
     BEGIN Delete(s,ip,l); Insert(sword,s,ip);
     END;
    Writeln(fo,s);
    END;
 3: BEGIN s:=s+sword; Writeln(fo,s);
    END;
 ELSE END;
 END;
END;
PROCEDURE EditTextFile;
VAR   i,j,k:INTEGER;
LABEL Lend, Wait;
 PROCEDURE Finish;
 BEGIN Form2.Memo1.Visible:=false; Form2.Memo2.Visible:=false;
 END;
BEGIN k:=1; fn:='a.sav'; AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
L0rec:=''; MakeFormV(0,20,630,430,0);
WITH Form2 DO
 BEGIN Make_Memo(Memo1,0,50); Make_Memo(Memo2,50,570); Caption:=fn;
 END;
WITH Form2.Memo1 DO
 BEGIN  Clear; ScrollBars:=ssNone;
 Font.Color:=clAqua; Brush.Color:=clBlack;
 END;
WITH Form2.Memo2 DO
 BEGIN  Clear; ScrollBars:=ssVertical;
 Font.Color:=clAqua; Brush.Color:=clBlack;
 END;
WHILE(NOT EoF(ft))DO WITH Form2.Memo2 DO
 BEGIN Readln(ft,s); {IF(DosWin)THEN} RecodeDtoW(s);
 ConvertStr(Float(i),5,0);
 {CaretPos.X:=7; SelAttributes.Color:=clAqua;}
 {Form2.Memo1.Lines.Add(sedz);} Lines.Add(s); Inc(k);
 IF(k>512)THEN BREAK;
 END;
 {Memo2.Lines.LoadFromFile(fn);  }
CloseFile(ft);
Wait:
Form2.ShowModal; IF(ModalRes=0)THEN GOTO Lend;
{Save with WIN to DOS} {Form2.Memo2.Lines.SaveToFile(fn);}
Finish; Exit;
Lend:
 i:=MessageDlg('Text unsaved. Still quit?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrNo)THEN GOTO Wait; Finish;
END;
PROCEDURE TestWidthFitting;
{Purpose: to test various width parameters fitting Version: Dec 24 2004}
VAR n:INTEGER; cmax,b,ass,chi:REAL; i:INTEGER;
 PROCEDURE mparam(i,l:INTEGER; v,vl,vu:REAL);
 BEGIN WITH testgfit.par[i] DO
  BEGIN p:=v; pl:=vl; pu:=vu;  IF(l=0)THEN
   BEGIN pl:=v; pu:=v;
   END;
  END;
 END;
 PROCEDURE MakeData;
 VAR i:INTEGER; y,w,ff:REAL;
 BEGIN WITH testgfit DO WITH tgd DO
  BEGIN FormParameters;
  mparam(1,l0,b0,-100000000000,1000000000000);
  mparam(2,l1,b1,-100000000000,100000000000);
  mparam(3,l2,b2,-1000000,1000000);
  FOR i:=1 TO np DO
   BEGIN mparam(i+3,1,amp,0,1E8); mparam(i+3+np,1,pos+(i-1)*dpos,1,150);
   END;
  mparam(3+2*np+1,1,w0,1,10); mparam(3+2*np+2,lw1,w1,-1000,10000);
  FOR i:=1 TO mp DO
   BEGIN ArithGau(y,w,ff,i,1);
   onl[i]:=AMAX1(0,ff+lnois*SIGN(Random-0.5)*2*SQRT(ff)/SQRT(12));
   END;
  par[1].p:=b0/2; par[2].p:=0; par[2*np+5].p:=0;
  r:=1; FOR i:=1 TO np DO
   BEGIN par[i+3].p:=amp+r*amp/5;
   par[i+np+3].p:=par[i+np+3].p-r*1; r:=r*(-1);
   END;
  END;
 WITH testgfit DO FOR i:=1 TO npar DO pold[i]:=par[i].p;
 END;
{---------------------}
BEGIN WITH tgd DO
 BEGIN np:=1; {Number of peaks}
 mp:=61; {Number of points}
 lnois:=0; {noise}
 n:=3+np*2+2; testgfit:=TParameter.Create(n,n,mp);
 b0:=0; b1:=0; b2:=0;
 l0:=0; l1:=0; l2:=0; lw1:=0;
 amp:=100; pos:=25; dpos:=3; w0:=4; w1:=0;
 Writeln(fout,' peaks  points  background ass');
 Writeln(fout,np:6,mp:6,b0:8:0);
 END;
WITH pmod[1] DO
 BEGIN typ:=1; makesm;
 END;
WITH testgfit DO
 BEGIN FormCB; n:=npar; WITH cb DO
  BEGIN gnit:=13; eps:=0.1; ipr:=0; step:=0.9999; damp:=0.01;
  {dbg.drv:=true;} dbg.corr:=true;
  END;
 tgd.mofit:=0; MakeData;
 PrintParArray;
 LeastSquaresFit(ArithGau,TestRegul);
 prifch; {Fitting characteristics}
 chi:=0; FOR i:=1 TO n DO
  chi:=chi+ABS(pold[i]-par[i].p)/AMAX1(0.001,pold[i]);
 chi:=chi/n; Writeln(fout,'Par-diff=',chi:8:2);
 cmax:=0; lsmprn(ArithGau,cmax); {graph; if cmax=0, set automat.}
 primat; {Correlation coefficients}

 tgd.mofit:=1; tgd.amp:=400; MakeData;
 LeastSquaresFit(ArithGau,TestRegul);
 prifch; {Fitting characteristics}
 chi:=0; FOR i:=1 TO n DO
  chi:=chi+ABS(pold[i]-par[i].p)/AMAX1(0.001,pold[i]);
 chi:=chi/n; Writeln(fout,'Par-diff=',chi:8:2);
 cmax:=0; lsmprn(ArithGau,cmax); {graph; if cmax=0, set automat.}
 primat; {Correlation coefficients}
 END;
{results in FOUT}
testgfit.Free;
END;

PROCEDURE TForm2.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR i,j,h,k:INTEGER; s:STRING; d:REAL;
BEGIN {ShowMess(IntToStr(x)+'  '+IntToStr(y));} Inc(aniwbl.ic);
WITH Form2.Image1.Canvas DO
 BEGIN s:=' X,Y = '+IntToStr(x)+'  '+IntToStr(y);
 OuttoLabel(Form2.Label1,370,3,clMaroon,clWhite,s);
 s:=' h  k        d';
 OuttoLabel(Form2.Label2,370,20,clMaroon,clWhite,s);
 WITH aniwbl DO WITH Form2.Image1.Canvas DO
  BEGIN h:=Round((x-225)/b); k:=Round((y-225)/a);
  d:=SQR(Round((x-225)/b))+SQR(Round((y-225)/a));
  IF(d<>0)THEN d:=1/SQRT(d);
  Pen.Style:=psSolid; Pen.Color:=clWhite;
  FOR i:=-2 TO 2 DO FOR j:=-2 TO 2 DO
   Pixels[h*Round(b)+225+i,k*Round(a)+225+j]:=clFuchsia;
  END;
 ConvertStr(d,7,4); s:=IntToStr(h)+' '+IntToStr(k)+' '+sedz;
 {OuttoLabel(Form2.Label2,370,40+aniwbl.ic*20,clMaroon,clWhite,s);}
 WITH LB1rec DO WITH aniwbl DO
  BEGIN nitems:=ic; ar[ic]:=s;
  END;
 MakeListBox(370,40,120,365); {Form2.ShowModal; ***}
 END;
END;

END.
